      subroutine cdftmm(nreal,ninteger,nconts,ncontp,ncontd,ncds,ncdspd,
     &                  nshels,nshelp,nsheld,mtloca,iprimvc,nprimvc,
     &                  icentvc,icdlfunc,icdcfunc,iwkvec,coord,alpha,
     &                  coeff,alphacd,coefscd,coefpcd,coefdcd,tvector,
     &                  density,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension g(7)

      dimension nshels(*),nshelp(*),nsheld(*),mtloca(*),iprimvc(*),
     &          nprimvc(*),icentvc(*),icdlfunc(*),icdcfunc(*),iwkvec(*)

      dimension coord(3,*),alpha(*),coeff(*),alphacd(*),coefscd(*),
     &          coefpcd(*),coefdcd(*),tvector(*),density(*),wkvec(*)

      data zero,three/0.0,3.0/

      sqrt3=sqrt(three)

      ndim=ncds+10*ncdspd

      do 1001 i=1,ndim
 1001 tvector(i)=zero

      do 1002 i=1,ncontd
      do 1002 j=1,nconts

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshels(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3

 1002 continue

      do 1003 i=1,ncontd
      do 1003 j=1,ncontp

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nshelp(j))
      i4=i2+i3

      density(i4)=density(i4)/sqrt3
      density(i4+1)=density(i4+1)/sqrt3
      density(i4+2)=density(i4+2)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/sqrt3
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/sqrt3
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3

 1003 continue

      do 1004 i=1,ncontd
      do 1004 j=1,i

      i1=mtloca(nsheld(i))
      i2=(i1*(i1-1))/2
      i3=mtloca(nsheld(j))
      i4=i2+i3

      density(i4)=density(i4)/three
      if(i.ne.j) density(i4+1)=density(i4+1)/sqrt3
      if(i.ne.j) density(i4+2)=density(i4+2)/sqrt3
      if(i.ne.j) density(i4+3)=density(i4+3)/three
      if(i.ne.j) density(i4+4)=density(i4+4)/sqrt3
      if(i.ne.j) density(i4+5)=density(i4+5)/three

      density(i4+i1)=density(i4+i1)/sqrt3
      if(i.ne.j) density(i4+i1+3)=density(i4+i1+3)/sqrt3
      if(i.ne.j) density(i4+i1+5)=density(i4+i1+5)/sqrt3

      density(i4+i1*2+1)=density(i4+i1*2+1)/sqrt3
      if(i.ne.j) density(i4+i1*2+4)=density(i4+i1*2+4)/sqrt3
      if(i.ne.j) density(i4+i1*2+6)=density(i4+i1*2+6)/sqrt3

      density(i4+i1*3+3)=density(i4+i1*3+3)/three
      density(i4+i1*3+4)=density(i4+i1*3+4)/sqrt3
      density(i4+i1*3+5)=density(i4+i1*3+5)/sqrt3
      density(i4+i1*3+6)=density(i4+i1*3+6)/three
      if(i.ne.j) density(i4+i1*3+7)=density(i4+i1*3+7)/sqrt3
      if(i.ne.j) density(i4+i1*3+8)=density(i4+i1*3+8)/three

      density(i4+i1*4+6)=density(i4+i1*4+6)/sqrt3
      density(i4+i1*4+9)=density(i4+i1*4+9)/sqrt3
      if(i.ne.j) density(i4+i1*4+11)=density(i4+i1*4+11)/sqrt3

      density(i4+i1*5+10)=density(i4+i1*5+10)/three
      density(i4+i1*5+11)=density(i4+i1*5+11)/sqrt3
      density(i4+i1*5+12)=density(i4+i1*5+12)/sqrt3
      density(i4+i1*5+13)=density(i4+i1*5+13)/three
      density(i4+i1*5+14)=density(i4+i1*5+14)/sqrt3
      density(i4+i1*5+15)=density(i4+i1*5+15)/three

 1004 continue

      ncposs=nconts*(nconts+1)/2
      ncpopp=ncontp*(ncontp+1)/2
      ncpodd=ncontd*(ncontd+1)/2

      ncpops=ncontp*nconts
      ncpods=ncontd*nconts
      ncpodp=ncontd*ncontp

      npposs=0
      nppops=0
      nppopp=0
      nppods=0
      nppodp=0
      nppodd=0

      do 1005 i=1,nconts
      do 1005 j=1,i
 1005 npposs=npposs+nprimvc(nshels(i))*nprimvc(nshels(j))

      do 1006 i=1,ncontp
      do 1006 j=1,nconts
 1006 nppops=nppops+nprimvc(nshelp(i))*nprimvc(nshels(j))

      do 1007 i=1,ncontp
      do 1007 j=1,i
 1007 nppopp=nppopp+nprimvc(nshelp(i))*nprimvc(nshelp(j))

      do 1008 i=1,ncontd
      do 1008 j=1,nconts
 1008 nppods=nppods+nprimvc(nsheld(i))*nprimvc(nshels(j))

      do 1009 i=1,ncontd
      do 1009 j=1,ncontp
 1009 nppodp=nppodp+nprimvc(nsheld(i))*nprimvc(nshelp(j))

      do 1010 i=1,ncontd
      do 1010 j=1,i
 1010 nppodd=nppodd+nprimvc(nsheld(i))*nprimvc(nsheld(j))

      ja=1
      jb=ja+npposs
      jc=jb+ncposs

      if(jc.gt.ninteger) stop 'twoemm ss integer overflow'

      je=1
      jf=je+npposs
      jg=jf+npposs
      jh=jg+npposs
      ji=jh+npposs
      jj=ji+npposs
      jk=jj+npposs
      jl=jk+npposs
      jm=jl+npposs
      jn=jm+npposs
      jo=jn+npposs
      jp=jo+npposs
      jq=jp+npposs

      if(jq.gt.nreal) stop 'twoemm ss real overflow'

      call setupss(ncposs,n,nconts,nshels,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),coord,alpha,coeff,
     &             wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),wkvec(ji),
     &             wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),wkvec(jn),
     &             wkvec(jo),wkvec(jp))

      jd=jc+n

      if(jd.gt.ninteger) stop 'twoemm ss integer overflow'

      ka=jq+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+ncposs
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+ncposs*3
      kl=kk+n*3
      km=kl+n*3
      kn=km+ncposs*6
      ko=kn+n*6
      kp=ko+n
      kq=kp+n
      kr=kq+n
      ks=kr+n
      kt=ks+n
      ku=kt+n

      if(ku.gt.nreal) stop 'twoemm ss real overflow'

      call cdftss(ncposs,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),g,coord,alphacd,coefscd,coefpcd,
     &            coefdcd,tvector,density,wkvec(je),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(ka),wkvec(kb),wkvec(kc),
     &            wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),wkvec(kh),
     &            wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),wkvec(km),
     &            wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &            wkvec(ks),wkvec(kt))

      if(ncontp.eq.0) goto 1011

      ja=1
      jb=ja+nppops
      jc=jb+ncpops*3

      if(jc.gt.ninteger) stop 'twoemm ps integer overflow'

      je=1
      jf=je+nppops
      jg=jf+nppops
      jh=jg+nppops
      ji=jh+nppops
      jj=ji+nppops
      jk=jj+nppops
      jl=jk+nppops
      jm=jl+nppops
      jn=jm+nppops
      jo=jn+nppops
      jp=jo+nppops
      jq=jp+nppops
      jr=jq+nppops
      js=jr+nppops
      jt=js+nppops

      if(jt.gt.nreal) stop 'twoemm ps real overflow'

      call setupps(ncpops,n,ncontp,nconts,nshelp,nshels,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js))

      jd=jc+n

      if(jd.gt.ninteger) stop 'twoemm ps integer overflow'

      ka=jt+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+ncpops*3
      ko=kn+n*3
      kp=ko+n*3
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+ncpops*9
      kt=ks+n*9
      ku=kt+n*9
      kv=ku+ncpops*18
      kw=kv+n*18
      kx=kw+n
      ky=kx+n
      kz=ky+n
      la=kz+n*3
      lb=la+n*3
      lc=lb+n
      ld=lc+n
      le=ld+n
      lf=le+n
      lg=lf+n
      lh=lg+n
      li=lh+n

      if(li.gt.nreal) stop 'twoemm ps real overflow'

      call cdftps(ncpops,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),g,coord,alphacd,coefscd,coefpcd,
     &            coefdcd,tvector,density,wkvec(je),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),wkvec(js),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &            wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),
     &            wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &            wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh))

      ja=1
      jb=ja+ncpopp
      jc=jb+nppopp
      jd=jc+ncpopp*9

      if(jd.gt.ninteger) stop 'twoemm pp integer overflow'

      je=1
      jf=je+nppopp
      jg=jf+nppopp
      jh=jg+nppopp
      ji=jh+nppopp
      jj=ji+nppopp
      jk=jj+nppopp
      jl=jk+nppopp
      jm=jl+nppopp
      jn=jm+nppopp
      jo=jn+nppopp
      jp=jo+nppopp
      jq=jp+nppopp
      jr=jq+nppopp
      js=jr+nppopp
      jt=js+nppopp
      ju=jt+nppopp
      jv=ju+nppopp
      jw=jv+nppopp
      jx=jw+ncpopp
      jy=jx+ncpopp
      jz=jy+ncpopp

      if(jz.gt.nreal) stop 'twoemm pp real overflow'

      call setuppp(ncpopp,n,ncontp,nshelp,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &             wkvec(jx),wkvec(jy))

      j0=jd+n

      if(j0.gt.ninteger) stop 'twoemm pp integer overflow'

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+ncpopp*3
      kp=ko+n*3
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+n*3
      kt=ks+ncpopp*6
      ku=kt+n*6
      kv=ku+n*6
      kw=kv+n*6
      kx=kw+n*3
      ky=kx+ncpopp*9
      kz=ky+n*9
      la=kz+n*9
      lb=la+ncpopp*18
      lc=lb+n*18
      ld=lc+n*18
      le=ld+ncpopp*18
      lf=le+n*18
      lg=lf+ncpopp*36
      lh=lg+n*36
      li=lh+ncpopp*9
      lj=li+ncpopp*27
      lk=lj+ncpopp*54
      ll=lk+n
      lm=ll+n
      ln=lm+n
      lo=ln+n*3
      lp=lo+n*6
      lq=lp+n*9
      lr=lq+n
      ls=lr+n
      lt=ls+n
      lu=lt+n
      lv=lu+n
      lw=lv+n
      lx=lw+n

      if(lx.gt.nreal) stop 'twoemm pp real overflow'

      call cdftpp(ncpopp,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jb),iwkvec(jd),iwkvec(jc),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),wkvec(js),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &            wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),
     &            wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &            wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),
     &            wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),
     &            wkvec(lo),wkvec(lp),wkvec(lq),wkvec(lr),wkvec(ls),
     &            wkvec(lt),wkvec(lu),wkvec(lv),wkvec(lw))

      if(ncontd.eq.0) goto 1011

      ja=1
      jb=ja+nppods
      jc=jb+ncpods*6

      if(jc.gt.ninteger) stop 'twoemm ds integer overflow'

      je=1
      jf=je+nppods
      jg=jf+nppods
      jh=jg+nppods
      ji=jh+nppods
      jj=ji+nppods
      jk=jj+nppods
      jl=jk+nppods
      jm=jl+nppods
      jn=jm+nppods
      jo=jn+nppods
      jp=jo+nppods
      jq=jp+nppods
      jr=jq+nppods
      js=jr+nppods
      jt=js+nppods

      if(jt.gt.nreal) stop 'twoemm ds real overflow'

      call setupds(ncpods,n,ncontd,nconts,nsheld,nshels,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js))

      jd=jc+n

      if(jd.gt.ninteger) stop 'twoemm ds integer overflow'

      ka=jt+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n*3
      kp=ko+n*3
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+ncpods*6
      kt=ks+n*6
      ku=kt+n*6
      kv=ku+n*6
      kw=kv+n*9
      kx=kw+ncpods*18
      ky=kx+n*18
      kz=ky+n*18
      la=kz+ncpods*36
      lb=la+n*36
      lc=lb+n
      ld=lc+n
      le=ld+n
      lf=le+n*3
      lg=lf+n*6
      lh=lg+n*9
      li=lh+n
      lj=li+n
      lk=lj+n
      ll=lk+n
      lm=ll+n
      ln=lm+n
      lo=ln+n

      if(lo.gt.nreal) stop 'twoemm ds real overflow'

      call cdftds(ncpods,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),g,coord,alphacd,coefscd,coefpcd,
     &            coefdcd,tvector,density,wkvec(je),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),wkvec(js),
     &            wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),
     &            wkvec(kf),wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),
     &            wkvec(kk),wkvec(kl),wkvec(km),wkvec(kn),wkvec(ko),
     &            wkvec(kp),wkvec(kq),wkvec(kr),wkvec(ks),wkvec(kt),
     &            wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),wkvec(ky),
     &            wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &            wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),
     &            wkvec(lj),wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln))

      ja=1
      jb=ja+nppodp
      jc=jb+ncpodp*18

      if(jc.gt.ninteger) stop 'twoemm dp integer overflow'

      je=1
      jf=je+nppodp
      jg=jf+nppodp
      jh=jg+nppodp
      ji=jh+nppodp
      jj=ji+nppodp
      jk=jj+nppodp
      jl=jk+nppodp
      jm=jl+nppodp
      jn=jm+nppodp
      jo=jn+nppodp
      jp=jo+nppodp
      jq=jp+nppodp
      jr=jq+nppodp
      js=jr+nppodp
      jt=js+nppodp
      ju=jt+nppodp
      jv=ju+nppodp
      jw=jv+nppodp
      jx=jw+ncpodp
      jy=jx+ncpodp
      jz=jy+ncpodp

      if(jz.gt.nreal) stop 'twoemm dp real overflow'

      call setupdp(ncpodp,n,ncontd,ncontp,nsheld,nshelp,mtloca,iprimvc,
     &             nprimvc,icentvc,iwkvec(ja),iwkvec(jb),coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &             wkvec(jx),wkvec(jy))

      jd=jc+n

      if(jd.gt.ninteger) stop 'twoemm dp integer overflow'

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n
      kp=ko+n*3
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+n*3
      kt=ks+n*3
      ku=kt+ncpodp*6
      kv=ku+n*6
      kw=kv+n*6
      kx=kw+n*6
      ky=kx+n*6
      kz=ky+ncpodp*10
      la=kz+n*10
      lb=la+n*10
      lc=lb+n*10
      ld=lc+n*9
      le=ld+ncpodp*18
      lf=le+n*18
      lg=lf+n*18
      lh=lg+ncpodp*30
      li=lh+n*30
      lj=li+n*30
      lk=lj+ncpodp*36
      ll=lk+n*36
      lm=ll+ncpodp*60
      ln=lm+n*60
      lo=ln+ncpodp*18
      lp=lo+ncpodp*54
      lq=lp+ncpodp*108
      lr=lq+n
      ls=lr+n
      lt=ls+n
      lu=lt+n*3
      lv=lu+n*6
      lw=lv+n*9
      lx=lw+n*10
      ly=lx+n*18
      lz=ly+n
      ma=lz+n
      mb=ma+n
      mc=mb+n
      md=mc+n
      me=md+n
      mf=me+n

      if(mf.gt.nreal) stop 'twoemm dp real overflow'

      call cdftdp(ncpodp,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jc),iwkvec(jb),g,coord,alphacd,coefscd,coefpcd,
     &            coefdcd,tvector,density,wkvec(je),wkvec(jw),wkvec(jx),
     &            wkvec(jy),wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jm),
     &            wkvec(jq),wkvec(jr),wkvec(js),wkvec(ka),wkvec(kb),
     &            wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),wkvec(kg),
     &            wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &            wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),
     &            wkvec(kr),wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),
     &            wkvec(kw),wkvec(kx),wkvec(ky),wkvec(kz),wkvec(la),
     &            wkvec(lb),wkvec(lc),wkvec(ld),wkvec(le),wkvec(lf),
     &            wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),wkvec(lk),
     &            wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),wkvec(lp),
     &            wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),wkvec(lu),
     &            wkvec(lv),wkvec(lw),wkvec(lx),wkvec(ly),wkvec(lz),
     &            wkvec(ma),wkvec(mb),wkvec(mc),wkvec(md),wkvec(me))

      ja=1
      jb=ja+ncpodd
      jc=jb+nppodd
      jd=jc+ncpodd*36

      if(jd.gt.ninteger) stop 'twoemm dd integer overflow'

      je=1
      jf=je+nppodd
      jg=jf+nppodd
      jh=jg+nppodd
      ji=jh+nppodd
      jj=ji+nppodd
      jk=jj+nppodd
      jl=jk+nppodd
      jm=jl+nppodd
      jn=jm+nppodd
      jo=jn+nppodd
      jp=jo+nppodd
      jq=jp+nppodd
      jr=jq+nppodd
      js=jr+nppodd
      jt=js+nppodd
      ju=jt+nppodd
      jv=ju+nppodd
      jw=jv+nppodd
      jx=jw+ncpodd
      jy=jx+ncpodd
      jz=jy+ncpodd

      if(jz.gt.nreal) stop 'twoemm dd real overflow'

      call setupdd(ncpodd,n,ncontd,nsheld,mtloca,iprimvc,nprimvc,
     &             icentvc,iwkvec(ja),iwkvec(jb),iwkvec(jc),coord,alpha,
     &             coeff,wkvec(je),wkvec(jf),wkvec(jg),wkvec(jh),
     &             wkvec(ji),wkvec(jj),wkvec(jk),wkvec(jl),wkvec(jm),
     &             wkvec(jn),wkvec(jo),wkvec(jp),wkvec(jq),wkvec(jr),
     &             wkvec(js),wkvec(jt),wkvec(ju),wkvec(jv),wkvec(jw),
     &             wkvec(jx),wkvec(jy))

      j0=jd+n

      if(j0.gt.ninteger) stop 'twoemm dd integer overflow'

      ka=jz+1
      kb=ka+n
      kc=kb+n
      kd=kc+n
      ke=kd+n
      kf=ke+n
      kg=kf+n
      kh=kg+n
      ki=kh+n
      kj=ki+n
      kk=kj+n
      kl=kk+n
      km=kl+n
      kn=km+n
      ko=kn+n
      kp=ko+n
      kq=kp+n*3
      kr=kq+n*3
      ks=kr+n*3
      kt=ks+n*3
      ku=kt+n*3
      kv=ku+n*3
      kw=kv+ncpodd*6
      kx=kw+n*6
      ky=kx+n*6
      kz=ky+n*6
      la=kz+n*6
      lb=la+n*6
      lc=lb+ncpodd*10
      ld=lc+n*10
      le=ld+n*10
      lf=le+n*10
      lg=lf+n*10
      lh=lg+ncpodd*15
      li=lh+n*15
      lj=li+n*15
      lk=lj+n*15
      ll=lk+n*9
      lm=ll+n*9
      ln=lm+ncpodd*18
      lo=ln+n*18
      lp=lo+n*18
      lq=lp+ncpodd*30
      lr=lq+n*30
      ls=lr+n*30
      lt=ls+ncpodd*45
      lu=lt+n*45
      lv=lu+n*45
      lw=lv+ncpodd*36
      lx=lw+n*36
      ly=lx+ncpodd*60
      lz=ly+n*60
      ma=lz+ncpodd*90
      mb=ma+n*90
      mc=mb+ncpodd*18
      md=mc+ncpodd*30
      me=md+ncpodd*36
      mf=me+ncpodd*54
      mg=mf+ncpodd*90
      mh=mg+ncpodd*108
      mi=mh+ncpodd*108
      mj=mi+ncpodd*180
      mk=mj+ncpodd*216
      ml=mk+n
      mm=ml+n
      mn=mm+n
      mo=mn+n*3
      mp=mo+n*6
      mq=mp+n*10
      mr=mq+n*15
      ms=mr+n*30
      mt=ms+n
      mu=mt+n
      mv=mu+n
      mw=mv+n
      mx=mw+n
      my=mx+n
      mz=my+n

      if(mz.gt.nreal) stop 'twoemm dd real overflow'

      call cdftdd(ncpodd,n,ncds,ncdspd,icdlfunc,icdcfunc,iwkvec(ja),
     &            iwkvec(jb),iwkvec(jd),iwkvec(jc),g,coord,alphacd,
     &            coefscd,coefpcd,coefdcd,tvector,density,wkvec(je),
     &            wkvec(jw),wkvec(jx),wkvec(jy),wkvec(jn),wkvec(jo),
     &            wkvec(jp),wkvec(jm),wkvec(jq),wkvec(jr),wkvec(js),
     &     wkvec(ka),wkvec(kb),wkvec(kc),wkvec(kd),wkvec(ke),wkvec(kf),
     &     wkvec(kg),wkvec(kh),wkvec(ki),wkvec(kj),wkvec(kk),wkvec(kl),
     &     wkvec(km),wkvec(kn),wkvec(ko),wkvec(kp),wkvec(kq),wkvec(kr),
     &     wkvec(ks),wkvec(kt),wkvec(ku),wkvec(kv),wkvec(kw),wkvec(kx),
     &     wkvec(ky),wkvec(kz),wkvec(la),wkvec(lb),wkvec(lc),wkvec(ld),
     &     wkvec(le),wkvec(lf),wkvec(lg),wkvec(lh),wkvec(li),wkvec(lj),
     &     wkvec(lk),wkvec(ll),wkvec(lm),wkvec(ln),wkvec(lo),wkvec(lp),
     &     wkvec(lq),wkvec(lr),wkvec(ls),wkvec(lt),wkvec(lu),wkvec(lv),
     &     wkvec(lw),wkvec(lx),wkvec(ly),wkvec(lz),wkvec(ma),wkvec(mb),
     &     wkvec(mc),wkvec(md),wkvec(me),wkvec(mf),wkvec(mg),wkvec(mh),
     &     wkvec(mi),wkvec(mj),wkvec(mk),wkvec(ml),wkvec(mm),wkvec(mn),
     &     wkvec(mo),wkvec(mp),wkvec(mq),wkvec(mr),wkvec(ms),wkvec(mt),
     &     wkvec(mu),wkvec(mv),wkvec(mw),wkvec(mx),wkvec(my))

 1011 continue

      return
      end
