      subroutine compg2(ncntrt,npts,nd,nconts,ncontp,ncontd,ilfunc,
     &                  icfunc,ngauss,nptrs,nptrp,nptrd,iloc,cent,alpha,
     &                  coeff,x,y,z,qf,qx,qy,qz,q1,q2,q3,q4,q5,q6,xx,yy,
     &                  zz,xxx,yyy,zzz,rr,rralpha,s,px,py,pz,dxx,dxy,
     &                  dxz,dyy,dyz,dzz,fxxx,fxxy,fxxz,fxyy,fxyz,fxzz,
     &                  fyyy,fyyz,fyzz,fzzz,gxxxx,gxxxy,gxxxz,gxxyy,
     &                  gxxyz,gxxzz,gxyyy,gxyyz,gxyzz,gxzzz,gyyyy,gyyyz,
     &                  gyyzz,gyzzz,gzzzz,tempqf,tempqx,tempqy,tempqz,
     &                  tempq1,tempq2,tempq3,tempq4,tempq5,tempq6)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      dimension iloc(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension x(*),y(*),z(*),qf(nd,*),qx(nd,*),qy(nd,*),qz(nd,*)
      dimension q1(nd,*),q2(nd,*),q3(nd,*),q4(nd,*),q5(nd,*),q6(nd,*)

      dimension xx(*),yy(*),zz(*),xxx(*),yyy(*),zzz(*),rr(*),rralpha(*)
      dimension s(*),px(*),py(*),pz(*)
      dimension dxx(*),dxy(*),dxz(*),dyy(*),dyz(*),dzz(*)
      dimension fxxx(*),fxxy(*),fxxz(*),fxyy(*),fxyz(*),
     &          fxzz(*),fyyy(*),fyyz(*),fyzz(*),fzzz(*)
      dimension gxxxx(*),gxxxy(*),gxxxz(*),gxxyy(*),gxxyz(*),
     &          gxxzz(*),gxyyy(*),gxyyz(*),gxyzz(*),gxzzz(*),
     &          gyyyy(*),gyyyz(*),gyyzz(*),gyzzz(*),gzzzz(*)
      dimension tempqf(nd,*),tempqx(nd,*),tempqy(nd,*),tempqz(nd,*)
      dimension tempq1(nd,*),tempq2(nd,*),tempq3(nd,*),
     &          tempq4(nd,*),tempq5(nd,*),tempq6(nd,*)

      data zero,one,two,three,five/0.0,1.0,2.0,3.0,5.0/

      rsqrt3=one/sqrt(three)

      do 1001 i=1,ncntrt
      do 1001 j=1,nd

      qf(j,i)=zero

      qx(j,i)=zero
      qy(j,i)=zero
      qz(j,i)=zero

      q1(j,i)=zero
      q2(j,i)=zero
      q3(j,i)=zero
      q4(j,i)=zero
      q5(j,i)=zero
      q6(j,i)=zero

 1001 continue

      k=0

c  loop over s functions

      if(nconts.eq.0) return

      do 1002 i=1,nconts

      ilabel=nptrs(i)

      iptr1=      ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      call utlt1a(npts,rr,xx,yy,zz,x,y,z,cent(1,icfunc(ilabel)))

      do 1003 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 1004 j=1,npts
 1004 rralpha(j)=rr(j)*alpha(nprimitive)

      call utlt1c(npts,icounter,iloc,xxx,yyy,zzz,xx,yy,zz,rralpha)

      do 1005 j=1,icounter
 1005 s(j)=coeff(nprimitive)*exp(-rralpha(j))

      do 1006 j=1,icounter
 1006 tempqf(j,1)=s(j)

      do 1007 j=1,icounter
 1007 s(j)=s(j)*twozeta

      do 1008 j=1,icounter
      px(j)=xxx(j)*s(j)
      py(j)=yyy(j)*s(j)
 1008 pz(j)=zzz(j)*s(j)

      do 1009 j=1,icounter
      tempqx(j,1)=-px(j)
      tempqy(j,1)=-py(j)
 1009 tempqz(j,1)=-pz(j)

      do 1010 j=1,icounter
      px(j)=px(j)*twozeta
      py(j)=py(j)*twozeta
 1010 pz(j)=pz(j)*twozeta

      do 1011 j=1,icounter
      tempq1(j,1)=xxx(j)*px(j)-s(j)
      tempq2(j,1)=xxx(j)*py(j)
      tempq3(j,1)=xxx(j)*pz(j)
      tempq4(j,1)=yyy(j)*py(j)-s(j)
      tempq5(j,1)=yyy(j)*pz(j)
 1011 tempq6(j,1)=zzz(j)*pz(j)-s(j)

      call utlt1b(npts,icounter,1,nd,k,iloc,qf,qx,qy,qz,q1,q2,q3,q4,q5,
     &            q6,tempqf,tempqx,tempqy,tempqz,tempq1,tempq2,tempq3,
     &            tempq4,tempq5,tempq6,fxxx,fxxy,fxxz,fxyy,fxyz,fxzz,
     &            fyyy,fyyz,fyzz,fzzz)

 1003 continue

 1002 k=k+1

c  loop over p functions

      if(ncontp.eq.0) return

      do 2001 i=1,ncontp

      ilabel=nptrp(i)

      iptr1=      ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      call utlt1a(npts,rr,xx,yy,zz,x,y,z,cent(1,icfunc(ilabel)))

      do 2002 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 2003 j=1,npts
 2003 rralpha(j)=rr(j)*alpha(nprimitive)

      call utlt1c(npts,icounter,iloc,xxx,yyy,zzz,xx,yy,zz,rralpha)

      do 2004 j=1,icounter
 2004 s(j)=coeff(nprimitive)*exp(-rralpha(j))

      do 2005 j=1,icounter
      px(j)=xxx(j)*s(j)
      py(j)=yyy(j)*s(j)
 2005 pz(j)=zzz(j)*s(j)

      do 2006 j=1,icounter
      tempqf(j,1)=px(j)
      tempqf(j,2)=py(j)
 2006 tempqf(j,3)=pz(j)

      do 2007 j=1,icounter
      px(j)=px(j)*twozeta
      py(j)=py(j)*twozeta
 2007 pz(j)=pz(j)*twozeta

      do 2008 j=1,icounter
      dxx(j)=xxx(j)*px(j)
      dxy(j)=xxx(j)*py(j)
      dxz(j)=xxx(j)*pz(j)
      dyy(j)=yyy(j)*py(j)
      dyz(j)=yyy(j)*pz(j)
 2008 dzz(j)=zzz(j)*pz(j)

      do 2009 j=1,icounter

      tempqx(j,1)=-dxx(j)+s(j)
      tempqy(j,1)=-dxy(j)
      tempqz(j,1)=-dxz(j)

      tempqx(j,2)=-dxy(j)
      tempqy(j,2)=-dyy(j)+s(j)
      tempqz(j,2)=-dyz(j)

      tempqx(j,3)=-dxz(j)
      tempqy(j,3)=-dyz(j)
      tempqz(j,3)=-dzz(j)+s(j)

 2009 continue

      do 2010 j=1,icounter
      dxx(j)=dxx(j)*twozeta
      dxy(j)=dxy(j)*twozeta
      dxz(j)=dxz(j)*twozeta
      dyy(j)=dyy(j)*twozeta
      dyz(j)=dyz(j)*twozeta
 2010 dzz(j)=dzz(j)*twozeta

      do 2011 j=1,icounter
      fxxx(j)=xxx(j)*dxx(j)
      fxxy(j)=xxx(j)*dxy(j)
      fxxz(j)=xxx(j)*dxz(j)
      fxyy(j)=xxx(j)*dyy(j)
      fxyz(j)=xxx(j)*dyz(j)
      fxzz(j)=xxx(j)*dzz(j)
      fyyy(j)=yyy(j)*dyy(j)
      fyyz(j)=yyy(j)*dyz(j)
      fyzz(j)=yyy(j)*dzz(j)
 2011 fzzz(j)=zzz(j)*dzz(j)

      do 2012 j=1,icounter

      tempq1(j,1)=fxxx(j)-px(j)-px(j)-px(j)
      tempq2(j,1)=fxxy(j)-py(j)
      tempq3(j,1)=fxxz(j)-pz(j)
      tempq4(j,1)=fxyy(j)-px(j)
      tempq5(j,1)=fxyz(j)
      tempq6(j,1)=fxzz(j)-px(j)

      tempq1(j,2)=fxxy(j)-py(j)
      tempq2(j,2)=fxyy(j)-px(j)
      tempq3(j,2)=fxyz(j)
      tempq4(j,2)=fyyy(j)-py(j)-py(j)-py(j)
      tempq5(j,2)=fyyz(j)-pz(j)
      tempq6(j,2)=fyzz(j)-py(j)

      tempq1(j,3)=fxxz(j)-pz(j)
      tempq2(j,3)=fxyz(j)
      tempq3(j,3)=fxzz(j)-px(j)
      tempq4(j,3)=fyyz(j)-pz(j)
      tempq5(j,3)=fyzz(j)-py(j)
      tempq6(j,3)=fzzz(j)-pz(j)-pz(j)-pz(j)

 2012 continue

      call utlt1b(npts,icounter,3,nd,k,iloc,qf,qx,qy,qz,q1,q2,q3,q4,q5,
     &            q6,tempqf,tempqx,tempqy,tempqz,tempq1,tempq2,tempq3,
     &            tempq4,tempq5,tempq6,fxxx,fxxy,fxxz,fxyy,fxyz,fxzz,
     &            fyyy,fyyz,fyzz,fzzz)

 2002 continue

 2001 k=k+3

c  loop over d functions

      if(ncontd.eq.0) return

      do 3001 i=1,ncontd

      ilabel=nptrd(i)

      iptr1=      ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      call utlt1a(npts,rr,xx,yy,zz,x,y,z,cent(1,icfunc(ilabel)))

      do 3002 nprimitive=iptr1,iptr2

      twozeta=two*alpha(nprimitive)

      do 3003 j=1,npts
 3003 rralpha(j)=rr(j)*alpha(nprimitive)

      call utlt1c(npts,icounter,iloc,xxx,yyy,zzz,xx,yy,zz,rralpha)

      do 3004 j=1,icounter
 3004 s(j)=coeff(nprimitive)*exp(-rralpha(j))

      do 3005 j=1,icounter
      px(j)=xxx(j)*s(j)
      py(j)=yyy(j)*s(j)
 3005 pz(j)=zzz(j)*s(j)

      do 3006 j=1,icounter
      dxx(j)=xxx(j)*px(j)
      dxy(j)=xxx(j)*py(j)
      dxz(j)=xxx(j)*pz(j)
      dyy(j)=yyy(j)*py(j)
      dyz(j)=yyy(j)*pz(j)
 3006 dzz(j)=zzz(j)*pz(j)

      do 3007 j=1,icounter
      tempqf(j,1)=dxx(j)
      tempqf(j,2)=dxy(j)
      tempqf(j,3)=dxz(j)
      tempqf(j,4)=dyy(j)
      tempqf(j,5)=dyz(j)
 3007 tempqf(j,6)=dzz(j)

      do 3008 j=1,icounter
      dxx(j)=dxx(j)*twozeta
      dxy(j)=dxy(j)*twozeta
      dxz(j)=dxz(j)*twozeta
      dyy(j)=dyy(j)*twozeta
      dyz(j)=dyz(j)*twozeta
 3008 dzz(j)=dzz(j)*twozeta

      do 3009 j=1,icounter
      fxxx(j)=xxx(j)*dxx(j)
      fxxy(j)=xxx(j)*dxy(j)
      fxxz(j)=xxx(j)*dxz(j)
      fxyy(j)=xxx(j)*dyy(j)
      fxyz(j)=xxx(j)*dyz(j)
      fxzz(j)=xxx(j)*dzz(j)
      fyyy(j)=yyy(j)*dyy(j)
      fyyz(j)=yyy(j)*dyz(j)
      fyzz(j)=yyy(j)*dzz(j)
 3009 fzzz(j)=zzz(j)*dzz(j)

      do 3010 j=1,icounter

      tempqx(j,1)=-fxxx(j)+px(j)+px(j)
      tempqy(j,1)=-fxxy(j)
      tempqz(j,1)=-fxxz(j)

      tempqx(j,2)=-fxxy(j)+py(j)
      tempqy(j,2)=-fxyy(j)+px(j)
      tempqz(j,2)=-fxyz(j)

      tempqx(j,3)=-fxxz(j)+pz(j)
      tempqy(j,3)=-fxyz(j)
      tempqz(j,3)=-fxzz(j)+px(j)

      tempqx(j,4)=-fxyy(j)
      tempqy(j,4)=-fyyy(j)+py(j)+py(j)
      tempqz(j,4)=-fyyz(j)

      tempqx(j,5)=-fxyz(j)
      tempqy(j,5)=-fyyz(j)+pz(j)
      tempqz(j,5)=-fyzz(j)+py(j)

      tempqx(j,6)=-fxzz(j)
      tempqy(j,6)=-fyzz(j)
      tempqz(j,6)=-fzzz(j)+pz(j)+pz(j)

 3010 continue

      do 3011 j=1,icounter
      fxxx(j)=fxxx(j)*twozeta
      fxxy(j)=fxxy(j)*twozeta
      fxxz(j)=fxxz(j)*twozeta
      fxyy(j)=fxyy(j)*twozeta
      fxyz(j)=fxyz(j)*twozeta
      fxzz(j)=fxzz(j)*twozeta
      fyyy(j)=fyyy(j)*twozeta
      fyyz(j)=fyyz(j)*twozeta
      fyzz(j)=fyzz(j)*twozeta
 3011 fzzz(j)=fzzz(j)*twozeta

      do 3012 j=1,icounter
      gxxxx(j)=xxx(j)*fxxx(j)
      gxxxy(j)=xxx(j)*fxxy(j)
      gxxxz(j)=xxx(j)*fxxz(j)
      gxxyy(j)=xxx(j)*fxyy(j)
      gxxyz(j)=xxx(j)*fxyz(j)
      gxxzz(j)=xxx(j)*fxzz(j)
      gxyyy(j)=xxx(j)*fyyy(j)
      gxyyz(j)=xxx(j)*fyyz(j)
      gxyzz(j)=xxx(j)*fyzz(j)
      gxzzz(j)=xxx(j)*fzzz(j)
      gyyyy(j)=yyy(j)*fyyy(j)
      gyyyz(j)=yyy(j)*fyyz(j)
      gyyzz(j)=yyy(j)*fyzz(j)
      gyzzz(j)=yyy(j)*fzzz(j)
 3012 gzzzz(j)=zzz(j)*fzzz(j)

      do 3013 j=1,icounter

      tempq1(j,1)=gxxxx(j)+s(j)+s(j)-dxx(j)*five
      tempq2(j,1)=gxxxy(j)          -dxy(j)-dxy(j)
      tempq3(j,1)=gxxxz(j)          -dxz(j)-dxz(j)
      tempq4(j,1)=gxxyy(j)          -dxx(j)
      tempq5(j,1)=gxxyz(j)
      tempq6(j,1)=gxxzz(j)          -dxx(j)

      tempq1(j,2)=gxxxy(j)          -dxy(j)-dxy(j)-dxy(j)
      tempq2(j,2)=gxxyy(j)+s(j)     -dyy(j)-dxx(j)
      tempq3(j,2)=gxxyz(j)          -dyz(j)
      tempq4(j,2)=gxyyy(j)          -dxy(j)-dxy(j)-dxy(j)
      tempq5(j,2)=gxyyz(j)          -dxz(j)
      tempq6(j,2)=gxyzz(j)          -dxy(j)

      tempq1(j,3)=gxxxz(j)          -dxz(j)-dxz(j)-dxz(j)
      tempq2(j,3)=gxxyz(j)          -dyz(j)
      tempq3(j,3)=gxxzz(j)+s(j)     -dzz(j)-dxx(j)
      tempq4(j,3)=gxyyz(j)          -dxz(j)
      tempq5(j,3)=gxyzz(j)          -dxy(j)
      tempq6(j,3)=gxzzz(j)          -dxz(j)-dxz(j)-dxz(j)

      tempq1(j,4)=gxxyy(j)          -dyy(j)
      tempq2(j,4)=gxyyy(j)          -dxy(j)-dxy(j)
      tempq3(j,4)=gxyyz(j)
      tempq4(j,4)=gyyyy(j)+s(j)+s(j)-dyy(j)*five
      tempq5(j,4)=gyyyz(j)          -dyz(j)-dyz(j)
      tempq6(j,4)=gyyzz(j)          -dyy(j)

      tempq1(j,5)=gxxyz(j)          -dyz(j)
      tempq2(j,5)=gxyyz(j)          -dxz(j)
      tempq3(j,5)=gxyzz(j)          -dxy(j)
      tempq4(j,5)=gyyyz(j)          -dyz(j)-dyz(j)-dyz(j)
      tempq5(j,5)=gyyzz(j)+s(j)     -dzz(j)-dyy(j)
      tempq6(j,5)=gyzzz(j)          -dyz(j)-dyz(j)-dyz(j)

      tempq1(j,6)=gxxzz(j)          -dzz(j)
      tempq2(j,6)=gxyzz(j)
      tempq3(j,6)=gxzzz(j)          -dxz(j)-dxz(j)
      tempq4(j,6)=gyyzz(j)          -dzz(j)
      tempq5(j,6)=gyzzz(j)          -dyz(j)-dyz(j)
      tempq6(j,6)=gzzzz(j)+s(j)+s(j)-dzz(j)*five

 3013 continue

      call utlt1b(npts,icounter,6,nd,k,iloc,qf,qx,qy,qz,q1,q2,q3,q4,q5,
     &            q6,tempqf,tempqx,tempqy,tempqz,tempq1,tempq2,tempq3,
     &            tempq4,tempq5,tempq6,fxxx,fxxy,fxxz,fxyy,fxyz,fxzz,
     &            fyyy,fyyz,fyzz,fzzz)

 3002 continue

      do 3014 j=1,npts

      qf(j,k+1)=qf(j,k+1)*rsqrt3
      qf(j,k+4)=qf(j,k+4)*rsqrt3
      qf(j,k+6)=qf(j,k+6)*rsqrt3

      qx(j,k+1)=qx(j,k+1)*rsqrt3
      qy(j,k+1)=qy(j,k+1)*rsqrt3
      qz(j,k+1)=qz(j,k+1)*rsqrt3

      qx(j,k+4)=qx(j,k+4)*rsqrt3
      qy(j,k+4)=qy(j,k+4)*rsqrt3
      qz(j,k+4)=qz(j,k+4)*rsqrt3

      qx(j,k+6)=qx(j,k+6)*rsqrt3
      qy(j,k+6)=qy(j,k+6)*rsqrt3
      qz(j,k+6)=qz(j,k+6)*rsqrt3

      q1(j,k+1)=q1(j,k+1)*rsqrt3
      q2(j,k+1)=q2(j,k+1)*rsqrt3
      q3(j,k+1)=q3(j,k+1)*rsqrt3
      q4(j,k+1)=q4(j,k+1)*rsqrt3
      q5(j,k+1)=q5(j,k+1)*rsqrt3
      q6(j,k+1)=q6(j,k+1)*rsqrt3

      q1(j,k+4)=q1(j,k+4)*rsqrt3
      q2(j,k+4)=q2(j,k+4)*rsqrt3
      q3(j,k+4)=q3(j,k+4)*rsqrt3
      q4(j,k+4)=q4(j,k+4)*rsqrt3
      q5(j,k+4)=q5(j,k+4)*rsqrt3
      q6(j,k+4)=q6(j,k+4)*rsqrt3

      q1(j,k+6)=q1(j,k+6)*rsqrt3
      q2(j,k+6)=q2(j,k+6)*rsqrt3
      q3(j,k+6)=q3(j,k+6)*rsqrt3
      q4(j,k+6)=q4(j,k+6)*rsqrt3
      q5(j,k+6)=q5(j,k+6)*rsqrt3
      q6(j,k+6)=q6(j,k+6)*rsqrt3

 3014 continue

 3001 k=k+6

      return
      end
