      subroutine dipoledp(m,n,icontr,inddyy,density,zeta,px,py,pz,pxax,
     &                    pyay,pzaz,pxbx,pyby,pzbz,base,ss,ps,ds,dp,pso,
     &                    dso,c,c1,c2,dpcond,dipole)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension icontr(*),inddyy(m,*)

      dimension density(*),zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),
     &          pzaz(*),pxbx(*),pyby(*),pzbz(*),base(*),ss(n,*),ps(n,*),
     &          ds(n,*),dp(n,*),pso(n,*),dso(n,*),c(*),c1(n,*),c2(n,*),
     &          dpcond(m,*),dipole(*)

      data zero,thrhlf,two,pi/0.0,1.5,2.0,3.1415926535898/

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      pso(i,1)=pxax(i)*base(i)
      pso(i,2)=pyay(i)*base(i)
 1002 pso(i,3)=pzaz(i)*base(i)

      do 1003 i=1,n
 1003 c(i)=base(i)/(two*zeta(i))

      do 1004 i=1,n
      dso(i,1)=pxax(i)*pso(i,1)+c(i)
      dso(i,2)=pyay(i)*pso(i,1)
      dso(i,3)=pzaz(i)*pso(i,1)
      dso(i,4)=pyay(i)*pso(i,2)+c(i)
      dso(i,5)=pzaz(i)*pso(i,2)
 1004 dso(i,6)=pzaz(i)*pso(i,3)+c(i)

      do 1005 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1005 ss(i,3)=pz(i)*base(i)

      do 1006 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1006 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1007 j=1,3
      do 1007 i=1,n
 1007 c1(i,j)=ss(i,j)/(two*zeta(i))

      do 1008 j=1,3
      do 1008 i=1,n
 1008 c2(i,j)=pso(i,j)/(two*zeta(i))

      do 1009 i=1,n
      ds(i,01)=pxax(i)*ps(i,1)+c1(i,1)+c2(i,1)
      ds(i,02)=pxax(i)*ps(i,2)+c1(i,2)
      ds(i,03)=pxax(i)*ps(i,3)+c1(i,3)
      ds(i,04)=pyay(i)*ps(i,1)
      ds(i,05)=pyay(i)*ps(i,2)        +c2(i,1)
      ds(i,06)=pyay(i)*ps(i,3)
      ds(i,07)=pzaz(i)*ps(i,1)
      ds(i,08)=pzaz(i)*ps(i,2)
      ds(i,09)=pzaz(i)*ps(i,3)        +c2(i,1)
      ds(i,10)=pyay(i)*ps(i,4)+c1(i,1)
      ds(i,11)=pyay(i)*ps(i,5)+c1(i,2)+c2(i,2)
      ds(i,12)=pyay(i)*ps(i,6)+c1(i,3)
      ds(i,13)=pzaz(i)*ps(i,4)
      ds(i,14)=pzaz(i)*ps(i,5)
      ds(i,15)=pzaz(i)*ps(i,6)        +c2(i,2)
      ds(i,16)=pzaz(i)*ps(i,7)+c1(i,1)
      ds(i,17)=pzaz(i)*ps(i,8)+c1(i,2)
 1009 ds(i,18)=pzaz(i)*ps(i,9)+c1(i,3)+c2(i,3)

      do 1010 j=1,6
      do 1010 i=1,n
 1010 c1(i,j)=dso(i,j)/(two*zeta(i))

      do 1011 j=1,9
      do 1011 i=1,n
 1011 c2(i,j)=ps(i,j)/(two*zeta(i))

      do 1012 i=1,n
      dp(i,01)=pxbx(i)*ds(i,01)+c1(i,1)+c2(i,1)+c2(i,1)
      dp(i,02)=pxbx(i)*ds(i,02)        +c2(i,2)+c2(i,2)
      dp(i,03)=pxbx(i)*ds(i,03)        +c2(i,3)+c2(i,3)
      dp(i,04)=pyby(i)*ds(i,01)
      dp(i,05)=pyby(i)*ds(i,02)+c1(i,1)
      dp(i,06)=pyby(i)*ds(i,03)
      dp(i,07)=pzbz(i)*ds(i,01)
      dp(i,08)=pzbz(i)*ds(i,02)
      dp(i,09)=pzbz(i)*ds(i,03)+c1(i,1)
      dp(i,10)=pxbx(i)*ds(i,04)+c1(i,2)+c2(i,4)
      dp(i,11)=pxbx(i)*ds(i,05)        +c2(i,5)
      dp(i,12)=pxbx(i)*ds(i,06)        +c2(i,6)
      dp(i,13)=pyby(i)*ds(i,04)        +c2(i,1)
      dp(i,14)=pyby(i)*ds(i,05)+c1(i,2)+c2(i,2)
      dp(i,15)=pyby(i)*ds(i,06)        +c2(i,3)
      dp(i,16)=pzbz(i)*ds(i,04)
      dp(i,17)=pzbz(i)*ds(i,05)
      dp(i,18)=pzbz(i)*ds(i,06)+c1(i,2)
      dp(i,19)=pxbx(i)*ds(i,07)+c1(i,3)+c2(i,7)
      dp(i,20)=pxbx(i)*ds(i,08)        +c2(i,8)
      dp(i,21)=pxbx(i)*ds(i,09)        +c2(i,9)
      dp(i,22)=pyby(i)*ds(i,07)
      dp(i,23)=pyby(i)*ds(i,08)+c1(i,3)
      dp(i,24)=pyby(i)*ds(i,09)
      dp(i,25)=pzbz(i)*ds(i,07)        +c2(i,1)
      dp(i,26)=pzbz(i)*ds(i,08)        +c2(i,2)
      dp(i,27)=pzbz(i)*ds(i,09)+c1(i,3)+c2(i,3)
      dp(i,28)=pxbx(i)*ds(i,10)+c1(i,4)
      dp(i,29)=pxbx(i)*ds(i,11)
      dp(i,30)=pxbx(i)*ds(i,12)
      dp(i,31)=pyby(i)*ds(i,10)        +c2(i,4)+c2(i,4)
      dp(i,32)=pyby(i)*ds(i,11)+c1(i,4)+c2(i,5)+c2(i,5)
      dp(i,33)=pyby(i)*ds(i,12)        +c2(i,6)+c2(i,6)
      dp(i,34)=pzbz(i)*ds(i,10)
      dp(i,35)=pzbz(i)*ds(i,11)
      dp(i,36)=pzbz(i)*ds(i,12)+c1(i,4)
      dp(i,37)=pxbx(i)*ds(i,13)+c1(i,5)
      dp(i,38)=pxbx(i)*ds(i,14)
      dp(i,39)=pxbx(i)*ds(i,15)
      dp(i,40)=pyby(i)*ds(i,13)        +c2(i,7)
      dp(i,41)=pyby(i)*ds(i,14)+c1(i,5)+c2(i,8)
      dp(i,42)=pyby(i)*ds(i,15)        +c2(i,9)
      dp(i,43)=pzbz(i)*ds(i,13)        +c2(i,4)
      dp(i,44)=pzbz(i)*ds(i,14)        +c2(i,5)
      dp(i,45)=pzbz(i)*ds(i,15)+c1(i,5)+c2(i,6)
      dp(i,46)=pxbx(i)*ds(i,16)+c1(i,6)
      dp(i,47)=pxbx(i)*ds(i,17)
      dp(i,48)=pxbx(i)*ds(i,18)
      dp(i,49)=pyby(i)*ds(i,16)
      dp(i,50)=pyby(i)*ds(i,17)+c1(i,6)
      dp(i,51)=pyby(i)*ds(i,18)
      dp(i,52)=pzbz(i)*ds(i,16)        +c2(i,7)+c2(i,7)
      dp(i,53)=pzbz(i)*ds(i,17)        +c2(i,8)+c2(i,8)
 1012 dp(i,54)=pzbz(i)*ds(i,18)+c1(i,6)+c2(i,9)+c2(i,9)

      do 1013 j=1,54
      do 1013 i=1,m
 1013 dpcond(i,j)=zero

      do 1014 j=1,54
      do 1014 i=1,n
 1014 dpcond(icontr(i),j)=dpcond(icontr(i),j)+dp(i,j)

      do 1015 k=1,18
      do 1015 j=1,3
      do 1015 i=1,m
 1015 dipole(j)=dipole(j)-density(inddyy(i,k))*dpcond(i,3*(k-1)+j)

      return
      end
