      subroutine gcardr(nstep,ntypehess,ndim,ncenters,coord1,coord2,
     &                  grdnt1,grdnt2,hessian,wkmat1,wkmat2)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension coord1(3,*),coord2(3,*),grdnt1(3,*),grdnt2(3,*)
      dimension hessian(ndim,*)
      dimension wkmat1(3*ncenters,*),wkmat2(3*ncenters,*)

      if(nstep.eq.1) then
                           if(ntypehess.eq.0) write(6,1001)
                           if(ntypehess.eq.1) write(6,1002)
                           if(ntypehess.eq.2) write(6,1003)
                     endif

 1001 format(/,' geometry optimization algorithm : ',
     &                           ' steepest descent',/)

 1002 format(/,' geometry optimization algorithm : ',
     &                           ' conjugate gradient',/)

 1003 format(/,' geometry optimization algorithm : ',
     &                           ' broyden-fletcher-goldfarb-shanno',/)

      if(nstep.gt.1) then

                if(ntypehess.eq.0) call steepd(3*ncenters,grdnt1,
     &                                         grdnt2,coord1,coord2)

                if(ntypehess.eq.1) call cg(3*ncenters,grdnt1,grdnt2,
     &                                     coord1,coord2)

                if(ntypehess.eq.2) call bfgs(3*ncenters,ndim,grdnt1,
     &                                       grdnt2,coord1,coord2,
     &                                       hessian,wkmat1,wkmat2)

                     else

                do 1004 j=1,ncenters
                do 1004 i=1,3
                coord1(i,j)=coord2(i,j)
 1004           grdnt1(i,j)=grdnt2(i,j)

                do 1005 i=1,ncenters
                do 1005 j=1,3
                do 1005 k=1,ncenters
                do 1005 l=1,3
 1005           coord2(j,i)=coord2(j,i)
     &                     -hessian(3*(i-1)+j,3*(k-1)+l)*grdnt2(l,k)

                     endif

      return
      end
