      subroutine gintdr(istep,imode,nlimit,ndegmx,ncentr,nint,ihess,
     &                  izmt1,izmt2,izmt3,wvec,g1,g2,c1,c2,cc1,cc2,
     &                  gc1,gc2,h,dj,nintfrz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension izmt1(*),izmt2(*),izmt3(*),nintfrz(*)

      dimension g1(*),g2(*),c1(*),c2(*)
      dimension cc1(3,*),cc2(3,*),gc1(3,*),gc2(3,*)
      dimension wvec(*),h(ndegmx,*),dj(nint,*)

      if(istep.eq.1) then
                           if(ihess.eq.3) write(6,1001)
                           if(ihess.eq.4) write(6,1002)
                     endif

 1001 format(/,' bfgs geometry optimization in internal coordinates',/)
 1002 format(/,' transition state location',/)

      call xyzdint(nint,ncentr,dj,gc1,g1)
      call xyzdint(nint,ncentr,dj,gc2,g2)

      call xyzcint(ncentr,c1,cc1,izmt1,izmt2,izmt3)
      call xyzcint(ncentr,c2,cc2,izmt1,izmt2,izmt3)

      if(istep.eq.1) call xyzhint(nint,ncentr,ndegmx,dj,h,wvec)

      ja=1
      jb=ja+nint*nint
      jc=jb+nint*nint
      jd=jc+nint*nint
      je=jd+nint*nint
      jf=je+nint*nint
      jg=jf+nint*nint
      jh=jg+nint
      ji=jh+nint
      jj=ji+nint
      jk=jj+nint

      jend=jk+nint

      if(jend.ge.nlimit) stop 'internal coordinate driver'

      if(ihess.eq.3) call bfgsi(istep,nint,ndegmx,wvec(ja),wvec(jb),
     &                          wvec(jc),wvec(jd),g1,g2,c1,c2,wvec(je),
     &                          wvec(jf),h,nintfrz)

      if(ihess.eq.4) call baker(istep,imode,nint,ndegmx,wvec(ja),
     &                          wvec(jb),wvec(jc),wvec(jd),wvec(je),
     &                          wvec(jf),wvec(jg),wvec(jh),wvec(ji),
     &                          wvec(jj),wvec(jk),h,g1,g2,c1,c2)

      do 1003 j=1,ncentr
      do 1003 i=1,3
      gc1(i,j)=gc2(i,j)
 1003 cc1(i,j)=cc2(i,j)

      call xyzfint(ncentr,c2,cc2,izmt1,izmt2,izmt3)

      return
      end
