      subroutine gradxxdd2(m,n,nn,nc,iminj,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,pss0,psp0,
     &                     psd0,dss0,dsp0,dsd0,fss0,fsp0,fsd0,axbx,ayby,
     &                     azbz,psscond,pspcond,psdcond,dsscond,dspcond,
     &                     dsdcond,fsscond,fspcond,fsdcond,ppscond,
     &                     pppcond,ppdcond,dpscond,dppcond,dpdcond,
     &                     pdscond,pdpcond,pddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),pss0(n,*),
     &          psp0(n,*),psd0(n,*),dss0(n,*),dsp0(n,*),dsd0(n,*),
     &          fss0(n,*),fsp0(n,*),fsd0(n,*),axbx(*),ayby(*),azbz(*),
     &          psscond(m,*),pspcond(m,*),psdcond(m,*),dsscond(m,*),
     &          dspcond(m,*),dsdcond(m,*),fsscond(m,*),fspcond(m,*),
     &          fsdcond(m,*),ppscond(m,*),pppcond(m,*),ppdcond(m,*),
     &          dpscond(m,*),dppcond(m,*),dpdcond(m,*),pdscond(m,*),
     &          pdpcond(m,*),pddcond(m,*),grad(m,*)

      data zero,two/0.0,2.0/

      do 1001 j=1,3
      do 1001 i=1,m
 1001 psscond(i,j)=zero

      do 1002 j=1,9
      do 1002 i=1,m
 1002 pspcond(i,j)=zero

      do 1003 j=1,18
      do 1003 i=1,m
 1003 psdcond(i,j)=zero

      do 1004 j=1,6
      do 1004 i=1,m
 1004 dsscond(i,j)=zero

      do 1005 j=1,18
      do 1005 i=1,m
 1005 dspcond(i,j)=zero

      do 1006 j=1,36
      do 1006 i=1,m
 1006 dsdcond(i,j)=zero

      do 1007 j=1,10
      do 1007 i=1,m
 1007 fsscond(i,j)=zero

      do 1008 j=1,30
      do 1008 i=1,m
 1008 fspcond(i,j)=zero

      do 1009 j=1,60
      do 1009 i=1,m
 1009 fsdcond(i,j)=zero

      do 1010 j=1,3
      do 1010 i=1,nn
 1010 psscond(iicontr(i),j)=psscond(iicontr(i),j)-pss0(i,j)

      do 1011 j=1,9
      do 1011 i=1,nn
 1011 pspcond(iicontr(i),j)=pspcond(iicontr(i),j)-psp0(i,j)

      do 1012 j=1,18
      do 1012 i=1,nn
 1012 psdcond(iicontr(i),j)=psdcond(iicontr(i),j)-psd0(i,j)

      do 1013 j=1,6
      do 1013 i=1,nn
 1013 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)-dss0(i,j)

      do 1014 j=1,18
      do 1014 i=1,nn
 1014 dspcond(iicontr(i),j)=dspcond(iicontr(i),j)-dsp0(i,j)

      do 1015 j=1,36
      do 1015 i=1,nn
 1015 dsdcond(iicontr(i),j)=dsdcond(iicontr(i),j)-dsd0(i,j)

      do 1016 j=1,10
      do 1016 i=1,nn
 1016 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)-fss0(i,j)

      do 1017 j=1,30
      do 1017 i=1,nn
 1017 fspcond(iicontr(i),j)=fspcond(iicontr(i),j)-fsp0(i,j)

      do 1018 j=1,60
      do 1018 i=1,nn
 1018 fsdcond(iicontr(i),j)=fsdcond(iicontr(i),j)-fsd0(i,j)

      do 1019 i=1,m
      ppscond(i,1)=axbx(i)*psscond(i,1)+dsscond(i,1)
      ppscond(i,2)=ayby(i)*psscond(i,1)+dsscond(i,2)
      ppscond(i,3)=azbz(i)*psscond(i,1)+dsscond(i,3)
      ppscond(i,4)=axbx(i)*psscond(i,2)+dsscond(i,2)
      ppscond(i,5)=ayby(i)*psscond(i,2)+dsscond(i,4)
      ppscond(i,6)=azbz(i)*psscond(i,2)+dsscond(i,5)
      ppscond(i,7)=axbx(i)*psscond(i,3)+dsscond(i,3)
      ppscond(i,8)=ayby(i)*psscond(i,3)+dsscond(i,5)
 1019 ppscond(i,9)=azbz(i)*psscond(i,3)+dsscond(i,6)

      do 1020 i=1,m
      pppcond(i,01)=axbx(i)*pspcond(i,1)+dspcond(i,01)
      pppcond(i,02)=axbx(i)*pspcond(i,2)+dspcond(i,02)
      pppcond(i,03)=axbx(i)*pspcond(i,3)+dspcond(i,03)
      pppcond(i,04)=ayby(i)*pspcond(i,1)+dspcond(i,04)
      pppcond(i,05)=ayby(i)*pspcond(i,2)+dspcond(i,05)
      pppcond(i,06)=ayby(i)*pspcond(i,3)+dspcond(i,06)
      pppcond(i,07)=azbz(i)*pspcond(i,1)+dspcond(i,07)
      pppcond(i,08)=azbz(i)*pspcond(i,2)+dspcond(i,08)
      pppcond(i,09)=azbz(i)*pspcond(i,3)+dspcond(i,09)
      pppcond(i,10)=axbx(i)*pspcond(i,4)+dspcond(i,04)
      pppcond(i,11)=axbx(i)*pspcond(i,5)+dspcond(i,05)
      pppcond(i,12)=axbx(i)*pspcond(i,6)+dspcond(i,06)
      pppcond(i,13)=ayby(i)*pspcond(i,4)+dspcond(i,10)
      pppcond(i,14)=ayby(i)*pspcond(i,5)+dspcond(i,11)
      pppcond(i,15)=ayby(i)*pspcond(i,6)+dspcond(i,12)
      pppcond(i,16)=azbz(i)*pspcond(i,4)+dspcond(i,13)
      pppcond(i,17)=azbz(i)*pspcond(i,5)+dspcond(i,14)
      pppcond(i,18)=azbz(i)*pspcond(i,6)+dspcond(i,15)
      pppcond(i,19)=axbx(i)*pspcond(i,7)+dspcond(i,07)
      pppcond(i,20)=axbx(i)*pspcond(i,8)+dspcond(i,08)
      pppcond(i,21)=axbx(i)*pspcond(i,9)+dspcond(i,09)
      pppcond(i,22)=ayby(i)*pspcond(i,7)+dspcond(i,13)
      pppcond(i,23)=ayby(i)*pspcond(i,8)+dspcond(i,14)
      pppcond(i,24)=ayby(i)*pspcond(i,9)+dspcond(i,15)
      pppcond(i,25)=azbz(i)*pspcond(i,7)+dspcond(i,16)
      pppcond(i,26)=azbz(i)*pspcond(i,8)+dspcond(i,17)
 1020 pppcond(i,27)=azbz(i)*pspcond(i,9)+dspcond(i,18)

      do 1021 i=1,m
      ppdcond(i,01)=axbx(i)*psdcond(i,01)+dsdcond(i,01)
      ppdcond(i,02)=axbx(i)*psdcond(i,02)+dsdcond(i,02)
      ppdcond(i,03)=axbx(i)*psdcond(i,03)+dsdcond(i,03)
      ppdcond(i,04)=axbx(i)*psdcond(i,04)+dsdcond(i,04)
      ppdcond(i,05)=axbx(i)*psdcond(i,05)+dsdcond(i,05)
      ppdcond(i,06)=axbx(i)*psdcond(i,06)+dsdcond(i,06)
      ppdcond(i,07)=ayby(i)*psdcond(i,01)+dsdcond(i,07)
      ppdcond(i,08)=ayby(i)*psdcond(i,02)+dsdcond(i,08)
      ppdcond(i,09)=ayby(i)*psdcond(i,03)+dsdcond(i,09)
      ppdcond(i,10)=ayby(i)*psdcond(i,04)+dsdcond(i,10)
      ppdcond(i,11)=ayby(i)*psdcond(i,05)+dsdcond(i,11)
      ppdcond(i,12)=ayby(i)*psdcond(i,06)+dsdcond(i,12)
      ppdcond(i,13)=azbz(i)*psdcond(i,01)+dsdcond(i,13)
      ppdcond(i,14)=azbz(i)*psdcond(i,02)+dsdcond(i,14)
      ppdcond(i,15)=azbz(i)*psdcond(i,03)+dsdcond(i,15)
      ppdcond(i,16)=azbz(i)*psdcond(i,04)+dsdcond(i,16)
      ppdcond(i,17)=azbz(i)*psdcond(i,05)+dsdcond(i,17)
      ppdcond(i,18)=azbz(i)*psdcond(i,06)+dsdcond(i,18)
      ppdcond(i,19)=axbx(i)*psdcond(i,07)+dsdcond(i,07)
      ppdcond(i,20)=axbx(i)*psdcond(i,08)+dsdcond(i,08)
      ppdcond(i,21)=axbx(i)*psdcond(i,09)+dsdcond(i,09)
      ppdcond(i,22)=axbx(i)*psdcond(i,10)+dsdcond(i,10)
      ppdcond(i,23)=axbx(i)*psdcond(i,11)+dsdcond(i,11)
      ppdcond(i,24)=axbx(i)*psdcond(i,12)+dsdcond(i,12)
      ppdcond(i,25)=ayby(i)*psdcond(i,07)+dsdcond(i,19)
      ppdcond(i,26)=ayby(i)*psdcond(i,08)+dsdcond(i,20)
      ppdcond(i,27)=ayby(i)*psdcond(i,09)+dsdcond(i,21)
      ppdcond(i,28)=ayby(i)*psdcond(i,10)+dsdcond(i,22)
      ppdcond(i,29)=ayby(i)*psdcond(i,11)+dsdcond(i,23)
      ppdcond(i,30)=ayby(i)*psdcond(i,12)+dsdcond(i,24)
      ppdcond(i,31)=azbz(i)*psdcond(i,07)+dsdcond(i,25)
      ppdcond(i,32)=azbz(i)*psdcond(i,08)+dsdcond(i,26)
      ppdcond(i,33)=azbz(i)*psdcond(i,09)+dsdcond(i,27)
      ppdcond(i,34)=azbz(i)*psdcond(i,10)+dsdcond(i,28)
      ppdcond(i,35)=azbz(i)*psdcond(i,11)+dsdcond(i,29)
      ppdcond(i,36)=azbz(i)*psdcond(i,12)+dsdcond(i,30)
      ppdcond(i,37)=axbx(i)*psdcond(i,13)+dsdcond(i,13)
      ppdcond(i,38)=axbx(i)*psdcond(i,14)+dsdcond(i,14)
      ppdcond(i,39)=axbx(i)*psdcond(i,15)+dsdcond(i,15)
      ppdcond(i,40)=axbx(i)*psdcond(i,16)+dsdcond(i,16)
      ppdcond(i,41)=axbx(i)*psdcond(i,17)+dsdcond(i,17)
      ppdcond(i,42)=axbx(i)*psdcond(i,18)+dsdcond(i,18)
      ppdcond(i,43)=ayby(i)*psdcond(i,13)+dsdcond(i,25)
      ppdcond(i,44)=ayby(i)*psdcond(i,14)+dsdcond(i,26)
      ppdcond(i,45)=ayby(i)*psdcond(i,15)+dsdcond(i,27)
      ppdcond(i,46)=ayby(i)*psdcond(i,16)+dsdcond(i,28)
      ppdcond(i,47)=ayby(i)*psdcond(i,17)+dsdcond(i,29)
      ppdcond(i,48)=ayby(i)*psdcond(i,18)+dsdcond(i,30)
      ppdcond(i,49)=azbz(i)*psdcond(i,13)+dsdcond(i,31)
      ppdcond(i,50)=azbz(i)*psdcond(i,14)+dsdcond(i,32)
      ppdcond(i,51)=azbz(i)*psdcond(i,15)+dsdcond(i,33)
      ppdcond(i,52)=azbz(i)*psdcond(i,16)+dsdcond(i,34)
      ppdcond(i,53)=azbz(i)*psdcond(i,17)+dsdcond(i,35)
 1021 ppdcond(i,54)=azbz(i)*psdcond(i,18)+dsdcond(i,36)

      do 1022 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1022 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1023 i=1,m
      dppcond(i,01)=axbx(i)*dspcond(i,01)+fspcond(i,01)
      dppcond(i,02)=axbx(i)*dspcond(i,02)+fspcond(i,02)
      dppcond(i,03)=axbx(i)*dspcond(i,03)+fspcond(i,03)
      dppcond(i,04)=ayby(i)*dspcond(i,01)+fspcond(i,04)
      dppcond(i,05)=ayby(i)*dspcond(i,02)+fspcond(i,05)
      dppcond(i,06)=ayby(i)*dspcond(i,03)+fspcond(i,06)
      dppcond(i,07)=azbz(i)*dspcond(i,01)+fspcond(i,07)
      dppcond(i,08)=azbz(i)*dspcond(i,02)+fspcond(i,08)
      dppcond(i,09)=azbz(i)*dspcond(i,03)+fspcond(i,09)
      dppcond(i,10)=axbx(i)*dspcond(i,04)+fspcond(i,04)
      dppcond(i,11)=axbx(i)*dspcond(i,05)+fspcond(i,05)
      dppcond(i,12)=axbx(i)*dspcond(i,06)+fspcond(i,06)
      dppcond(i,13)=ayby(i)*dspcond(i,04)+fspcond(i,10)
      dppcond(i,14)=ayby(i)*dspcond(i,05)+fspcond(i,11)
      dppcond(i,15)=ayby(i)*dspcond(i,06)+fspcond(i,12)
      dppcond(i,16)=azbz(i)*dspcond(i,04)+fspcond(i,13)
      dppcond(i,17)=azbz(i)*dspcond(i,05)+fspcond(i,14)
      dppcond(i,18)=azbz(i)*dspcond(i,06)+fspcond(i,15)
      dppcond(i,19)=axbx(i)*dspcond(i,07)+fspcond(i,07)
      dppcond(i,20)=axbx(i)*dspcond(i,08)+fspcond(i,08)
      dppcond(i,21)=axbx(i)*dspcond(i,09)+fspcond(i,09)
      dppcond(i,22)=ayby(i)*dspcond(i,07)+fspcond(i,13)
      dppcond(i,23)=ayby(i)*dspcond(i,08)+fspcond(i,14)
      dppcond(i,24)=ayby(i)*dspcond(i,09)+fspcond(i,15)
      dppcond(i,25)=azbz(i)*dspcond(i,07)+fspcond(i,16)
      dppcond(i,26)=azbz(i)*dspcond(i,08)+fspcond(i,17)
      dppcond(i,27)=azbz(i)*dspcond(i,09)+fspcond(i,18)
      dppcond(i,28)=axbx(i)*dspcond(i,10)+fspcond(i,10)
      dppcond(i,29)=axbx(i)*dspcond(i,11)+fspcond(i,11)
      dppcond(i,30)=axbx(i)*dspcond(i,12)+fspcond(i,12)
      dppcond(i,31)=ayby(i)*dspcond(i,10)+fspcond(i,19)
      dppcond(i,32)=ayby(i)*dspcond(i,11)+fspcond(i,20)
      dppcond(i,33)=ayby(i)*dspcond(i,12)+fspcond(i,21)
      dppcond(i,34)=azbz(i)*dspcond(i,10)+fspcond(i,22)
      dppcond(i,35)=azbz(i)*dspcond(i,11)+fspcond(i,23)
      dppcond(i,36)=azbz(i)*dspcond(i,12)+fspcond(i,24)
      dppcond(i,37)=axbx(i)*dspcond(i,13)+fspcond(i,13)
      dppcond(i,38)=axbx(i)*dspcond(i,14)+fspcond(i,14)
      dppcond(i,39)=axbx(i)*dspcond(i,15)+fspcond(i,15)
      dppcond(i,40)=ayby(i)*dspcond(i,13)+fspcond(i,22)
      dppcond(i,41)=ayby(i)*dspcond(i,14)+fspcond(i,23)
      dppcond(i,42)=ayby(i)*dspcond(i,15)+fspcond(i,24)
      dppcond(i,43)=azbz(i)*dspcond(i,13)+fspcond(i,25)
      dppcond(i,44)=azbz(i)*dspcond(i,14)+fspcond(i,26)
      dppcond(i,45)=azbz(i)*dspcond(i,15)+fspcond(i,27)
      dppcond(i,46)=axbx(i)*dspcond(i,16)+fspcond(i,16)
      dppcond(i,47)=axbx(i)*dspcond(i,17)+fspcond(i,17)
      dppcond(i,48)=axbx(i)*dspcond(i,18)+fspcond(i,18)
      dppcond(i,49)=ayby(i)*dspcond(i,16)+fspcond(i,25)
      dppcond(i,50)=ayby(i)*dspcond(i,17)+fspcond(i,26)
      dppcond(i,51)=ayby(i)*dspcond(i,18)+fspcond(i,27)
      dppcond(i,52)=azbz(i)*dspcond(i,16)+fspcond(i,28)
      dppcond(i,53)=azbz(i)*dspcond(i,17)+fspcond(i,29)
 1023 dppcond(i,54)=azbz(i)*dspcond(i,18)+fspcond(i,30)

      do 1024 i=1,m
      dpdcond(i,001)=axbx(i)*dsdcond(i,01)+fsdcond(i,01)
      dpdcond(i,002)=axbx(i)*dsdcond(i,02)+fsdcond(i,02)
      dpdcond(i,003)=axbx(i)*dsdcond(i,03)+fsdcond(i,03)
      dpdcond(i,004)=axbx(i)*dsdcond(i,04)+fsdcond(i,04)
      dpdcond(i,005)=axbx(i)*dsdcond(i,05)+fsdcond(i,05)
      dpdcond(i,006)=axbx(i)*dsdcond(i,06)+fsdcond(i,06)
      dpdcond(i,007)=ayby(i)*dsdcond(i,01)+fsdcond(i,07)
      dpdcond(i,008)=ayby(i)*dsdcond(i,02)+fsdcond(i,08)
      dpdcond(i,009)=ayby(i)*dsdcond(i,03)+fsdcond(i,09)
      dpdcond(i,010)=ayby(i)*dsdcond(i,04)+fsdcond(i,10)
      dpdcond(i,011)=ayby(i)*dsdcond(i,05)+fsdcond(i,11)
      dpdcond(i,012)=ayby(i)*dsdcond(i,06)+fsdcond(i,12)
      dpdcond(i,013)=azbz(i)*dsdcond(i,01)+fsdcond(i,13)
      dpdcond(i,014)=azbz(i)*dsdcond(i,02)+fsdcond(i,14)
      dpdcond(i,015)=azbz(i)*dsdcond(i,03)+fsdcond(i,15)
      dpdcond(i,016)=azbz(i)*dsdcond(i,04)+fsdcond(i,16)
      dpdcond(i,017)=azbz(i)*dsdcond(i,05)+fsdcond(i,17)
      dpdcond(i,018)=azbz(i)*dsdcond(i,06)+fsdcond(i,18)
      dpdcond(i,019)=axbx(i)*dsdcond(i,07)+fsdcond(i,07)
      dpdcond(i,020)=axbx(i)*dsdcond(i,08)+fsdcond(i,08)
      dpdcond(i,021)=axbx(i)*dsdcond(i,09)+fsdcond(i,09)
      dpdcond(i,022)=axbx(i)*dsdcond(i,10)+fsdcond(i,10)
      dpdcond(i,023)=axbx(i)*dsdcond(i,11)+fsdcond(i,11)
      dpdcond(i,024)=axbx(i)*dsdcond(i,12)+fsdcond(i,12)
      dpdcond(i,025)=ayby(i)*dsdcond(i,07)+fsdcond(i,19)
      dpdcond(i,026)=ayby(i)*dsdcond(i,08)+fsdcond(i,20)
      dpdcond(i,027)=ayby(i)*dsdcond(i,09)+fsdcond(i,21)
      dpdcond(i,028)=ayby(i)*dsdcond(i,10)+fsdcond(i,22)
      dpdcond(i,029)=ayby(i)*dsdcond(i,11)+fsdcond(i,23)
      dpdcond(i,030)=ayby(i)*dsdcond(i,12)+fsdcond(i,24)
      dpdcond(i,031)=azbz(i)*dsdcond(i,07)+fsdcond(i,25)
      dpdcond(i,032)=azbz(i)*dsdcond(i,08)+fsdcond(i,26)
      dpdcond(i,033)=azbz(i)*dsdcond(i,09)+fsdcond(i,27)
      dpdcond(i,034)=azbz(i)*dsdcond(i,10)+fsdcond(i,28)
      dpdcond(i,035)=azbz(i)*dsdcond(i,11)+fsdcond(i,29)
      dpdcond(i,036)=azbz(i)*dsdcond(i,12)+fsdcond(i,30)
      dpdcond(i,037)=axbx(i)*dsdcond(i,13)+fsdcond(i,13)
      dpdcond(i,038)=axbx(i)*dsdcond(i,14)+fsdcond(i,14)
      dpdcond(i,039)=axbx(i)*dsdcond(i,15)+fsdcond(i,15)
      dpdcond(i,040)=axbx(i)*dsdcond(i,16)+fsdcond(i,16)
      dpdcond(i,041)=axbx(i)*dsdcond(i,17)+fsdcond(i,17)
      dpdcond(i,042)=axbx(i)*dsdcond(i,18)+fsdcond(i,18)
      dpdcond(i,043)=ayby(i)*dsdcond(i,13)+fsdcond(i,25)
      dpdcond(i,044)=ayby(i)*dsdcond(i,14)+fsdcond(i,26)
      dpdcond(i,045)=ayby(i)*dsdcond(i,15)+fsdcond(i,27)
      dpdcond(i,046)=ayby(i)*dsdcond(i,16)+fsdcond(i,28)
      dpdcond(i,047)=ayby(i)*dsdcond(i,17)+fsdcond(i,29)
      dpdcond(i,048)=ayby(i)*dsdcond(i,18)+fsdcond(i,30)
      dpdcond(i,049)=azbz(i)*dsdcond(i,13)+fsdcond(i,31)
      dpdcond(i,050)=azbz(i)*dsdcond(i,14)+fsdcond(i,32)
      dpdcond(i,051)=azbz(i)*dsdcond(i,15)+fsdcond(i,33)
      dpdcond(i,052)=azbz(i)*dsdcond(i,16)+fsdcond(i,34)
      dpdcond(i,053)=azbz(i)*dsdcond(i,17)+fsdcond(i,35)
      dpdcond(i,054)=azbz(i)*dsdcond(i,18)+fsdcond(i,36)
      dpdcond(i,055)=axbx(i)*dsdcond(i,19)+fsdcond(i,19)
      dpdcond(i,056)=axbx(i)*dsdcond(i,20)+fsdcond(i,20)
      dpdcond(i,057)=axbx(i)*dsdcond(i,21)+fsdcond(i,21)
      dpdcond(i,058)=axbx(i)*dsdcond(i,22)+fsdcond(i,22)
      dpdcond(i,059)=axbx(i)*dsdcond(i,23)+fsdcond(i,23)
      dpdcond(i,060)=axbx(i)*dsdcond(i,24)+fsdcond(i,24)
      dpdcond(i,061)=ayby(i)*dsdcond(i,19)+fsdcond(i,37)
      dpdcond(i,062)=ayby(i)*dsdcond(i,20)+fsdcond(i,38)
      dpdcond(i,063)=ayby(i)*dsdcond(i,21)+fsdcond(i,39)
      dpdcond(i,064)=ayby(i)*dsdcond(i,22)+fsdcond(i,40)
      dpdcond(i,065)=ayby(i)*dsdcond(i,23)+fsdcond(i,41)
      dpdcond(i,066)=ayby(i)*dsdcond(i,24)+fsdcond(i,42)
      dpdcond(i,067)=azbz(i)*dsdcond(i,19)+fsdcond(i,43)
      dpdcond(i,068)=azbz(i)*dsdcond(i,20)+fsdcond(i,44)
      dpdcond(i,069)=azbz(i)*dsdcond(i,21)+fsdcond(i,45)
      dpdcond(i,070)=azbz(i)*dsdcond(i,22)+fsdcond(i,46)
      dpdcond(i,071)=azbz(i)*dsdcond(i,23)+fsdcond(i,47)
      dpdcond(i,072)=azbz(i)*dsdcond(i,24)+fsdcond(i,48)
      dpdcond(i,073)=axbx(i)*dsdcond(i,25)+fsdcond(i,25)
      dpdcond(i,074)=axbx(i)*dsdcond(i,26)+fsdcond(i,26)
      dpdcond(i,075)=axbx(i)*dsdcond(i,27)+fsdcond(i,27)
      dpdcond(i,076)=axbx(i)*dsdcond(i,28)+fsdcond(i,28)
      dpdcond(i,077)=axbx(i)*dsdcond(i,29)+fsdcond(i,29)
      dpdcond(i,078)=axbx(i)*dsdcond(i,30)+fsdcond(i,30)
      dpdcond(i,079)=ayby(i)*dsdcond(i,25)+fsdcond(i,43)
      dpdcond(i,080)=ayby(i)*dsdcond(i,26)+fsdcond(i,44)
      dpdcond(i,081)=ayby(i)*dsdcond(i,27)+fsdcond(i,45)
      dpdcond(i,082)=ayby(i)*dsdcond(i,28)+fsdcond(i,46)
      dpdcond(i,083)=ayby(i)*dsdcond(i,29)+fsdcond(i,47)
      dpdcond(i,084)=ayby(i)*dsdcond(i,30)+fsdcond(i,48)
      dpdcond(i,085)=azbz(i)*dsdcond(i,25)+fsdcond(i,49)
      dpdcond(i,086)=azbz(i)*dsdcond(i,26)+fsdcond(i,50)
      dpdcond(i,087)=azbz(i)*dsdcond(i,27)+fsdcond(i,51)
      dpdcond(i,088)=azbz(i)*dsdcond(i,28)+fsdcond(i,52)
      dpdcond(i,089)=azbz(i)*dsdcond(i,29)+fsdcond(i,53)
      dpdcond(i,090)=azbz(i)*dsdcond(i,30)+fsdcond(i,54)
      dpdcond(i,091)=axbx(i)*dsdcond(i,31)+fsdcond(i,31)
      dpdcond(i,092)=axbx(i)*dsdcond(i,32)+fsdcond(i,32)
      dpdcond(i,093)=axbx(i)*dsdcond(i,33)+fsdcond(i,33)
      dpdcond(i,094)=axbx(i)*dsdcond(i,34)+fsdcond(i,34)
      dpdcond(i,095)=axbx(i)*dsdcond(i,35)+fsdcond(i,35)
      dpdcond(i,096)=axbx(i)*dsdcond(i,36)+fsdcond(i,36)
      dpdcond(i,097)=ayby(i)*dsdcond(i,31)+fsdcond(i,49)
      dpdcond(i,098)=ayby(i)*dsdcond(i,32)+fsdcond(i,50)
      dpdcond(i,099)=ayby(i)*dsdcond(i,33)+fsdcond(i,51)
      dpdcond(i,100)=ayby(i)*dsdcond(i,34)+fsdcond(i,52)
      dpdcond(i,101)=ayby(i)*dsdcond(i,35)+fsdcond(i,53)
      dpdcond(i,102)=ayby(i)*dsdcond(i,36)+fsdcond(i,54)
      dpdcond(i,103)=azbz(i)*dsdcond(i,31)+fsdcond(i,55)
      dpdcond(i,104)=azbz(i)*dsdcond(i,32)+fsdcond(i,56)
      dpdcond(i,105)=azbz(i)*dsdcond(i,33)+fsdcond(i,57)
      dpdcond(i,106)=azbz(i)*dsdcond(i,34)+fsdcond(i,58)
      dpdcond(i,107)=azbz(i)*dsdcond(i,35)+fsdcond(i,59)
 1024 dpdcond(i,108)=azbz(i)*dsdcond(i,36)+fsdcond(i,60)

      do 1025 i=1,m
      pdscond(i,01)=axbx(i)*ppscond(i,1)+dpscond(i,01)
      pdscond(i,02)=ayby(i)*ppscond(i,1)+dpscond(i,04)
      pdscond(i,03)=azbz(i)*ppscond(i,1)+dpscond(i,07)
      pdscond(i,04)=ayby(i)*ppscond(i,2)+dpscond(i,05)
      pdscond(i,05)=azbz(i)*ppscond(i,2)+dpscond(i,08)
      pdscond(i,06)=azbz(i)*ppscond(i,3)+dpscond(i,09)
      pdscond(i,07)=axbx(i)*ppscond(i,4)+dpscond(i,04)
      pdscond(i,08)=ayby(i)*ppscond(i,4)+dpscond(i,10)
      pdscond(i,09)=azbz(i)*ppscond(i,4)+dpscond(i,13)
      pdscond(i,10)=ayby(i)*ppscond(i,5)+dpscond(i,11)
      pdscond(i,11)=azbz(i)*ppscond(i,5)+dpscond(i,14)
      pdscond(i,12)=azbz(i)*ppscond(i,6)+dpscond(i,15)
      pdscond(i,13)=axbx(i)*ppscond(i,7)+dpscond(i,07)
      pdscond(i,14)=ayby(i)*ppscond(i,7)+dpscond(i,13)
      pdscond(i,15)=azbz(i)*ppscond(i,7)+dpscond(i,16)
      pdscond(i,16)=ayby(i)*ppscond(i,8)+dpscond(i,14)
      pdscond(i,17)=azbz(i)*ppscond(i,8)+dpscond(i,17)
 1025 pdscond(i,18)=azbz(i)*ppscond(i,9)+dpscond(i,18)

      do 1026 i=1,m
      pdpcond(i,01)=axbx(i)*pppcond(i,01)+dppcond(i,01)
      pdpcond(i,02)=axbx(i)*pppcond(i,02)+dppcond(i,02)
      pdpcond(i,03)=axbx(i)*pppcond(i,03)+dppcond(i,03)
      pdpcond(i,04)=ayby(i)*pppcond(i,01)+dppcond(i,10)
      pdpcond(i,05)=ayby(i)*pppcond(i,02)+dppcond(i,11)
      pdpcond(i,06)=ayby(i)*pppcond(i,03)+dppcond(i,12)
      pdpcond(i,07)=azbz(i)*pppcond(i,01)+dppcond(i,19)
      pdpcond(i,08)=azbz(i)*pppcond(i,02)+dppcond(i,20)
      pdpcond(i,09)=azbz(i)*pppcond(i,03)+dppcond(i,21)
      pdpcond(i,10)=ayby(i)*pppcond(i,04)+dppcond(i,13)
      pdpcond(i,11)=ayby(i)*pppcond(i,05)+dppcond(i,14)
      pdpcond(i,12)=ayby(i)*pppcond(i,06)+dppcond(i,15)
      pdpcond(i,13)=azbz(i)*pppcond(i,04)+dppcond(i,22)
      pdpcond(i,14)=azbz(i)*pppcond(i,05)+dppcond(i,23)
      pdpcond(i,15)=azbz(i)*pppcond(i,06)+dppcond(i,24)
      pdpcond(i,16)=azbz(i)*pppcond(i,07)+dppcond(i,25)
      pdpcond(i,17)=azbz(i)*pppcond(i,08)+dppcond(i,26)
      pdpcond(i,18)=azbz(i)*pppcond(i,09)+dppcond(i,27)
      pdpcond(i,19)=axbx(i)*pppcond(i,10)+dppcond(i,10)
      pdpcond(i,20)=axbx(i)*pppcond(i,11)+dppcond(i,11)
      pdpcond(i,21)=axbx(i)*pppcond(i,12)+dppcond(i,12)
      pdpcond(i,22)=ayby(i)*pppcond(i,10)+dppcond(i,28)
      pdpcond(i,23)=ayby(i)*pppcond(i,11)+dppcond(i,29)
      pdpcond(i,24)=ayby(i)*pppcond(i,12)+dppcond(i,30)
      pdpcond(i,25)=azbz(i)*pppcond(i,10)+dppcond(i,37)
      pdpcond(i,26)=azbz(i)*pppcond(i,11)+dppcond(i,38)
      pdpcond(i,27)=azbz(i)*pppcond(i,12)+dppcond(i,39)
      pdpcond(i,28)=ayby(i)*pppcond(i,13)+dppcond(i,31)
      pdpcond(i,29)=ayby(i)*pppcond(i,14)+dppcond(i,32)
      pdpcond(i,30)=ayby(i)*pppcond(i,15)+dppcond(i,33)
      pdpcond(i,31)=azbz(i)*pppcond(i,13)+dppcond(i,40)
      pdpcond(i,32)=azbz(i)*pppcond(i,14)+dppcond(i,41)
      pdpcond(i,33)=azbz(i)*pppcond(i,15)+dppcond(i,42)
      pdpcond(i,34)=azbz(i)*pppcond(i,16)+dppcond(i,43)
      pdpcond(i,35)=azbz(i)*pppcond(i,17)+dppcond(i,44)
      pdpcond(i,36)=azbz(i)*pppcond(i,18)+dppcond(i,45)
      pdpcond(i,37)=axbx(i)*pppcond(i,19)+dppcond(i,19)
      pdpcond(i,38)=axbx(i)*pppcond(i,20)+dppcond(i,20)
      pdpcond(i,39)=axbx(i)*pppcond(i,21)+dppcond(i,21)
      pdpcond(i,40)=ayby(i)*pppcond(i,19)+dppcond(i,37)
      pdpcond(i,41)=ayby(i)*pppcond(i,20)+dppcond(i,38)
      pdpcond(i,42)=ayby(i)*pppcond(i,21)+dppcond(i,39)
      pdpcond(i,43)=azbz(i)*pppcond(i,19)+dppcond(i,46)
      pdpcond(i,44)=azbz(i)*pppcond(i,20)+dppcond(i,47)
      pdpcond(i,45)=azbz(i)*pppcond(i,21)+dppcond(i,48)
      pdpcond(i,46)=ayby(i)*pppcond(i,22)+dppcond(i,40)
      pdpcond(i,47)=ayby(i)*pppcond(i,23)+dppcond(i,41)
      pdpcond(i,48)=ayby(i)*pppcond(i,24)+dppcond(i,42)
      pdpcond(i,49)=azbz(i)*pppcond(i,22)+dppcond(i,49)
      pdpcond(i,50)=azbz(i)*pppcond(i,23)+dppcond(i,50)
      pdpcond(i,51)=azbz(i)*pppcond(i,24)+dppcond(i,51)
      pdpcond(i,52)=azbz(i)*pppcond(i,25)+dppcond(i,52)
      pdpcond(i,53)=azbz(i)*pppcond(i,26)+dppcond(i,53)
 1026 pdpcond(i,54)=azbz(i)*pppcond(i,27)+dppcond(i,54)

      do 1027 i=1,m
      pddcond(i,001)=axbx(i)*ppdcond(i,01)+dpdcond(i,001)
      pddcond(i,002)=axbx(i)*ppdcond(i,02)+dpdcond(i,002)
      pddcond(i,003)=axbx(i)*ppdcond(i,03)+dpdcond(i,003)
      pddcond(i,004)=axbx(i)*ppdcond(i,04)+dpdcond(i,004)
      pddcond(i,005)=axbx(i)*ppdcond(i,05)+dpdcond(i,005)
      pddcond(i,006)=axbx(i)*ppdcond(i,06)+dpdcond(i,006)
      pddcond(i,007)=ayby(i)*ppdcond(i,01)+dpdcond(i,019)
      pddcond(i,008)=ayby(i)*ppdcond(i,02)+dpdcond(i,020)
      pddcond(i,009)=ayby(i)*ppdcond(i,03)+dpdcond(i,021)
      pddcond(i,010)=ayby(i)*ppdcond(i,04)+dpdcond(i,022)
      pddcond(i,011)=ayby(i)*ppdcond(i,05)+dpdcond(i,023)
      pddcond(i,012)=ayby(i)*ppdcond(i,06)+dpdcond(i,024)
      pddcond(i,013)=azbz(i)*ppdcond(i,01)+dpdcond(i,037)
      pddcond(i,014)=azbz(i)*ppdcond(i,02)+dpdcond(i,038)
      pddcond(i,015)=azbz(i)*ppdcond(i,03)+dpdcond(i,039)
      pddcond(i,016)=azbz(i)*ppdcond(i,04)+dpdcond(i,040)
      pddcond(i,017)=azbz(i)*ppdcond(i,05)+dpdcond(i,041)
      pddcond(i,018)=azbz(i)*ppdcond(i,06)+dpdcond(i,042)
      pddcond(i,019)=ayby(i)*ppdcond(i,07)+dpdcond(i,025)
      pddcond(i,020)=ayby(i)*ppdcond(i,08)+dpdcond(i,026)
      pddcond(i,021)=ayby(i)*ppdcond(i,09)+dpdcond(i,027)
      pddcond(i,022)=ayby(i)*ppdcond(i,10)+dpdcond(i,028)
      pddcond(i,023)=ayby(i)*ppdcond(i,11)+dpdcond(i,029)
      pddcond(i,024)=ayby(i)*ppdcond(i,12)+dpdcond(i,030)
      pddcond(i,025)=azbz(i)*ppdcond(i,07)+dpdcond(i,043)
      pddcond(i,026)=azbz(i)*ppdcond(i,08)+dpdcond(i,044)
      pddcond(i,027)=azbz(i)*ppdcond(i,09)+dpdcond(i,045)
      pddcond(i,028)=azbz(i)*ppdcond(i,10)+dpdcond(i,046)
      pddcond(i,029)=azbz(i)*ppdcond(i,11)+dpdcond(i,047)
      pddcond(i,030)=azbz(i)*ppdcond(i,12)+dpdcond(i,048)
      pddcond(i,031)=azbz(i)*ppdcond(i,13)+dpdcond(i,049)
      pddcond(i,032)=azbz(i)*ppdcond(i,14)+dpdcond(i,050)
      pddcond(i,033)=azbz(i)*ppdcond(i,15)+dpdcond(i,051)
      pddcond(i,034)=azbz(i)*ppdcond(i,16)+dpdcond(i,052)
      pddcond(i,035)=azbz(i)*ppdcond(i,17)+dpdcond(i,053)
      pddcond(i,036)=azbz(i)*ppdcond(i,18)+dpdcond(i,054)
      pddcond(i,037)=axbx(i)*ppdcond(i,19)+dpdcond(i,019)
      pddcond(i,038)=axbx(i)*ppdcond(i,20)+dpdcond(i,020)
      pddcond(i,039)=axbx(i)*ppdcond(i,21)+dpdcond(i,021)
      pddcond(i,040)=axbx(i)*ppdcond(i,22)+dpdcond(i,022)
      pddcond(i,041)=axbx(i)*ppdcond(i,23)+dpdcond(i,023)
      pddcond(i,042)=axbx(i)*ppdcond(i,24)+dpdcond(i,024)
      pddcond(i,043)=ayby(i)*ppdcond(i,19)+dpdcond(i,055)
      pddcond(i,044)=ayby(i)*ppdcond(i,20)+dpdcond(i,056)
      pddcond(i,045)=ayby(i)*ppdcond(i,21)+dpdcond(i,057)
      pddcond(i,046)=ayby(i)*ppdcond(i,22)+dpdcond(i,058)
      pddcond(i,047)=ayby(i)*ppdcond(i,23)+dpdcond(i,059)
      pddcond(i,048)=ayby(i)*ppdcond(i,24)+dpdcond(i,060)
      pddcond(i,049)=azbz(i)*ppdcond(i,19)+dpdcond(i,073)
      pddcond(i,050)=azbz(i)*ppdcond(i,20)+dpdcond(i,074)
      pddcond(i,051)=azbz(i)*ppdcond(i,21)+dpdcond(i,075)
      pddcond(i,052)=azbz(i)*ppdcond(i,22)+dpdcond(i,076)
      pddcond(i,053)=azbz(i)*ppdcond(i,23)+dpdcond(i,077)
      pddcond(i,054)=azbz(i)*ppdcond(i,24)+dpdcond(i,078)
      pddcond(i,055)=ayby(i)*ppdcond(i,25)+dpdcond(i,061)
      pddcond(i,056)=ayby(i)*ppdcond(i,26)+dpdcond(i,062)
      pddcond(i,057)=ayby(i)*ppdcond(i,27)+dpdcond(i,063)
      pddcond(i,058)=ayby(i)*ppdcond(i,28)+dpdcond(i,064)
      pddcond(i,059)=ayby(i)*ppdcond(i,29)+dpdcond(i,065)
      pddcond(i,060)=ayby(i)*ppdcond(i,30)+dpdcond(i,066)
      pddcond(i,061)=azbz(i)*ppdcond(i,25)+dpdcond(i,079)
      pddcond(i,062)=azbz(i)*ppdcond(i,26)+dpdcond(i,080)
      pddcond(i,063)=azbz(i)*ppdcond(i,27)+dpdcond(i,081)
      pddcond(i,064)=azbz(i)*ppdcond(i,28)+dpdcond(i,082)
      pddcond(i,065)=azbz(i)*ppdcond(i,29)+dpdcond(i,083)
      pddcond(i,066)=azbz(i)*ppdcond(i,30)+dpdcond(i,084)
      pddcond(i,067)=azbz(i)*ppdcond(i,31)+dpdcond(i,085)
      pddcond(i,068)=azbz(i)*ppdcond(i,32)+dpdcond(i,086)
      pddcond(i,069)=azbz(i)*ppdcond(i,33)+dpdcond(i,087)
      pddcond(i,070)=azbz(i)*ppdcond(i,34)+dpdcond(i,088)
      pddcond(i,071)=azbz(i)*ppdcond(i,35)+dpdcond(i,089)
      pddcond(i,072)=azbz(i)*ppdcond(i,36)+dpdcond(i,090)
      pddcond(i,073)=axbx(i)*ppdcond(i,37)+dpdcond(i,037)
      pddcond(i,074)=axbx(i)*ppdcond(i,38)+dpdcond(i,038)
      pddcond(i,075)=axbx(i)*ppdcond(i,39)+dpdcond(i,039)
      pddcond(i,076)=axbx(i)*ppdcond(i,40)+dpdcond(i,040)
      pddcond(i,077)=axbx(i)*ppdcond(i,41)+dpdcond(i,041)
      pddcond(i,078)=axbx(i)*ppdcond(i,42)+dpdcond(i,042)
      pddcond(i,079)=ayby(i)*ppdcond(i,37)+dpdcond(i,073)
      pddcond(i,080)=ayby(i)*ppdcond(i,38)+dpdcond(i,074)
      pddcond(i,081)=ayby(i)*ppdcond(i,39)+dpdcond(i,075)
      pddcond(i,082)=ayby(i)*ppdcond(i,40)+dpdcond(i,076)
      pddcond(i,083)=ayby(i)*ppdcond(i,41)+dpdcond(i,077)
      pddcond(i,084)=ayby(i)*ppdcond(i,42)+dpdcond(i,078)
      pddcond(i,085)=azbz(i)*ppdcond(i,37)+dpdcond(i,091)
      pddcond(i,086)=azbz(i)*ppdcond(i,38)+dpdcond(i,092)
      pddcond(i,087)=azbz(i)*ppdcond(i,39)+dpdcond(i,093)
      pddcond(i,088)=azbz(i)*ppdcond(i,40)+dpdcond(i,094)
      pddcond(i,089)=azbz(i)*ppdcond(i,41)+dpdcond(i,095)
      pddcond(i,090)=azbz(i)*ppdcond(i,42)+dpdcond(i,096)
      pddcond(i,091)=ayby(i)*ppdcond(i,43)+dpdcond(i,079)
      pddcond(i,092)=ayby(i)*ppdcond(i,44)+dpdcond(i,080)
      pddcond(i,093)=ayby(i)*ppdcond(i,45)+dpdcond(i,081)
      pddcond(i,094)=ayby(i)*ppdcond(i,46)+dpdcond(i,082)
      pddcond(i,095)=ayby(i)*ppdcond(i,47)+dpdcond(i,083)
      pddcond(i,096)=ayby(i)*ppdcond(i,48)+dpdcond(i,084)
      pddcond(i,097)=azbz(i)*ppdcond(i,43)+dpdcond(i,097)
      pddcond(i,098)=azbz(i)*ppdcond(i,44)+dpdcond(i,098)
      pddcond(i,099)=azbz(i)*ppdcond(i,45)+dpdcond(i,099)
      pddcond(i,100)=azbz(i)*ppdcond(i,46)+dpdcond(i,100)
      pddcond(i,101)=azbz(i)*ppdcond(i,47)+dpdcond(i,101)
      pddcond(i,102)=azbz(i)*ppdcond(i,48)+dpdcond(i,102)
      pddcond(i,103)=azbz(i)*ppdcond(i,49)+dpdcond(i,103)
      pddcond(i,104)=azbz(i)*ppdcond(i,50)+dpdcond(i,104)
      pddcond(i,105)=azbz(i)*ppdcond(i,51)+dpdcond(i,105)
      pddcond(i,106)=azbz(i)*ppdcond(i,52)+dpdcond(i,106)
      pddcond(i,107)=azbz(i)*ppdcond(i,53)+dpdcond(i,107)
 1027 pddcond(i,108)=azbz(i)*ppdcond(i,54)+dpdcond(i,108)

      do 1028 i=1,m
      grad(i,01)=pdscond(i,01)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=pdscond(i,02)*density(inddyy(i,02))*cdfits*two
      grad(i,03)=pdscond(i,03)*density(inddyy(i,03))*cdfits*two
      grad(i,04)=pdscond(i,04)*density(inddyy(i,04))*cdfits*two
      grad(i,05)=pdscond(i,05)*density(inddyy(i,05))*cdfits*two
      grad(i,06)=pdscond(i,06)*density(inddyy(i,06))*cdfits*two
      grad(i,07)=pdscond(i,07)*density(inddyy(i,07))*cdfits
      grad(i,08)=pdscond(i,08)*density(inddyy(i,08))*cdfits
      grad(i,09)=pdscond(i,09)*density(inddyy(i,09))*cdfits
      grad(i,10)=pdscond(i,10)*density(inddyy(i,10))*cdfits
      grad(i,11)=pdscond(i,11)*density(inddyy(i,11))*cdfits
      grad(i,12)=pdscond(i,12)*density(inddyy(i,12))*cdfits
      grad(i,13)=pdscond(i,13)*density(inddyy(i,13))*cdfits
      grad(i,14)=pdscond(i,14)*density(inddyy(i,14))*cdfits
      grad(i,15)=pdscond(i,15)*density(inddyy(i,15))*cdfits
      grad(i,16)=pdscond(i,16)*density(inddyy(i,16))*cdfits
      grad(i,17)=pdscond(i,17)*density(inddyy(i,17))*cdfits
      grad(i,18)=pdscond(i,18)*density(inddyy(i,18))*cdfits
      grad(i,19)=pdscond(i,01)*density(inddyy(i,07))*cdfits
      grad(i,20)=pdscond(i,02)*density(inddyy(i,08))*cdfits
      grad(i,21)=pdscond(i,03)*density(inddyy(i,09))*cdfits
      grad(i,22)=pdscond(i,04)*density(inddyy(i,10))*cdfits
      grad(i,23)=pdscond(i,05)*density(inddyy(i,11))*cdfits
      grad(i,24)=pdscond(i,06)*density(inddyy(i,12))*cdfits
      grad(i,25)=pdscond(i,07)*density(inddyy(i,19))*cdfits*two
      grad(i,26)=pdscond(i,08)*density(inddyy(i,20))*cdfits*two
      grad(i,27)=pdscond(i,09)*density(inddyy(i,21))*cdfits*two
      grad(i,28)=pdscond(i,10)*density(inddyy(i,22))*cdfits*two
      grad(i,29)=pdscond(i,11)*density(inddyy(i,23))*cdfits*two
      grad(i,30)=pdscond(i,12)*density(inddyy(i,24))*cdfits*two
      grad(i,31)=pdscond(i,13)*density(inddyy(i,25))*cdfits
      grad(i,32)=pdscond(i,14)*density(inddyy(i,26))*cdfits
      grad(i,33)=pdscond(i,15)*density(inddyy(i,27))*cdfits
      grad(i,34)=pdscond(i,16)*density(inddyy(i,28))*cdfits
      grad(i,35)=pdscond(i,17)*density(inddyy(i,29))*cdfits
      grad(i,36)=pdscond(i,18)*density(inddyy(i,30))*cdfits
      grad(i,37)=pdscond(i,01)*density(inddyy(i,13))*cdfits
      grad(i,38)=pdscond(i,02)*density(inddyy(i,14))*cdfits
      grad(i,39)=pdscond(i,03)*density(inddyy(i,15))*cdfits
      grad(i,40)=pdscond(i,04)*density(inddyy(i,16))*cdfits
      grad(i,41)=pdscond(i,05)*density(inddyy(i,17))*cdfits
      grad(i,42)=pdscond(i,06)*density(inddyy(i,18))*cdfits
      grad(i,43)=pdscond(i,07)*density(inddyy(i,25))*cdfits
      grad(i,44)=pdscond(i,08)*density(inddyy(i,26))*cdfits
      grad(i,45)=pdscond(i,09)*density(inddyy(i,27))*cdfits
      grad(i,46)=pdscond(i,10)*density(inddyy(i,28))*cdfits
      grad(i,47)=pdscond(i,11)*density(inddyy(i,29))*cdfits
      grad(i,48)=pdscond(i,12)*density(inddyy(i,30))*cdfits
      grad(i,49)=pdscond(i,13)*density(inddyy(i,31))*cdfits*two
      grad(i,50)=pdscond(i,14)*density(inddyy(i,32))*cdfits*two
      grad(i,51)=pdscond(i,15)*density(inddyy(i,33))*cdfits*two
      grad(i,52)=pdscond(i,16)*density(inddyy(i,34))*cdfits*two
      grad(i,53)=pdscond(i,17)*density(inddyy(i,35))*cdfits*two
 1028 grad(i,54)=pdscond(i,18)*density(inddyy(i,36))*cdfits*two

      do 1029 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1029 continue

      do 1030 k=1,3
      do 1030 j=1,18
      do 1030 i=1,m
 1030 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1031 k=1,3
      do 1031 j=1,18
      do 1031 i=1,m
 1031 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

      do 2001 l=1,3

      do 1032 i=1,m
      grad(i,01)=pdpcond(i,00+l)*density(inddyy(i,01))*cdfitp(l)*two
      grad(i,02)=pdpcond(i,03+l)*density(inddyy(i,02))*cdfitp(l)*two
      grad(i,03)=pdpcond(i,06+l)*density(inddyy(i,03))*cdfitp(l)*two
      grad(i,04)=pdpcond(i,09+l)*density(inddyy(i,04))*cdfitp(l)*two
      grad(i,05)=pdpcond(i,12+l)*density(inddyy(i,05))*cdfitp(l)*two
      grad(i,06)=pdpcond(i,15+l)*density(inddyy(i,06))*cdfitp(l)*two
      grad(i,07)=pdpcond(i,18+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,08)=pdpcond(i,21+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,09)=pdpcond(i,24+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,10)=pdpcond(i,27+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,11)=pdpcond(i,30+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,12)=pdpcond(i,33+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,13)=pdpcond(i,36+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,14)=pdpcond(i,39+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,15)=pdpcond(i,42+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,16)=pdpcond(i,45+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,17)=pdpcond(i,48+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,18)=pdpcond(i,51+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,19)=pdpcond(i,00+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,20)=pdpcond(i,03+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,21)=pdpcond(i,06+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,22)=pdpcond(i,09+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,23)=pdpcond(i,12+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,24)=pdpcond(i,15+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,25)=pdpcond(i,18+l)*density(inddyy(i,19))*cdfitp(l)*two
      grad(i,26)=pdpcond(i,21+l)*density(inddyy(i,20))*cdfitp(l)*two
      grad(i,27)=pdpcond(i,24+l)*density(inddyy(i,21))*cdfitp(l)*two
      grad(i,28)=pdpcond(i,27+l)*density(inddyy(i,22))*cdfitp(l)*two
      grad(i,29)=pdpcond(i,30+l)*density(inddyy(i,23))*cdfitp(l)*two
      grad(i,30)=pdpcond(i,33+l)*density(inddyy(i,24))*cdfitp(l)*two
      grad(i,31)=pdpcond(i,36+l)*density(inddyy(i,25))*cdfitp(l)
      grad(i,32)=pdpcond(i,39+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,33)=pdpcond(i,42+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,34)=pdpcond(i,45+l)*density(inddyy(i,28))*cdfitp(l)
      grad(i,35)=pdpcond(i,48+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,36)=pdpcond(i,51+l)*density(inddyy(i,30))*cdfitp(l)
      grad(i,37)=pdpcond(i,00+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,38)=pdpcond(i,03+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,39)=pdpcond(i,06+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,40)=pdpcond(i,09+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,41)=pdpcond(i,12+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,42)=pdpcond(i,15+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,43)=pdpcond(i,18+l)*density(inddyy(i,25))*cdfitp(l)
      grad(i,44)=pdpcond(i,21+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,45)=pdpcond(i,24+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,46)=pdpcond(i,27+l)*density(inddyy(i,28))*cdfitp(l)
      grad(i,47)=pdpcond(i,30+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,48)=pdpcond(i,33+l)*density(inddyy(i,30))*cdfitp(l)
      grad(i,49)=pdpcond(i,36+l)*density(inddyy(i,31))*cdfitp(l)*two
      grad(i,50)=pdpcond(i,39+l)*density(inddyy(i,32))*cdfitp(l)*two
      grad(i,51)=pdpcond(i,42+l)*density(inddyy(i,33))*cdfitp(l)*two
      grad(i,52)=pdpcond(i,45+l)*density(inddyy(i,34))*cdfitp(l)*two
      grad(i,53)=pdpcond(i,48+l)*density(inddyy(i,35))*cdfitp(l)*two
 1032 grad(i,54)=pdpcond(i,51+l)*density(inddyy(i,36))*cdfitp(l)*two

      do 1033 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1033 continue

      do 1034 k=1,3
      do 1034 j=1,18
      do 1034 i=1,m
 1034 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1035 k=1,3
      do 1035 j=1,18
      do 1035 i=1,m
 1035 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

 2001 continue

      do 2002 l=1,6

      do 1036 i=1,m
      grad(i,01)=pddcond(i,000+l)*density(inddyy(i,01))*cdfitd(l)*two
      grad(i,02)=pddcond(i,006+l)*density(inddyy(i,02))*cdfitd(l)*two
      grad(i,03)=pddcond(i,012+l)*density(inddyy(i,03))*cdfitd(l)*two
      grad(i,04)=pddcond(i,018+l)*density(inddyy(i,04))*cdfitd(l)*two
      grad(i,05)=pddcond(i,024+l)*density(inddyy(i,05))*cdfitd(l)*two
      grad(i,06)=pddcond(i,030+l)*density(inddyy(i,06))*cdfitd(l)*two
      grad(i,07)=pddcond(i,036+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,08)=pddcond(i,042+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,09)=pddcond(i,048+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,10)=pddcond(i,054+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,11)=pddcond(i,060+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,12)=pddcond(i,066+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,13)=pddcond(i,072+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,14)=pddcond(i,078+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,15)=pddcond(i,084+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,16)=pddcond(i,090+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,17)=pddcond(i,096+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,18)=pddcond(i,102+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,19)=pddcond(i,000+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,20)=pddcond(i,006+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,21)=pddcond(i,012+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,22)=pddcond(i,018+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,23)=pddcond(i,024+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,24)=pddcond(i,030+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,25)=pddcond(i,036+l)*density(inddyy(i,19))*cdfitd(l)*two
      grad(i,26)=pddcond(i,042+l)*density(inddyy(i,20))*cdfitd(l)*two
      grad(i,27)=pddcond(i,048+l)*density(inddyy(i,21))*cdfitd(l)*two
      grad(i,28)=pddcond(i,054+l)*density(inddyy(i,22))*cdfitd(l)*two
      grad(i,29)=pddcond(i,060+l)*density(inddyy(i,23))*cdfitd(l)*two
      grad(i,30)=pddcond(i,066+l)*density(inddyy(i,24))*cdfitd(l)*two
      grad(i,31)=pddcond(i,072+l)*density(inddyy(i,25))*cdfitd(l)
      grad(i,32)=pddcond(i,078+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,33)=pddcond(i,084+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,34)=pddcond(i,090+l)*density(inddyy(i,28))*cdfitd(l)
      grad(i,35)=pddcond(i,096+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,36)=pddcond(i,102+l)*density(inddyy(i,30))*cdfitd(l)
      grad(i,37)=pddcond(i,000+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,38)=pddcond(i,006+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,39)=pddcond(i,012+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,40)=pddcond(i,018+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,41)=pddcond(i,024+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,42)=pddcond(i,030+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,43)=pddcond(i,036+l)*density(inddyy(i,25))*cdfitd(l)
      grad(i,44)=pddcond(i,042+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,45)=pddcond(i,048+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,46)=pddcond(i,054+l)*density(inddyy(i,28))*cdfitd(l)
      grad(i,47)=pddcond(i,060+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,48)=pddcond(i,066+l)*density(inddyy(i,30))*cdfitd(l)
      grad(i,49)=pddcond(i,072+l)*density(inddyy(i,31))*cdfitd(l)*two
      grad(i,50)=pddcond(i,078+l)*density(inddyy(i,32))*cdfitd(l)*two
      grad(i,51)=pddcond(i,084+l)*density(inddyy(i,33))*cdfitd(l)*two
      grad(i,52)=pddcond(i,090+l)*density(inddyy(i,34))*cdfitd(l)*two
      grad(i,53)=pddcond(i,096+l)*density(inddyy(i,35))*cdfitd(l)*two
 1036 grad(i,54)=pddcond(i,102+l)*density(inddyy(i,36))*cdfitd(l)*two

      do 1037 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,04)=zero
                              grad(i,05)=zero
                              grad(i,06)=zero
                              grad(i,09)=zero
                              grad(i,10)=zero
                              grad(i,11)=zero
                              grad(i,12)=zero
                              grad(i,16)=zero
                              grad(i,17)=zero
                              grad(i,18)=zero
                              grad(i,21)=zero
                              grad(i,22)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,29)=zero
                              grad(i,30)=zero
                              grad(i,36)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,48)=zero
                        endif
 1037 continue

      do 1038 k=1,3
      do 1038 j=1,18
      do 1038 i=1,m
 1038 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1039 k=1,3
      do 1039 j=1,18
      do 1039 i=1,m
 1039 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,18*(k-1)+j)

 2002 continue

      do 1040 i=1,m
      grad(i,01)=dpscond(i,01)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=dpscond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,03)=dpscond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,04)=dpscond(i,04)*density(inddyy(i,07))*cdfits*two
      grad(i,05)=dpscond(i,05)*density(inddyy(i,08))*cdfits
      grad(i,06)=dpscond(i,06)*density(inddyy(i,09))*cdfits
      grad(i,07)=dpscond(i,07)*density(inddyy(i,13))*cdfits*two
      grad(i,08)=dpscond(i,08)*density(inddyy(i,14))*cdfits
      grad(i,09)=dpscond(i,09)*density(inddyy(i,15))*cdfits
      grad(i,10)=dpscond(i,10)*density(inddyy(i,19))*cdfits*two
      grad(i,11)=dpscond(i,11)*density(inddyy(i,20))*cdfits
      grad(i,12)=dpscond(i,12)*density(inddyy(i,21))*cdfits
      grad(i,13)=dpscond(i,13)*density(inddyy(i,25))*cdfits*two
      grad(i,14)=dpscond(i,14)*density(inddyy(i,26))*cdfits
      grad(i,15)=dpscond(i,15)*density(inddyy(i,27))*cdfits
      grad(i,16)=dpscond(i,16)*density(inddyy(i,31))*cdfits*two
      grad(i,17)=dpscond(i,17)*density(inddyy(i,32))*cdfits
      grad(i,18)=dpscond(i,18)*density(inddyy(i,33))*cdfits
      grad(i,19)=dpscond(i,01)*density(inddyy(i,02))*cdfits
      grad(i,20)=dpscond(i,02)*density(inddyy(i,04))*cdfits*two
      grad(i,21)=dpscond(i,03)*density(inddyy(i,05))*cdfits
      grad(i,22)=dpscond(i,04)*density(inddyy(i,08))*cdfits
      grad(i,23)=dpscond(i,05)*density(inddyy(i,10))*cdfits*two
      grad(i,24)=dpscond(i,06)*density(inddyy(i,11))*cdfits
      grad(i,25)=dpscond(i,07)*density(inddyy(i,14))*cdfits
      grad(i,26)=dpscond(i,08)*density(inddyy(i,16))*cdfits*two
      grad(i,27)=dpscond(i,09)*density(inddyy(i,17))*cdfits
      grad(i,28)=dpscond(i,10)*density(inddyy(i,20))*cdfits
      grad(i,29)=dpscond(i,11)*density(inddyy(i,22))*cdfits*two
      grad(i,30)=dpscond(i,12)*density(inddyy(i,23))*cdfits
      grad(i,31)=dpscond(i,13)*density(inddyy(i,26))*cdfits
      grad(i,32)=dpscond(i,14)*density(inddyy(i,28))*cdfits*two
      grad(i,33)=dpscond(i,15)*density(inddyy(i,29))*cdfits
      grad(i,34)=dpscond(i,16)*density(inddyy(i,32))*cdfits
      grad(i,35)=dpscond(i,17)*density(inddyy(i,34))*cdfits*two
      grad(i,36)=dpscond(i,18)*density(inddyy(i,35))*cdfits
      grad(i,37)=dpscond(i,01)*density(inddyy(i,03))*cdfits
      grad(i,38)=dpscond(i,02)*density(inddyy(i,05))*cdfits
      grad(i,39)=dpscond(i,03)*density(inddyy(i,06))*cdfits*two
      grad(i,40)=dpscond(i,04)*density(inddyy(i,09))*cdfits
      grad(i,41)=dpscond(i,05)*density(inddyy(i,11))*cdfits
      grad(i,42)=dpscond(i,06)*density(inddyy(i,12))*cdfits*two
      grad(i,43)=dpscond(i,07)*density(inddyy(i,15))*cdfits
      grad(i,44)=dpscond(i,08)*density(inddyy(i,17))*cdfits
      grad(i,45)=dpscond(i,09)*density(inddyy(i,18))*cdfits*two
      grad(i,46)=dpscond(i,10)*density(inddyy(i,21))*cdfits
      grad(i,47)=dpscond(i,11)*density(inddyy(i,23))*cdfits
      grad(i,48)=dpscond(i,12)*density(inddyy(i,24))*cdfits*two
      grad(i,49)=dpscond(i,13)*density(inddyy(i,27))*cdfits
      grad(i,50)=dpscond(i,14)*density(inddyy(i,29))*cdfits
      grad(i,51)=dpscond(i,15)*density(inddyy(i,30))*cdfits*two
      grad(i,52)=dpscond(i,16)*density(inddyy(i,33))*cdfits
      grad(i,53)=dpscond(i,17)*density(inddyy(i,35))*cdfits
 1040 grad(i,54)=dpscond(i,18)*density(inddyy(i,36))*cdfits*two

      do 1041 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,19)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,26)=zero
                              grad(i,27)=zero
                              grad(i,30)=zero
                              grad(i,37)=zero
                              grad(i,38)=zero
                              grad(i,39)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,44)=zero
                              grad(i,45)=zero
                              grad(i,47)=zero
                              grad(i,48)=zero
                              grad(i,51)=zero
                        endif
 1041 continue

      do 1042 k=1,3
      do 1042 j=1,18
      do 1042 i=1,m
 1042 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1043 k=1,3
      do 1043 j=1,18
      do 1043 i=1,m
 1043 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      do 2003 l=1,3

      do 1044 i=1,m
      grad(i,01)=dppcond(i,00+l)*density(inddyy(i,01))*cdfitp(l)*two
      grad(i,02)=dppcond(i,03+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,03)=dppcond(i,06+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,04)=dppcond(i,09+l)*density(inddyy(i,07))*cdfitp(l)*two
      grad(i,05)=dppcond(i,12+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,06)=dppcond(i,15+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,07)=dppcond(i,18+l)*density(inddyy(i,13))*cdfitp(l)*two
      grad(i,08)=dppcond(i,21+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,09)=dppcond(i,24+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,10)=dppcond(i,27+l)*density(inddyy(i,19))*cdfitp(l)*two
      grad(i,11)=dppcond(i,30+l)*density(inddyy(i,20))*cdfitp(l)
      grad(i,12)=dppcond(i,33+l)*density(inddyy(i,21))*cdfitp(l)
      grad(i,13)=dppcond(i,36+l)*density(inddyy(i,25))*cdfitp(l)*two
      grad(i,14)=dppcond(i,39+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,15)=dppcond(i,42+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,16)=dppcond(i,45+l)*density(inddyy(i,31))*cdfitp(l)*two
      grad(i,17)=dppcond(i,48+l)*density(inddyy(i,32))*cdfitp(l)
      grad(i,18)=dppcond(i,51+l)*density(inddyy(i,33))*cdfitp(l)
      grad(i,19)=dppcond(i,00+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,20)=dppcond(i,03+l)*density(inddyy(i,04))*cdfitp(l)*two
      grad(i,21)=dppcond(i,06+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,22)=dppcond(i,09+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,23)=dppcond(i,12+l)*density(inddyy(i,10))*cdfitp(l)*two
      grad(i,24)=dppcond(i,15+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,25)=dppcond(i,18+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,26)=dppcond(i,21+l)*density(inddyy(i,16))*cdfitp(l)*two
      grad(i,27)=dppcond(i,24+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,28)=dppcond(i,27+l)*density(inddyy(i,20))*cdfitp(l)
      grad(i,29)=dppcond(i,30+l)*density(inddyy(i,22))*cdfitp(l)*two
      grad(i,30)=dppcond(i,33+l)*density(inddyy(i,23))*cdfitp(l)
      grad(i,31)=dppcond(i,36+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,32)=dppcond(i,39+l)*density(inddyy(i,28))*cdfitp(l)*two
      grad(i,33)=dppcond(i,42+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,34)=dppcond(i,45+l)*density(inddyy(i,32))*cdfitp(l)
      grad(i,35)=dppcond(i,48+l)*density(inddyy(i,34))*cdfitp(l)*two
      grad(i,36)=dppcond(i,51+l)*density(inddyy(i,35))*cdfitp(l)
      grad(i,37)=dppcond(i,00+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,38)=dppcond(i,03+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,39)=dppcond(i,06+l)*density(inddyy(i,06))*cdfitp(l)*two
      grad(i,40)=dppcond(i,09+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,41)=dppcond(i,12+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,42)=dppcond(i,15+l)*density(inddyy(i,12))*cdfitp(l)*two
      grad(i,43)=dppcond(i,18+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,44)=dppcond(i,21+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,45)=dppcond(i,24+l)*density(inddyy(i,18))*cdfitp(l)*two
      grad(i,46)=dppcond(i,27+l)*density(inddyy(i,21))*cdfitp(l)
      grad(i,47)=dppcond(i,30+l)*density(inddyy(i,23))*cdfitp(l)
      grad(i,48)=dppcond(i,33+l)*density(inddyy(i,24))*cdfitp(l)*two
      grad(i,49)=dppcond(i,36+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,50)=dppcond(i,39+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,51)=dppcond(i,42+l)*density(inddyy(i,30))*cdfitp(l)*two
      grad(i,52)=dppcond(i,45+l)*density(inddyy(i,33))*cdfitp(l)
      grad(i,53)=dppcond(i,48+l)*density(inddyy(i,35))*cdfitp(l)
 1044 grad(i,54)=dppcond(i,51+l)*density(inddyy(i,36))*cdfitp(l)*two

      do 1045 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,19)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,26)=zero
                              grad(i,27)=zero
                              grad(i,30)=zero
                              grad(i,37)=zero
                              grad(i,38)=zero
                              grad(i,39)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,44)=zero
                              grad(i,45)=zero
                              grad(i,47)=zero
                              grad(i,48)=zero
                              grad(i,51)=zero
                        endif
 1045 continue

      do 1046 k=1,3
      do 1046 j=1,18
      do 1046 i=1,m
 1046 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1047 k=1,3
      do 1047 j=1,18
      do 1047 i=1,m
 1047 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

 2003 continue

      do 2004 l=1,6

      do 1048 i=1,m
      grad(i,01)=dpdcond(i,000+l)*density(inddyy(i,01))*cdfitd(l)*two
      grad(i,02)=dpdcond(i,006+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,03)=dpdcond(i,012+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,04)=dpdcond(i,018+l)*density(inddyy(i,07))*cdfitd(l)*two
      grad(i,05)=dpdcond(i,024+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,06)=dpdcond(i,030+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,07)=dpdcond(i,036+l)*density(inddyy(i,13))*cdfitd(l)*two
      grad(i,08)=dpdcond(i,042+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,09)=dpdcond(i,048+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,10)=dpdcond(i,054+l)*density(inddyy(i,19))*cdfitd(l)*two
      grad(i,11)=dpdcond(i,060+l)*density(inddyy(i,20))*cdfitd(l)
      grad(i,12)=dpdcond(i,066+l)*density(inddyy(i,21))*cdfitd(l)
      grad(i,13)=dpdcond(i,072+l)*density(inddyy(i,25))*cdfitd(l)*two
      grad(i,14)=dpdcond(i,078+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,15)=dpdcond(i,084+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,16)=dpdcond(i,090+l)*density(inddyy(i,31))*cdfitd(l)*two
      grad(i,17)=dpdcond(i,096+l)*density(inddyy(i,32))*cdfitd(l)
      grad(i,18)=dpdcond(i,102+l)*density(inddyy(i,33))*cdfitd(l)
      grad(i,19)=dpdcond(i,000+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,20)=dpdcond(i,006+l)*density(inddyy(i,04))*cdfitd(l)*two
      grad(i,21)=dpdcond(i,012+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,22)=dpdcond(i,018+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,23)=dpdcond(i,024+l)*density(inddyy(i,10))*cdfitd(l)*two
      grad(i,24)=dpdcond(i,030+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,25)=dpdcond(i,036+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,26)=dpdcond(i,042+l)*density(inddyy(i,16))*cdfitd(l)*two
      grad(i,27)=dpdcond(i,048+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,28)=dpdcond(i,054+l)*density(inddyy(i,20))*cdfitd(l)
      grad(i,29)=dpdcond(i,060+l)*density(inddyy(i,22))*cdfitd(l)*two
      grad(i,30)=dpdcond(i,066+l)*density(inddyy(i,23))*cdfitd(l)
      grad(i,31)=dpdcond(i,072+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,32)=dpdcond(i,078+l)*density(inddyy(i,28))*cdfitd(l)*two
      grad(i,33)=dpdcond(i,084+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,34)=dpdcond(i,090+l)*density(inddyy(i,32))*cdfitd(l)
      grad(i,35)=dpdcond(i,096+l)*density(inddyy(i,34))*cdfitd(l)*two
      grad(i,36)=dpdcond(i,102+l)*density(inddyy(i,35))*cdfitd(l)
      grad(i,37)=dpdcond(i,000+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,38)=dpdcond(i,006+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,39)=dpdcond(i,012+l)*density(inddyy(i,06))*cdfitd(l)*two
      grad(i,40)=dpdcond(i,018+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,41)=dpdcond(i,024+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,42)=dpdcond(i,030+l)*density(inddyy(i,12))*cdfitd(l)*two
      grad(i,43)=dpdcond(i,036+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,44)=dpdcond(i,042+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,45)=dpdcond(i,048+l)*density(inddyy(i,18))*cdfitd(l)*two
      grad(i,46)=dpdcond(i,054+l)*density(inddyy(i,21))*cdfitd(l)
      grad(i,47)=dpdcond(i,060+l)*density(inddyy(i,23))*cdfitd(l)
      grad(i,48)=dpdcond(i,066+l)*density(inddyy(i,24))*cdfitd(l)*two
      grad(i,49)=dpdcond(i,072+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,50)=dpdcond(i,078+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,51)=dpdcond(i,084+l)*density(inddyy(i,30))*cdfitd(l)*two
      grad(i,52)=dpdcond(i,090+l)*density(inddyy(i,33))*cdfitd(l)
      grad(i,53)=dpdcond(i,096+l)*density(inddyy(i,35))*cdfitd(l)
 1048 grad(i,54)=dpdcond(i,102+l)*density(inddyy(i,36))*cdfitd(l)*two

      do 1049 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,02)=zero
                              grad(i,03)=zero
                              grad(i,06)=zero
                              grad(i,19)=zero
                              grad(i,20)=zero
                              grad(i,21)=zero
                              grad(i,23)=zero
                              grad(i,24)=zero
                              grad(i,26)=zero
                              grad(i,27)=zero
                              grad(i,30)=zero
                              grad(i,37)=zero
                              grad(i,38)=zero
                              grad(i,39)=zero
                              grad(i,40)=zero
                              grad(i,41)=zero
                              grad(i,42)=zero
                              grad(i,44)=zero
                              grad(i,45)=zero
                              grad(i,47)=zero
                              grad(i,48)=zero
                              grad(i,51)=zero
                        endif
 1049 continue

      do 1050 k=1,3
      do 1050 j=1,18
      do 1050 i=1,m
 1050 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1051 k=1,3
      do 1051 j=1,18
      do 1051 i=1,m
 1051 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

 2004 continue

      return
      end
