      subroutine gradxxdd3(m,n,nn,nc,iminj,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,ttwozetaa,
     &                     fss0,fsp0,fsd0,gss0,gsp0,gsd0,hss0,hsp0,hsd0,
     &                     axbx,ayby,azbz,fsscond,fspcond,fsdcond,
     &                     gsscond,gspcond,gsdcond,hsscond,hspcond,
     &                     hsdcond,fpscond,fppcond,fpdcond,gpscond,
     &                     gppcond,gpdcond,fdscond,fdpcond,fddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),
     &          ttwozetaa(*),fss0(n,*),fsp0(n,*),fsd0(n,*),gss0(n,*),
     &          gsp0(n,*),gsd0(n,*),hss0(n,*),hsp0(n,*),hsd0(n,*),
     &          axbx(*),ayby(*),azbz(*),fsscond(m,*),fspcond(m,*),
     &          fsdcond(m,*),gsscond(m,*),gspcond(m,*),gsdcond(m,*),
     &          hsscond(m,*),hspcond(m,*),hsdcond(m,*),fpscond(m,*),
     &          fppcond(m,*),fpdcond(m,*),gpscond(m,*),gppcond(m,*),
     &          gpdcond(m,*),fdscond(m,*),fdpcond(m,*),fddcond(m,*),
     &          grad(m,*)

      data zero/0.0/

      do 1001 j=1,10
      do 1001 i=1,m
 1001 fsscond(i,j)=zero

      do 1002 j=1,30
      do 1002 i=1,m
 1002 fspcond(i,j)=zero

      do 1003 j=1,60
      do 1003 i=1,m
 1003 fsdcond(i,j)=zero

      do 1004 j=1,15
      do 1004 i=1,m
 1004 gsscond(i,j)=zero

      do 1005 j=1,45
      do 1005 i=1,m
 1005 gspcond(i,j)=zero

      do 1006 j=1,90
      do 1006 i=1,m
 1006 gsdcond(i,j)=zero

      do 1007 j=1,21
      do 1007 i=1,m
 1007 hsscond(i,j)=zero

      do 1008 j=1,63
      do 1008 i=1,m
 1008 hspcond(i,j)=zero

      do 1009 j=1,126
      do 1009 i=1,m
 1009 hsdcond(i,j)=zero

      do 1010 j=1,10
      do 1010 i=1,nn
 1010 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)+fss0(i,j)*ttwozetaa(i)

      do 1011 j=1,30
      do 1011 i=1,nn
 1011 fspcond(iicontr(i),j)=fspcond(iicontr(i),j)+fsp0(i,j)*ttwozetaa(i)

      do 1012 j=1,60
      do 1012 i=1,nn
 1012 fsdcond(iicontr(i),j)=fsdcond(iicontr(i),j)+fsd0(i,j)*ttwozetaa(i)

      do 1013 j=1,15
      do 1013 i=1,nn
 1013 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)+gss0(i,j)*ttwozetaa(i)

      do 1014 j=1,45
      do 1014 i=1,nn
 1014 gspcond(iicontr(i),j)=gspcond(iicontr(i),j)+gsp0(i,j)*ttwozetaa(i)

      do 1015 j=1,90
      do 1015 i=1,nn
 1015 gsdcond(iicontr(i),j)=gsdcond(iicontr(i),j)+gsd0(i,j)*ttwozetaa(i)

      do 1016 j=1,21
      do 1016 i=1,nn
 1016 hsscond(iicontr(i),j)=hsscond(iicontr(i),j)+hss0(i,j)*ttwozetaa(i)

      do 1017 j=1,63
      do 1017 i=1,nn
 1017 hspcond(iicontr(i),j)=hspcond(iicontr(i),j)+hsp0(i,j)*ttwozetaa(i)

      do 1018 j=1,126
      do 1018 i=1,nn
 1018 hsdcond(iicontr(i),j)=hsdcond(iicontr(i),j)+hsd0(i,j)*ttwozetaa(i)

      call gradxxdd8(m,axbx,ayby,azbz,fsscond,fspcond,fsdcond,gsscond,
     &               gspcond,gsdcond,hsscond,hspcond,hsdcond,fpscond,
     &               fppcond,fpdcond,gpscond,gppcond,gpdcond)

      call gradxxdd9(m,axbx,ayby,azbz,fpscond,fppcond,fpdcond,gpscond,
     &               gppcond,gpdcond,fdscond,fdpcond,fddcond)

      do 1019 i=1,m
      grad(i,001)=fdscond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,002)=fdscond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,003)=fdscond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,004)=fdscond(i,04)*density(inddyy(i,04))*cdfits
      grad(i,005)=fdscond(i,05)*density(inddyy(i,05))*cdfits
      grad(i,006)=fdscond(i,06)*density(inddyy(i,06))*cdfits
      grad(i,007)=fdscond(i,07)*density(inddyy(i,07))*cdfits
      grad(i,008)=fdscond(i,08)*density(inddyy(i,08))*cdfits
      grad(i,009)=fdscond(i,09)*density(inddyy(i,09))*cdfits
      grad(i,010)=fdscond(i,10)*density(inddyy(i,10))*cdfits
      grad(i,011)=fdscond(i,11)*density(inddyy(i,11))*cdfits
      grad(i,012)=fdscond(i,12)*density(inddyy(i,12))*cdfits
      grad(i,013)=fdscond(i,13)*density(inddyy(i,13))*cdfits
      grad(i,014)=fdscond(i,14)*density(inddyy(i,14))*cdfits
      grad(i,015)=fdscond(i,15)*density(inddyy(i,15))*cdfits
      grad(i,016)=fdscond(i,16)*density(inddyy(i,16))*cdfits
      grad(i,017)=fdscond(i,17)*density(inddyy(i,17))*cdfits
      grad(i,018)=fdscond(i,18)*density(inddyy(i,18))*cdfits
      grad(i,019)=fdscond(i,19)*density(inddyy(i,19))*cdfits
      grad(i,020)=fdscond(i,20)*density(inddyy(i,20))*cdfits
      grad(i,021)=fdscond(i,21)*density(inddyy(i,21))*cdfits
      grad(i,022)=fdscond(i,22)*density(inddyy(i,22))*cdfits
      grad(i,023)=fdscond(i,23)*density(inddyy(i,23))*cdfits
      grad(i,024)=fdscond(i,24)*density(inddyy(i,24))*cdfits
      grad(i,025)=fdscond(i,25)*density(inddyy(i,25))*cdfits
      grad(i,026)=fdscond(i,26)*density(inddyy(i,26))*cdfits
      grad(i,027)=fdscond(i,27)*density(inddyy(i,27))*cdfits
      grad(i,028)=fdscond(i,28)*density(inddyy(i,28))*cdfits
      grad(i,029)=fdscond(i,29)*density(inddyy(i,29))*cdfits
      grad(i,030)=fdscond(i,30)*density(inddyy(i,30))*cdfits
      grad(i,031)=fdscond(i,31)*density(inddyy(i,31))*cdfits
      grad(i,032)=fdscond(i,32)*density(inddyy(i,32))*cdfits
      grad(i,033)=fdscond(i,33)*density(inddyy(i,33))*cdfits
      grad(i,034)=fdscond(i,34)*density(inddyy(i,34))*cdfits
      grad(i,035)=fdscond(i,35)*density(inddyy(i,35))*cdfits
      grad(i,036)=fdscond(i,36)*density(inddyy(i,36))*cdfits
      grad(i,037)=fdscond(i,07)*density(inddyy(i,01))*cdfits
      grad(i,038)=fdscond(i,08)*density(inddyy(i,02))*cdfits
      grad(i,039)=fdscond(i,09)*density(inddyy(i,03))*cdfits
      grad(i,040)=fdscond(i,10)*density(inddyy(i,04))*cdfits
      grad(i,041)=fdscond(i,11)*density(inddyy(i,05))*cdfits
      grad(i,042)=fdscond(i,12)*density(inddyy(i,06))*cdfits
      grad(i,043)=fdscond(i,19)*density(inddyy(i,07))*cdfits
      grad(i,044)=fdscond(i,20)*density(inddyy(i,08))*cdfits
      grad(i,045)=fdscond(i,21)*density(inddyy(i,09))*cdfits
      grad(i,046)=fdscond(i,22)*density(inddyy(i,10))*cdfits
      grad(i,047)=fdscond(i,23)*density(inddyy(i,11))*cdfits
      grad(i,048)=fdscond(i,24)*density(inddyy(i,12))*cdfits
      grad(i,049)=fdscond(i,25)*density(inddyy(i,13))*cdfits
      grad(i,050)=fdscond(i,26)*density(inddyy(i,14))*cdfits
      grad(i,051)=fdscond(i,27)*density(inddyy(i,15))*cdfits
      grad(i,052)=fdscond(i,28)*density(inddyy(i,16))*cdfits
      grad(i,053)=fdscond(i,29)*density(inddyy(i,17))*cdfits
      grad(i,054)=fdscond(i,30)*density(inddyy(i,18))*cdfits
      grad(i,055)=fdscond(i,37)*density(inddyy(i,19))*cdfits
      grad(i,056)=fdscond(i,38)*density(inddyy(i,20))*cdfits
      grad(i,057)=fdscond(i,39)*density(inddyy(i,21))*cdfits
      grad(i,058)=fdscond(i,40)*density(inddyy(i,22))*cdfits
      grad(i,059)=fdscond(i,41)*density(inddyy(i,23))*cdfits
      grad(i,060)=fdscond(i,42)*density(inddyy(i,24))*cdfits
      grad(i,061)=fdscond(i,43)*density(inddyy(i,25))*cdfits
      grad(i,062)=fdscond(i,44)*density(inddyy(i,26))*cdfits
      grad(i,063)=fdscond(i,45)*density(inddyy(i,27))*cdfits
      grad(i,064)=fdscond(i,46)*density(inddyy(i,28))*cdfits
      grad(i,065)=fdscond(i,47)*density(inddyy(i,29))*cdfits
      grad(i,066)=fdscond(i,48)*density(inddyy(i,30))*cdfits
      grad(i,067)=fdscond(i,49)*density(inddyy(i,31))*cdfits
      grad(i,068)=fdscond(i,50)*density(inddyy(i,32))*cdfits
      grad(i,069)=fdscond(i,51)*density(inddyy(i,33))*cdfits
      grad(i,070)=fdscond(i,52)*density(inddyy(i,34))*cdfits
      grad(i,071)=fdscond(i,53)*density(inddyy(i,35))*cdfits
      grad(i,072)=fdscond(i,54)*density(inddyy(i,36))*cdfits
      grad(i,073)=fdscond(i,13)*density(inddyy(i,01))*cdfits
      grad(i,074)=fdscond(i,14)*density(inddyy(i,02))*cdfits
      grad(i,075)=fdscond(i,15)*density(inddyy(i,03))*cdfits
      grad(i,076)=fdscond(i,16)*density(inddyy(i,04))*cdfits
      grad(i,077)=fdscond(i,17)*density(inddyy(i,05))*cdfits
      grad(i,078)=fdscond(i,18)*density(inddyy(i,06))*cdfits
      grad(i,079)=fdscond(i,25)*density(inddyy(i,07))*cdfits
      grad(i,080)=fdscond(i,26)*density(inddyy(i,08))*cdfits
      grad(i,081)=fdscond(i,27)*density(inddyy(i,09))*cdfits
      grad(i,082)=fdscond(i,28)*density(inddyy(i,10))*cdfits
      grad(i,083)=fdscond(i,29)*density(inddyy(i,11))*cdfits
      grad(i,084)=fdscond(i,30)*density(inddyy(i,12))*cdfits
      grad(i,085)=fdscond(i,31)*density(inddyy(i,13))*cdfits
      grad(i,086)=fdscond(i,32)*density(inddyy(i,14))*cdfits
      grad(i,087)=fdscond(i,33)*density(inddyy(i,15))*cdfits
      grad(i,088)=fdscond(i,34)*density(inddyy(i,16))*cdfits
      grad(i,089)=fdscond(i,35)*density(inddyy(i,17))*cdfits
      grad(i,090)=fdscond(i,36)*density(inddyy(i,18))*cdfits
      grad(i,091)=fdscond(i,43)*density(inddyy(i,19))*cdfits
      grad(i,092)=fdscond(i,44)*density(inddyy(i,20))*cdfits
      grad(i,093)=fdscond(i,45)*density(inddyy(i,21))*cdfits
      grad(i,094)=fdscond(i,46)*density(inddyy(i,22))*cdfits
      grad(i,095)=fdscond(i,47)*density(inddyy(i,23))*cdfits
      grad(i,096)=fdscond(i,48)*density(inddyy(i,24))*cdfits
      grad(i,097)=fdscond(i,49)*density(inddyy(i,25))*cdfits
      grad(i,098)=fdscond(i,50)*density(inddyy(i,26))*cdfits
      grad(i,099)=fdscond(i,51)*density(inddyy(i,27))*cdfits
      grad(i,100)=fdscond(i,52)*density(inddyy(i,28))*cdfits
      grad(i,101)=fdscond(i,53)*density(inddyy(i,29))*cdfits
      grad(i,102)=fdscond(i,54)*density(inddyy(i,30))*cdfits
      grad(i,103)=fdscond(i,55)*density(inddyy(i,31))*cdfits
      grad(i,104)=fdscond(i,56)*density(inddyy(i,32))*cdfits
      grad(i,105)=fdscond(i,57)*density(inddyy(i,33))*cdfits
      grad(i,106)=fdscond(i,58)*density(inddyy(i,34))*cdfits
      grad(i,107)=fdscond(i,59)*density(inddyy(i,35))*cdfits
 1019 grad(i,108)=fdscond(i,60)*density(inddyy(i,36))*cdfits

      do 1020 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1020 continue

      do 1021 k=1,3
      do 1021 j=1,36
      do 1021 i=1,m
 1021 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1022 k=1,3
      do 1022 j=1,36
      do 1022 i=1,m
 1022 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,36*(k-1)+j)

      do 2001 l=1,3

      do 1023 i=1,m
      grad(i,001)=fdpcond(i,000+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,002)=fdpcond(i,003+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,003)=fdpcond(i,006+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,004)=fdpcond(i,009+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,005)=fdpcond(i,012+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,006)=fdpcond(i,015+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,007)=fdpcond(i,018+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,008)=fdpcond(i,021+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,009)=fdpcond(i,024+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,010)=fdpcond(i,027+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,011)=fdpcond(i,030+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,012)=fdpcond(i,033+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,013)=fdpcond(i,036+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,014)=fdpcond(i,039+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,015)=fdpcond(i,042+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,016)=fdpcond(i,045+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,017)=fdpcond(i,048+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,018)=fdpcond(i,051+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,019)=fdpcond(i,054+l)*density(inddyy(i,19))*cdfitp(l)
      grad(i,020)=fdpcond(i,057+l)*density(inddyy(i,20))*cdfitp(l)
      grad(i,021)=fdpcond(i,060+l)*density(inddyy(i,21))*cdfitp(l)
      grad(i,022)=fdpcond(i,063+l)*density(inddyy(i,22))*cdfitp(l)
      grad(i,023)=fdpcond(i,066+l)*density(inddyy(i,23))*cdfitp(l)
      grad(i,024)=fdpcond(i,069+l)*density(inddyy(i,24))*cdfitp(l)
      grad(i,025)=fdpcond(i,072+l)*density(inddyy(i,25))*cdfitp(l)
      grad(i,026)=fdpcond(i,075+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,027)=fdpcond(i,078+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,028)=fdpcond(i,081+l)*density(inddyy(i,28))*cdfitp(l)
      grad(i,029)=fdpcond(i,084+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,030)=fdpcond(i,087+l)*density(inddyy(i,30))*cdfitp(l)
      grad(i,031)=fdpcond(i,090+l)*density(inddyy(i,31))*cdfitp(l)
      grad(i,032)=fdpcond(i,093+l)*density(inddyy(i,32))*cdfitp(l)
      grad(i,033)=fdpcond(i,096+l)*density(inddyy(i,33))*cdfitp(l)
      grad(i,034)=fdpcond(i,099+l)*density(inddyy(i,34))*cdfitp(l)
      grad(i,035)=fdpcond(i,102+l)*density(inddyy(i,35))*cdfitp(l)
      grad(i,036)=fdpcond(i,105+l)*density(inddyy(i,36))*cdfitp(l)
      grad(i,037)=fdpcond(i,018+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,038)=fdpcond(i,021+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,039)=fdpcond(i,024+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,040)=fdpcond(i,027+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,041)=fdpcond(i,030+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,042)=fdpcond(i,033+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,043)=fdpcond(i,054+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,044)=fdpcond(i,057+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,045)=fdpcond(i,060+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,046)=fdpcond(i,063+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,047)=fdpcond(i,066+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,048)=fdpcond(i,069+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,049)=fdpcond(i,072+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,050)=fdpcond(i,075+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,051)=fdpcond(i,078+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,052)=fdpcond(i,081+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,053)=fdpcond(i,084+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,054)=fdpcond(i,087+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,055)=fdpcond(i,108+l)*density(inddyy(i,19))*cdfitp(l)
      grad(i,056)=fdpcond(i,111+l)*density(inddyy(i,20))*cdfitp(l)
      grad(i,057)=fdpcond(i,114+l)*density(inddyy(i,21))*cdfitp(l)
      grad(i,058)=fdpcond(i,117+l)*density(inddyy(i,22))*cdfitp(l)
      grad(i,059)=fdpcond(i,120+l)*density(inddyy(i,23))*cdfitp(l)
      grad(i,060)=fdpcond(i,123+l)*density(inddyy(i,24))*cdfitp(l)
      grad(i,061)=fdpcond(i,126+l)*density(inddyy(i,25))*cdfitp(l)
      grad(i,062)=fdpcond(i,129+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,063)=fdpcond(i,132+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,064)=fdpcond(i,135+l)*density(inddyy(i,28))*cdfitp(l)
      grad(i,065)=fdpcond(i,138+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,066)=fdpcond(i,141+l)*density(inddyy(i,30))*cdfitp(l)
      grad(i,067)=fdpcond(i,144+l)*density(inddyy(i,31))*cdfitp(l)
      grad(i,068)=fdpcond(i,147+l)*density(inddyy(i,32))*cdfitp(l)
      grad(i,069)=fdpcond(i,150+l)*density(inddyy(i,33))*cdfitp(l)
      grad(i,070)=fdpcond(i,153+l)*density(inddyy(i,34))*cdfitp(l)
      grad(i,071)=fdpcond(i,156+l)*density(inddyy(i,35))*cdfitp(l)
      grad(i,072)=fdpcond(i,159+l)*density(inddyy(i,36))*cdfitp(l)
      grad(i,073)=fdpcond(i,036+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,074)=fdpcond(i,039+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,075)=fdpcond(i,042+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,076)=fdpcond(i,045+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,077)=fdpcond(i,048+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,078)=fdpcond(i,051+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,079)=fdpcond(i,072+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,080)=fdpcond(i,075+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,081)=fdpcond(i,078+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,082)=fdpcond(i,081+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,083)=fdpcond(i,084+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,084)=fdpcond(i,087+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,085)=fdpcond(i,090+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,086)=fdpcond(i,093+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,087)=fdpcond(i,096+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,088)=fdpcond(i,099+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,089)=fdpcond(i,102+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,090)=fdpcond(i,105+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,091)=fdpcond(i,126+l)*density(inddyy(i,19))*cdfitp(l)
      grad(i,092)=fdpcond(i,129+l)*density(inddyy(i,20))*cdfitp(l)
      grad(i,093)=fdpcond(i,132+l)*density(inddyy(i,21))*cdfitp(l)
      grad(i,094)=fdpcond(i,135+l)*density(inddyy(i,22))*cdfitp(l)
      grad(i,095)=fdpcond(i,138+l)*density(inddyy(i,23))*cdfitp(l)
      grad(i,096)=fdpcond(i,141+l)*density(inddyy(i,24))*cdfitp(l)
      grad(i,097)=fdpcond(i,144+l)*density(inddyy(i,25))*cdfitp(l)
      grad(i,098)=fdpcond(i,147+l)*density(inddyy(i,26))*cdfitp(l)
      grad(i,099)=fdpcond(i,150+l)*density(inddyy(i,27))*cdfitp(l)
      grad(i,100)=fdpcond(i,153+l)*density(inddyy(i,28))*cdfitp(l)
      grad(i,101)=fdpcond(i,156+l)*density(inddyy(i,29))*cdfitp(l)
      grad(i,102)=fdpcond(i,159+l)*density(inddyy(i,30))*cdfitp(l)
      grad(i,103)=fdpcond(i,162+l)*density(inddyy(i,31))*cdfitp(l)
      grad(i,104)=fdpcond(i,165+l)*density(inddyy(i,32))*cdfitp(l)
      grad(i,105)=fdpcond(i,168+l)*density(inddyy(i,33))*cdfitp(l)
      grad(i,106)=fdpcond(i,171+l)*density(inddyy(i,34))*cdfitp(l)
      grad(i,107)=fdpcond(i,174+l)*density(inddyy(i,35))*cdfitp(l)
 1023 grad(i,108)=fdpcond(i,177+l)*density(inddyy(i,36))*cdfitp(l)

      do 1024 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1024 continue

      do 1025 k=1,3
      do 1025 j=1,36
      do 1025 i=1,m
 1025 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1026 k=1,3
      do 1026 j=1,36
      do 1026 i=1,m
 1026 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,36*(k-1)+j)

 2001 continue

      do 2002 l=1,6

      do 1027 i=1,m
      grad(i,001)=fddcond(i,000+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,002)=fddcond(i,006+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,003)=fddcond(i,012+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,004)=fddcond(i,018+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,005)=fddcond(i,024+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,006)=fddcond(i,030+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,007)=fddcond(i,036+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,008)=fddcond(i,042+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,009)=fddcond(i,048+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,010)=fddcond(i,054+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,011)=fddcond(i,060+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,012)=fddcond(i,066+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,013)=fddcond(i,072+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,014)=fddcond(i,078+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,015)=fddcond(i,084+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,016)=fddcond(i,090+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,017)=fddcond(i,096+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,018)=fddcond(i,102+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,019)=fddcond(i,108+l)*density(inddyy(i,19))*cdfitd(l)
      grad(i,020)=fddcond(i,114+l)*density(inddyy(i,20))*cdfitd(l)
      grad(i,021)=fddcond(i,120+l)*density(inddyy(i,21))*cdfitd(l)
      grad(i,022)=fddcond(i,126+l)*density(inddyy(i,22))*cdfitd(l)
      grad(i,023)=fddcond(i,132+l)*density(inddyy(i,23))*cdfitd(l)
      grad(i,024)=fddcond(i,138+l)*density(inddyy(i,24))*cdfitd(l)
      grad(i,025)=fddcond(i,144+l)*density(inddyy(i,25))*cdfitd(l)
      grad(i,026)=fddcond(i,150+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,027)=fddcond(i,156+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,028)=fddcond(i,162+l)*density(inddyy(i,28))*cdfitd(l)
      grad(i,029)=fddcond(i,168+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,030)=fddcond(i,174+l)*density(inddyy(i,30))*cdfitd(l)
      grad(i,031)=fddcond(i,180+l)*density(inddyy(i,31))*cdfitd(l)
      grad(i,032)=fddcond(i,186+l)*density(inddyy(i,32))*cdfitd(l)
      grad(i,033)=fddcond(i,192+l)*density(inddyy(i,33))*cdfitd(l)
      grad(i,034)=fddcond(i,198+l)*density(inddyy(i,34))*cdfitd(l)
      grad(i,035)=fddcond(i,204+l)*density(inddyy(i,35))*cdfitd(l)
      grad(i,036)=fddcond(i,210+l)*density(inddyy(i,36))*cdfitd(l)
      grad(i,037)=fddcond(i,036+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,038)=fddcond(i,042+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,039)=fddcond(i,048+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,040)=fddcond(i,054+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,041)=fddcond(i,060+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,042)=fddcond(i,066+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,043)=fddcond(i,108+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,044)=fddcond(i,114+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,045)=fddcond(i,120+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,046)=fddcond(i,126+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,047)=fddcond(i,132+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,048)=fddcond(i,138+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,049)=fddcond(i,144+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,050)=fddcond(i,150+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,051)=fddcond(i,156+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,052)=fddcond(i,162+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,053)=fddcond(i,168+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,054)=fddcond(i,174+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,055)=fddcond(i,216+l)*density(inddyy(i,19))*cdfitd(l)
      grad(i,056)=fddcond(i,222+l)*density(inddyy(i,20))*cdfitd(l)
      grad(i,057)=fddcond(i,228+l)*density(inddyy(i,21))*cdfitd(l)
      grad(i,058)=fddcond(i,234+l)*density(inddyy(i,22))*cdfitd(l)
      grad(i,059)=fddcond(i,240+l)*density(inddyy(i,23))*cdfitd(l)
      grad(i,060)=fddcond(i,246+l)*density(inddyy(i,24))*cdfitd(l)
      grad(i,061)=fddcond(i,252+l)*density(inddyy(i,25))*cdfitd(l)
      grad(i,062)=fddcond(i,258+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,063)=fddcond(i,264+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,064)=fddcond(i,270+l)*density(inddyy(i,28))*cdfitd(l)
      grad(i,065)=fddcond(i,276+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,066)=fddcond(i,282+l)*density(inddyy(i,30))*cdfitd(l)
      grad(i,067)=fddcond(i,288+l)*density(inddyy(i,31))*cdfitd(l)
      grad(i,068)=fddcond(i,294+l)*density(inddyy(i,32))*cdfitd(l)
      grad(i,069)=fddcond(i,300+l)*density(inddyy(i,33))*cdfitd(l)
      grad(i,070)=fddcond(i,306+l)*density(inddyy(i,34))*cdfitd(l)
      grad(i,071)=fddcond(i,312+l)*density(inddyy(i,35))*cdfitd(l)
      grad(i,072)=fddcond(i,318+l)*density(inddyy(i,36))*cdfitd(l)
      grad(i,073)=fddcond(i,072+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,074)=fddcond(i,078+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,075)=fddcond(i,084+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,076)=fddcond(i,090+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,077)=fddcond(i,096+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,078)=fddcond(i,102+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,079)=fddcond(i,144+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,080)=fddcond(i,150+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,081)=fddcond(i,156+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,082)=fddcond(i,162+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,083)=fddcond(i,168+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,084)=fddcond(i,174+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,085)=fddcond(i,180+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,086)=fddcond(i,186+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,087)=fddcond(i,192+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,088)=fddcond(i,198+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,089)=fddcond(i,204+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,090)=fddcond(i,210+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,091)=fddcond(i,252+l)*density(inddyy(i,19))*cdfitd(l)
      grad(i,092)=fddcond(i,258+l)*density(inddyy(i,20))*cdfitd(l)
      grad(i,093)=fddcond(i,264+l)*density(inddyy(i,21))*cdfitd(l)
      grad(i,094)=fddcond(i,270+l)*density(inddyy(i,22))*cdfitd(l)
      grad(i,095)=fddcond(i,276+l)*density(inddyy(i,23))*cdfitd(l)
      grad(i,096)=fddcond(i,282+l)*density(inddyy(i,24))*cdfitd(l)
      grad(i,097)=fddcond(i,288+l)*density(inddyy(i,25))*cdfitd(l)
      grad(i,098)=fddcond(i,294+l)*density(inddyy(i,26))*cdfitd(l)
      grad(i,099)=fddcond(i,300+l)*density(inddyy(i,27))*cdfitd(l)
      grad(i,100)=fddcond(i,306+l)*density(inddyy(i,28))*cdfitd(l)
      grad(i,101)=fddcond(i,312+l)*density(inddyy(i,29))*cdfitd(l)
      grad(i,102)=fddcond(i,318+l)*density(inddyy(i,30))*cdfitd(l)
      grad(i,103)=fddcond(i,324+l)*density(inddyy(i,31))*cdfitd(l)
      grad(i,104)=fddcond(i,330+l)*density(inddyy(i,32))*cdfitd(l)
      grad(i,105)=fddcond(i,336+l)*density(inddyy(i,33))*cdfitd(l)
      grad(i,106)=fddcond(i,342+l)*density(inddyy(i,34))*cdfitd(l)
      grad(i,107)=fddcond(i,348+l)*density(inddyy(i,35))*cdfitd(l)
 1027 grad(i,108)=fddcond(i,354+l)*density(inddyy(i,36))*cdfitd(l)

      do 1028 i=1,m
      if(iminj(i).eq.0) then
                              grad(i,002)=zero
                              grad(i,003)=zero
                              grad(i,004)=zero
                              grad(i,005)=zero
                              grad(i,006)=zero
                              grad(i,009)=zero
                              grad(i,010)=zero
                              grad(i,011)=zero
                              grad(i,012)=zero
                              grad(i,016)=zero
                              grad(i,017)=zero
                              grad(i,018)=zero
                              grad(i,023)=zero
                              grad(i,024)=zero
                              grad(i,030)=zero
                              grad(i,038)=zero
                              grad(i,039)=zero
                              grad(i,040)=zero
                              grad(i,041)=zero
                              grad(i,042)=zero
                              grad(i,045)=zero
                              grad(i,046)=zero
                              grad(i,047)=zero
                              grad(i,048)=zero
                              grad(i,052)=zero
                              grad(i,053)=zero
                              grad(i,054)=zero
                              grad(i,059)=zero
                              grad(i,060)=zero
                              grad(i,066)=zero
                              grad(i,074)=zero
                              grad(i,075)=zero
                              grad(i,076)=zero
                              grad(i,077)=zero
                              grad(i,078)=zero
                              grad(i,081)=zero
                              grad(i,082)=zero
                              grad(i,083)=zero
                              grad(i,084)=zero
                              grad(i,088)=zero
                              grad(i,089)=zero
                              grad(i,090)=zero
                              grad(i,095)=zero
                              grad(i,096)=zero
                              grad(i,102)=zero
                        endif
 1028 continue

      do 1029 k=1,3
      do 1029 j=1,36
      do 1029 i=1,m
 1029 gradient(k,nc)=gradient(k,nc)-grad(i,36*(k-1)+j)

      do 1030 k=1,3
      do 1030 j=1,36
      do 1030 i=1,m
 1030 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,36*(k-1)+j)

 2002 continue

      return
      end
