      subroutine gradxxdp1(m,n,nn,nc,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,pss0,psp0,
     &                     psd0,dss0,dsp0,dsd0,axbx,ayby,azbz,psscond,
     &                     pspcond,psdcond,dsscond,dspcond,dsdcond,
     &                     ppscond,pppcond,ppdcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),pss0(n,*),
     &          psp0(n,*),psd0(n,*),dss0(n,*),dsp0(n,*),dsd0(n,*),
     &          axbx(*),ayby(*),azbz(*),psscond(m,*),pspcond(m,*),
     &          psdcond(m,*),dsscond(m,*),dspcond(m,*),dsdcond(m,*),
     &          ppscond(m,*),pppcond(m,*),ppdcond(m,*),grad(m,*)

      data zero,two/0.0,2.0/

      do 1001 j=1,3
      do 1001 i=1,m
 1001 psscond(i,j)=zero

      do 1002 j=1,9
      do 1002 i=1,m
 1002 pspcond(i,j)=zero

      do 1003 j=1,18
      do 1003 i=1,m
 1003 psdcond(i,j)=zero

      do 1004 j=1,6
      do 1004 i=1,m
 1004 dsscond(i,j)=zero

      do 1005 j=1,18
      do 1005 i=1,m
 1005 dspcond(i,j)=zero

      do 1006 j=1,36
      do 1006 i=1,m
 1006 dsdcond(i,j)=zero

      do 1007 j=1,3
      do 1007 i=1,nn
 1007 psscond(iicontr(i),j)=psscond(iicontr(i),j)-pss0(i,j)

      do 1008 j=1,9
      do 1008 i=1,nn
 1008 pspcond(iicontr(i),j)=pspcond(iicontr(i),j)-psp0(i,j)

      do 1009 j=1,18
      do 1009 i=1,nn
 1009 psdcond(iicontr(i),j)=psdcond(iicontr(i),j)-psd0(i,j)

      do 1010 j=1,6
      do 1010 i=1,nn
 1010 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)-dss0(i,j)

      do 1011 j=1,18
      do 1011 i=1,nn
 1011 dspcond(iicontr(i),j)=dspcond(iicontr(i),j)-dsp0(i,j)

      do 1012 j=1,36
      do 1012 i=1,nn
 1012 dsdcond(iicontr(i),j)=dsdcond(iicontr(i),j)-dsd0(i,j)

      do 1013 i=1,m
      ppscond(i,1)=axbx(i)*psscond(i,1)+dsscond(i,1)
      ppscond(i,2)=ayby(i)*psscond(i,1)+dsscond(i,2)
      ppscond(i,3)=azbz(i)*psscond(i,1)+dsscond(i,3)
      ppscond(i,4)=axbx(i)*psscond(i,2)+dsscond(i,2)
      ppscond(i,5)=ayby(i)*psscond(i,2)+dsscond(i,4)
      ppscond(i,6)=azbz(i)*psscond(i,2)+dsscond(i,5)
      ppscond(i,7)=axbx(i)*psscond(i,3)+dsscond(i,3)
      ppscond(i,8)=ayby(i)*psscond(i,3)+dsscond(i,5)
 1013 ppscond(i,9)=azbz(i)*psscond(i,3)+dsscond(i,6)

      do 1014 i=1,m
      pppcond(i,01)=axbx(i)*pspcond(i,1)+dspcond(i,01)
      pppcond(i,02)=axbx(i)*pspcond(i,2)+dspcond(i,02)
      pppcond(i,03)=axbx(i)*pspcond(i,3)+dspcond(i,03)
      pppcond(i,04)=ayby(i)*pspcond(i,1)+dspcond(i,04)
      pppcond(i,05)=ayby(i)*pspcond(i,2)+dspcond(i,05)
      pppcond(i,06)=ayby(i)*pspcond(i,3)+dspcond(i,06)
      pppcond(i,07)=azbz(i)*pspcond(i,1)+dspcond(i,07)
      pppcond(i,08)=azbz(i)*pspcond(i,2)+dspcond(i,08)
      pppcond(i,09)=azbz(i)*pspcond(i,3)+dspcond(i,09)
      pppcond(i,10)=axbx(i)*pspcond(i,4)+dspcond(i,04)
      pppcond(i,11)=axbx(i)*pspcond(i,5)+dspcond(i,05)
      pppcond(i,12)=axbx(i)*pspcond(i,6)+dspcond(i,06)
      pppcond(i,13)=ayby(i)*pspcond(i,4)+dspcond(i,10)
      pppcond(i,14)=ayby(i)*pspcond(i,5)+dspcond(i,11)
      pppcond(i,15)=ayby(i)*pspcond(i,6)+dspcond(i,12)
      pppcond(i,16)=azbz(i)*pspcond(i,4)+dspcond(i,13)
      pppcond(i,17)=azbz(i)*pspcond(i,5)+dspcond(i,14)
      pppcond(i,18)=azbz(i)*pspcond(i,6)+dspcond(i,15)
      pppcond(i,19)=axbx(i)*pspcond(i,7)+dspcond(i,07)
      pppcond(i,20)=axbx(i)*pspcond(i,8)+dspcond(i,08)
      pppcond(i,21)=axbx(i)*pspcond(i,9)+dspcond(i,09)
      pppcond(i,22)=ayby(i)*pspcond(i,7)+dspcond(i,13)
      pppcond(i,23)=ayby(i)*pspcond(i,8)+dspcond(i,14)
      pppcond(i,24)=ayby(i)*pspcond(i,9)+dspcond(i,15)
      pppcond(i,25)=azbz(i)*pspcond(i,7)+dspcond(i,16)
      pppcond(i,26)=azbz(i)*pspcond(i,8)+dspcond(i,17)
 1014 pppcond(i,27)=azbz(i)*pspcond(i,9)+dspcond(i,18)

      do 1015 i=1,m
      ppdcond(i,01)=axbx(i)*psdcond(i,01)+dsdcond(i,01)
      ppdcond(i,02)=axbx(i)*psdcond(i,02)+dsdcond(i,02)
      ppdcond(i,03)=axbx(i)*psdcond(i,03)+dsdcond(i,03)
      ppdcond(i,04)=axbx(i)*psdcond(i,04)+dsdcond(i,04)
      ppdcond(i,05)=axbx(i)*psdcond(i,05)+dsdcond(i,05)
      ppdcond(i,06)=axbx(i)*psdcond(i,06)+dsdcond(i,06)
      ppdcond(i,07)=ayby(i)*psdcond(i,01)+dsdcond(i,07)
      ppdcond(i,08)=ayby(i)*psdcond(i,02)+dsdcond(i,08)
      ppdcond(i,09)=ayby(i)*psdcond(i,03)+dsdcond(i,09)
      ppdcond(i,10)=ayby(i)*psdcond(i,04)+dsdcond(i,10)
      ppdcond(i,11)=ayby(i)*psdcond(i,05)+dsdcond(i,11)
      ppdcond(i,12)=ayby(i)*psdcond(i,06)+dsdcond(i,12)
      ppdcond(i,13)=azbz(i)*psdcond(i,01)+dsdcond(i,13)
      ppdcond(i,14)=azbz(i)*psdcond(i,02)+dsdcond(i,14)
      ppdcond(i,15)=azbz(i)*psdcond(i,03)+dsdcond(i,15)
      ppdcond(i,16)=azbz(i)*psdcond(i,04)+dsdcond(i,16)
      ppdcond(i,17)=azbz(i)*psdcond(i,05)+dsdcond(i,17)
      ppdcond(i,18)=azbz(i)*psdcond(i,06)+dsdcond(i,18)
      ppdcond(i,19)=axbx(i)*psdcond(i,07)+dsdcond(i,07)
      ppdcond(i,20)=axbx(i)*psdcond(i,08)+dsdcond(i,08)
      ppdcond(i,21)=axbx(i)*psdcond(i,09)+dsdcond(i,09)
      ppdcond(i,22)=axbx(i)*psdcond(i,10)+dsdcond(i,10)
      ppdcond(i,23)=axbx(i)*psdcond(i,11)+dsdcond(i,11)
      ppdcond(i,24)=axbx(i)*psdcond(i,12)+dsdcond(i,12)
      ppdcond(i,25)=ayby(i)*psdcond(i,07)+dsdcond(i,19)
      ppdcond(i,26)=ayby(i)*psdcond(i,08)+dsdcond(i,20)
      ppdcond(i,27)=ayby(i)*psdcond(i,09)+dsdcond(i,21)
      ppdcond(i,28)=ayby(i)*psdcond(i,10)+dsdcond(i,22)
      ppdcond(i,29)=ayby(i)*psdcond(i,11)+dsdcond(i,23)
      ppdcond(i,30)=ayby(i)*psdcond(i,12)+dsdcond(i,24)
      ppdcond(i,31)=azbz(i)*psdcond(i,07)+dsdcond(i,25)
      ppdcond(i,32)=azbz(i)*psdcond(i,08)+dsdcond(i,26)
      ppdcond(i,33)=azbz(i)*psdcond(i,09)+dsdcond(i,27)
      ppdcond(i,34)=azbz(i)*psdcond(i,10)+dsdcond(i,28)
      ppdcond(i,35)=azbz(i)*psdcond(i,11)+dsdcond(i,29)
      ppdcond(i,36)=azbz(i)*psdcond(i,12)+dsdcond(i,30)
      ppdcond(i,37)=axbx(i)*psdcond(i,13)+dsdcond(i,13)
      ppdcond(i,38)=axbx(i)*psdcond(i,14)+dsdcond(i,14)
      ppdcond(i,39)=axbx(i)*psdcond(i,15)+dsdcond(i,15)
      ppdcond(i,40)=axbx(i)*psdcond(i,16)+dsdcond(i,16)
      ppdcond(i,41)=axbx(i)*psdcond(i,17)+dsdcond(i,17)
      ppdcond(i,42)=axbx(i)*psdcond(i,18)+dsdcond(i,18)
      ppdcond(i,43)=ayby(i)*psdcond(i,13)+dsdcond(i,25)
      ppdcond(i,44)=ayby(i)*psdcond(i,14)+dsdcond(i,26)
      ppdcond(i,45)=ayby(i)*psdcond(i,15)+dsdcond(i,27)
      ppdcond(i,46)=ayby(i)*psdcond(i,16)+dsdcond(i,28)
      ppdcond(i,47)=ayby(i)*psdcond(i,17)+dsdcond(i,29)
      ppdcond(i,48)=ayby(i)*psdcond(i,18)+dsdcond(i,30)
      ppdcond(i,49)=azbz(i)*psdcond(i,13)+dsdcond(i,31)
      ppdcond(i,50)=azbz(i)*psdcond(i,14)+dsdcond(i,32)
      ppdcond(i,51)=azbz(i)*psdcond(i,15)+dsdcond(i,33)
      ppdcond(i,52)=azbz(i)*psdcond(i,16)+dsdcond(i,34)
      ppdcond(i,53)=azbz(i)*psdcond(i,17)+dsdcond(i,35)
 1015 ppdcond(i,54)=azbz(i)*psdcond(i,18)+dsdcond(i,36)

      do 1016 i=1,m
      grad(i,01)=ppscond(i,1)*density(inddyy(i,01))*cdfits*two
      grad(i,02)=ppscond(i,2)*density(inddyy(i,02))*cdfits*two
      grad(i,03)=ppscond(i,3)*density(inddyy(i,03))*cdfits*two
      grad(i,04)=ppscond(i,4)*density(inddyy(i,04))*cdfits
      grad(i,05)=ppscond(i,5)*density(inddyy(i,05))*cdfits
      grad(i,06)=ppscond(i,6)*density(inddyy(i,06))*cdfits
      grad(i,07)=ppscond(i,7)*density(inddyy(i,07))*cdfits
      grad(i,08)=ppscond(i,8)*density(inddyy(i,08))*cdfits
      grad(i,09)=ppscond(i,9)*density(inddyy(i,09))*cdfits
      grad(i,10)=ppscond(i,1)*density(inddyy(i,04))*cdfits
      grad(i,11)=ppscond(i,2)*density(inddyy(i,05))*cdfits
      grad(i,12)=ppscond(i,3)*density(inddyy(i,06))*cdfits
      grad(i,13)=ppscond(i,4)*density(inddyy(i,10))*cdfits*two
      grad(i,14)=ppscond(i,5)*density(inddyy(i,11))*cdfits*two
      grad(i,15)=ppscond(i,6)*density(inddyy(i,12))*cdfits*two
      grad(i,16)=ppscond(i,7)*density(inddyy(i,13))*cdfits
      grad(i,17)=ppscond(i,8)*density(inddyy(i,14))*cdfits
      grad(i,18)=ppscond(i,9)*density(inddyy(i,15))*cdfits
      grad(i,19)=ppscond(i,1)*density(inddyy(i,07))*cdfits
      grad(i,20)=ppscond(i,2)*density(inddyy(i,08))*cdfits
      grad(i,21)=ppscond(i,3)*density(inddyy(i,09))*cdfits
      grad(i,22)=ppscond(i,4)*density(inddyy(i,13))*cdfits
      grad(i,23)=ppscond(i,5)*density(inddyy(i,14))*cdfits
      grad(i,24)=ppscond(i,6)*density(inddyy(i,15))*cdfits
      grad(i,25)=ppscond(i,7)*density(inddyy(i,16))*cdfits*two
      grad(i,26)=ppscond(i,8)*density(inddyy(i,17))*cdfits*two
 1016 grad(i,27)=ppscond(i,9)*density(inddyy(i,18))*cdfits*two

      do 1017 k=1,3
      do 1017 j=1,9
      do 1017 i=1,m
 1017 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1018 k=1,3
      do 1018 j=1,9
      do 1018 i=1,m
 1018 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

      do 2001 l=1,3

      do 1019 i=1,m
      grad(i,01)=pppcond(i,00+l)*density(inddyy(i,01))*cdfitp(l)*two
      grad(i,02)=pppcond(i,03+l)*density(inddyy(i,02))*cdfitp(l)*two
      grad(i,03)=pppcond(i,06+l)*density(inddyy(i,03))*cdfitp(l)*two
      grad(i,04)=pppcond(i,09+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,05)=pppcond(i,12+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,06)=pppcond(i,15+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,07)=pppcond(i,18+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,08)=pppcond(i,21+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,09)=pppcond(i,24+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,10)=pppcond(i,00+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,11)=pppcond(i,03+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,12)=pppcond(i,06+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,13)=pppcond(i,09+l)*density(inddyy(i,10))*cdfitp(l)*two
      grad(i,14)=pppcond(i,12+l)*density(inddyy(i,11))*cdfitp(l)*two
      grad(i,15)=pppcond(i,15+l)*density(inddyy(i,12))*cdfitp(l)*two
      grad(i,16)=pppcond(i,18+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,17)=pppcond(i,21+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,18)=pppcond(i,24+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,19)=pppcond(i,00+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,20)=pppcond(i,03+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,21)=pppcond(i,06+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,22)=pppcond(i,09+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,23)=pppcond(i,12+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,24)=pppcond(i,15+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,25)=pppcond(i,18+l)*density(inddyy(i,16))*cdfitp(l)*two
      grad(i,26)=pppcond(i,21+l)*density(inddyy(i,17))*cdfitp(l)*two
 1019 grad(i,27)=pppcond(i,24+l)*density(inddyy(i,18))*cdfitp(l)*two

      do 1020 k=1,3
      do 1020 j=1,9
      do 1020 i=1,m
 1020 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1021 k=1,3
      do 1021 j=1,9
      do 1021 i=1,m
 1021 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

 2001 continue

      do 2002 l=1,6

      do 1022 i=1,m
      grad(i,01)=ppdcond(i,00+l)*density(inddyy(i,01))*cdfitd(l)*two
      grad(i,02)=ppdcond(i,06+l)*density(inddyy(i,02))*cdfitd(l)*two
      grad(i,03)=ppdcond(i,12+l)*density(inddyy(i,03))*cdfitd(l)*two
      grad(i,04)=ppdcond(i,18+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,05)=ppdcond(i,24+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,06)=ppdcond(i,30+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,07)=ppdcond(i,36+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,08)=ppdcond(i,42+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,09)=ppdcond(i,48+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,10)=ppdcond(i,00+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,11)=ppdcond(i,06+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,12)=ppdcond(i,12+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,13)=ppdcond(i,18+l)*density(inddyy(i,10))*cdfitd(l)*two
      grad(i,14)=ppdcond(i,24+l)*density(inddyy(i,11))*cdfitd(l)*two
      grad(i,15)=ppdcond(i,30+l)*density(inddyy(i,12))*cdfitd(l)*two
      grad(i,16)=ppdcond(i,36+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,17)=ppdcond(i,42+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,18)=ppdcond(i,48+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,19)=ppdcond(i,00+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,20)=ppdcond(i,06+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,21)=ppdcond(i,12+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,22)=ppdcond(i,18+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,23)=ppdcond(i,24+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,24)=ppdcond(i,30+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,25)=ppdcond(i,36+l)*density(inddyy(i,16))*cdfitd(l)*two
      grad(i,26)=ppdcond(i,42+l)*density(inddyy(i,17))*cdfitd(l)*two
 1022 grad(i,27)=ppdcond(i,48+l)*density(inddyy(i,18))*cdfitd(l)*two

      do 1023 k=1,3
      do 1023 j=1,9
      do 1023 i=1,m
 1023 gradient(k,nc)=gradient(k,nc)-grad(i,9*(k-1)+j)

      do 1024 k=1,3
      do 1024 j=1,9
      do 1024 i=1,m
 1024 gradient(k,icentr(i,1))=gradient(k,icentr(i,1))+grad(i,9*(k-1)+j)

 2002 continue

      do 1025 i=1,m
      grad(i,01)=dsscond(i,1)*density(inddyy(i,01))*cdfits
      grad(i,02)=dsscond(i,2)*density(inddyy(i,04))*cdfits
      grad(i,03)=dsscond(i,3)*density(inddyy(i,07))*cdfits
      grad(i,04)=dsscond(i,4)*density(inddyy(i,10))*cdfits
      grad(i,05)=dsscond(i,5)*density(inddyy(i,13))*cdfits
      grad(i,06)=dsscond(i,6)*density(inddyy(i,16))*cdfits
      grad(i,07)=dsscond(i,1)*density(inddyy(i,02))*cdfits
      grad(i,08)=dsscond(i,2)*density(inddyy(i,05))*cdfits
      grad(i,09)=dsscond(i,3)*density(inddyy(i,08))*cdfits
      grad(i,10)=dsscond(i,4)*density(inddyy(i,11))*cdfits
      grad(i,11)=dsscond(i,5)*density(inddyy(i,14))*cdfits
      grad(i,12)=dsscond(i,6)*density(inddyy(i,17))*cdfits
      grad(i,13)=dsscond(i,1)*density(inddyy(i,03))*cdfits
      grad(i,14)=dsscond(i,2)*density(inddyy(i,06))*cdfits
      grad(i,15)=dsscond(i,3)*density(inddyy(i,09))*cdfits
      grad(i,16)=dsscond(i,4)*density(inddyy(i,12))*cdfits
      grad(i,17)=dsscond(i,5)*density(inddyy(i,15))*cdfits
 1025 grad(i,18)=dsscond(i,6)*density(inddyy(i,18))*cdfits

      do 1026 k=1,3
      do 1026 j=1,6
      do 1026 i=1,m
 1026 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1027 k=1,3
      do 1027 j=1,6
      do 1027 i=1,m
 1027 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

      do 2003 l=1,3

      do 1028 i=1,m
      grad(i,01)=dspcond(i,00+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,02)=dspcond(i,03+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,03)=dspcond(i,06+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,04)=dspcond(i,09+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,05)=dspcond(i,12+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,06)=dspcond(i,15+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,07)=dspcond(i,00+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,08)=dspcond(i,03+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,09)=dspcond(i,06+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,10)=dspcond(i,09+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,11)=dspcond(i,12+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,12)=dspcond(i,15+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,13)=dspcond(i,00+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,14)=dspcond(i,03+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,15)=dspcond(i,06+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,16)=dspcond(i,09+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,17)=dspcond(i,12+l)*density(inddyy(i,15))*cdfitp(l)
 1028 grad(i,18)=dspcond(i,15+l)*density(inddyy(i,18))*cdfitp(l)

      do 1029 k=1,3
      do 1029 j=1,6
      do 1029 i=1,m
 1029 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1030 k=1,3
      do 1030 j=1,6
      do 1030 i=1,m
 1030 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

 2003 continue

      do 2004 l=1,6

      do 1031 i=1,m
      grad(i,01)=dsdcond(i,00+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,02)=dsdcond(i,06+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,03)=dsdcond(i,12+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,04)=dsdcond(i,18+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,05)=dsdcond(i,24+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,06)=dsdcond(i,30+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,07)=dsdcond(i,00+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,08)=dsdcond(i,06+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,09)=dsdcond(i,12+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,10)=dsdcond(i,18+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,11)=dsdcond(i,24+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,12)=dsdcond(i,30+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,13)=dsdcond(i,00+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,14)=dsdcond(i,06+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,15)=dsdcond(i,12+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,16)=dsdcond(i,18+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,17)=dsdcond(i,24+l)*density(inddyy(i,15))*cdfitd(l)
 1031 grad(i,18)=dsdcond(i,30+l)*density(inddyy(i,18))*cdfitd(l)

      do 1032 k=1,3
      do 1032 j=1,6
      do 1032 i=1,m
 1032 gradient(k,nc)=gradient(k,nc)-grad(i,6*(k-1)+j)

      do 1033 k=1,3
      do 1033 j=1,6
      do 1033 i=1,m
 1033 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,6*(k-1)+j)

 2004 continue

      return
      end
