      subroutine gradxxdp3(m,n,nn,nc,inddyy,icentr,iicontr,cdfits,
     &                     cdfitp,cdfitd,gradient,density,ttwozetab,
     &                     dss0,dsp0,dsd0,fss0,fsp0,fsd0,gss0,gsp0,gsd0,
     &                     axbx,ayby,azbz,dsscond,dspcond,dsdcond,
     &                     fsscond,fspcond,fsdcond,gsscond,gspcond,
     &                     gsdcond,dpscond,dppcond,dpdcond,fpscond,
     &                     fppcond,fpdcond,ddscond,ddpcond,dddcond,grad)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension inddyy(m,*),icentr(m,*),iicontr(*)

      dimension cdfitp(*),cdfitd(*),gradient(3,*),density(*),
     &          ttwozetab(*),dss0(n,*),dsp0(n,*),dsd0(n,*),fss0(n,*),
     &          fsp0(n,*),fsd0(n,*),gss0(n,*),gsp0(n,*),gsd0(n,*),
     &          axbx(*),ayby(*),azbz(*),dsscond(m,*),dspcond(m,*),
     &          dsdcond(m,*),fsscond(m,*),fspcond(m,*),fsdcond(m,*),
     &          gsscond(m,*),gspcond(m,*),gsdcond(m,*),dpscond(m,*),
     &          dppcond(m,*),dpdcond(m,*),fpscond(m,*),fppcond(m,*),
     &          fpdcond(m,*),ddscond(m,*),ddpcond(m,*),dddcond(m,*),
     &          grad(m,*)

      data zero/0.0/

      do 1001 j=1,6
      do 1001 i=1,m
 1001 dsscond(i,j)=zero

      do 1002 j=1,18
      do 1002 i=1,m
 1002 dspcond(i,j)=zero

      do 1003 j=1,36
      do 1003 i=1,m
 1003 dsdcond(i,j)=zero

      do 1004 j=1,10
      do 1004 i=1,m
 1004 fsscond(i,j)=zero

      do 1005 j=1,30
      do 1005 i=1,m
 1005 fspcond(i,j)=zero

      do 1006 j=1,60
      do 1006 i=1,m
 1006 fsdcond(i,j)=zero

      do 1007 j=1,15
      do 1007 i=1,m
 1007 gsscond(i,j)=zero

      do 1008 j=1,45
      do 1008 i=1,m
 1008 gspcond(i,j)=zero

      do 1009 j=1,90
      do 1009 i=1,m
 1009 gsdcond(i,j)=zero

      do 1010 j=1,6
      do 1010 i=1,nn
 1010 dsscond(iicontr(i),j)=dsscond(iicontr(i),j)+dss0(i,j)*ttwozetab(i)

      do 1011 j=1,18
      do 1011 i=1,nn
 1011 dspcond(iicontr(i),j)=dspcond(iicontr(i),j)+dsp0(i,j)*ttwozetab(i)

      do 1012 j=1,36
      do 1012 i=1,nn
 1012 dsdcond(iicontr(i),j)=dsdcond(iicontr(i),j)+dsd0(i,j)*ttwozetab(i)

      do 1013 j=1,10
      do 1013 i=1,nn
 1013 fsscond(iicontr(i),j)=fsscond(iicontr(i),j)+fss0(i,j)*ttwozetab(i)

      do 1014 j=1,30
      do 1014 i=1,nn
 1014 fspcond(iicontr(i),j)=fspcond(iicontr(i),j)+fsp0(i,j)*ttwozetab(i)

      do 1015 j=1,60
      do 1015 i=1,nn
 1015 fsdcond(iicontr(i),j)=fsdcond(iicontr(i),j)+fsd0(i,j)*ttwozetab(i)

      do 1016 j=1,15
      do 1016 i=1,nn
 1016 gsscond(iicontr(i),j)=gsscond(iicontr(i),j)+gss0(i,j)*ttwozetab(i)

      do 1017 j=1,45
      do 1017 i=1,nn
 1017 gspcond(iicontr(i),j)=gspcond(iicontr(i),j)+gsp0(i,j)*ttwozetab(i)

      do 1018 j=1,90
      do 1018 i=1,nn
 1018 gsdcond(iicontr(i),j)=gsdcond(iicontr(i),j)+gsd0(i,j)*ttwozetab(i)

      do 1019 i=1,m
      dpscond(i,01)=axbx(i)*dsscond(i,1)+fsscond(i,01)
      dpscond(i,02)=ayby(i)*dsscond(i,1)+fsscond(i,02)
      dpscond(i,03)=azbz(i)*dsscond(i,1)+fsscond(i,03)
      dpscond(i,04)=axbx(i)*dsscond(i,2)+fsscond(i,02)
      dpscond(i,05)=ayby(i)*dsscond(i,2)+fsscond(i,04)
      dpscond(i,06)=azbz(i)*dsscond(i,2)+fsscond(i,05)
      dpscond(i,07)=axbx(i)*dsscond(i,3)+fsscond(i,03)
      dpscond(i,08)=ayby(i)*dsscond(i,3)+fsscond(i,05)
      dpscond(i,09)=azbz(i)*dsscond(i,3)+fsscond(i,06)
      dpscond(i,10)=axbx(i)*dsscond(i,4)+fsscond(i,04)
      dpscond(i,11)=ayby(i)*dsscond(i,4)+fsscond(i,07)
      dpscond(i,12)=azbz(i)*dsscond(i,4)+fsscond(i,08)
      dpscond(i,13)=axbx(i)*dsscond(i,5)+fsscond(i,05)
      dpscond(i,14)=ayby(i)*dsscond(i,5)+fsscond(i,08)
      dpscond(i,15)=azbz(i)*dsscond(i,5)+fsscond(i,09)
      dpscond(i,16)=axbx(i)*dsscond(i,6)+fsscond(i,06)
      dpscond(i,17)=ayby(i)*dsscond(i,6)+fsscond(i,09)
 1019 dpscond(i,18)=azbz(i)*dsscond(i,6)+fsscond(i,10)

      do 1020 i=1,m
      dppcond(i,01)=axbx(i)*dspcond(i,01)+fspcond(i,01)
      dppcond(i,02)=axbx(i)*dspcond(i,02)+fspcond(i,02)
      dppcond(i,03)=axbx(i)*dspcond(i,03)+fspcond(i,03)
      dppcond(i,04)=ayby(i)*dspcond(i,01)+fspcond(i,04)
      dppcond(i,05)=ayby(i)*dspcond(i,02)+fspcond(i,05)
      dppcond(i,06)=ayby(i)*dspcond(i,03)+fspcond(i,06)
      dppcond(i,07)=azbz(i)*dspcond(i,01)+fspcond(i,07)
      dppcond(i,08)=azbz(i)*dspcond(i,02)+fspcond(i,08)
      dppcond(i,09)=azbz(i)*dspcond(i,03)+fspcond(i,09)
      dppcond(i,10)=axbx(i)*dspcond(i,04)+fspcond(i,04)
      dppcond(i,11)=axbx(i)*dspcond(i,05)+fspcond(i,05)
      dppcond(i,12)=axbx(i)*dspcond(i,06)+fspcond(i,06)
      dppcond(i,13)=ayby(i)*dspcond(i,04)+fspcond(i,10)
      dppcond(i,14)=ayby(i)*dspcond(i,05)+fspcond(i,11)
      dppcond(i,15)=ayby(i)*dspcond(i,06)+fspcond(i,12)
      dppcond(i,16)=azbz(i)*dspcond(i,04)+fspcond(i,13)
      dppcond(i,17)=azbz(i)*dspcond(i,05)+fspcond(i,14)
      dppcond(i,18)=azbz(i)*dspcond(i,06)+fspcond(i,15)
      dppcond(i,19)=axbx(i)*dspcond(i,07)+fspcond(i,07)
      dppcond(i,20)=axbx(i)*dspcond(i,08)+fspcond(i,08)
      dppcond(i,21)=axbx(i)*dspcond(i,09)+fspcond(i,09)
      dppcond(i,22)=ayby(i)*dspcond(i,07)+fspcond(i,13)
      dppcond(i,23)=ayby(i)*dspcond(i,08)+fspcond(i,14)
      dppcond(i,24)=ayby(i)*dspcond(i,09)+fspcond(i,15)
      dppcond(i,25)=azbz(i)*dspcond(i,07)+fspcond(i,16)
      dppcond(i,26)=azbz(i)*dspcond(i,08)+fspcond(i,17)
      dppcond(i,27)=azbz(i)*dspcond(i,09)+fspcond(i,18)
      dppcond(i,28)=axbx(i)*dspcond(i,10)+fspcond(i,10)
      dppcond(i,29)=axbx(i)*dspcond(i,11)+fspcond(i,11)
      dppcond(i,30)=axbx(i)*dspcond(i,12)+fspcond(i,12)
      dppcond(i,31)=ayby(i)*dspcond(i,10)+fspcond(i,19)
      dppcond(i,32)=ayby(i)*dspcond(i,11)+fspcond(i,20)
      dppcond(i,33)=ayby(i)*dspcond(i,12)+fspcond(i,21)
      dppcond(i,34)=azbz(i)*dspcond(i,10)+fspcond(i,22)
      dppcond(i,35)=azbz(i)*dspcond(i,11)+fspcond(i,23)
      dppcond(i,36)=azbz(i)*dspcond(i,12)+fspcond(i,24)
      dppcond(i,37)=axbx(i)*dspcond(i,13)+fspcond(i,13)
      dppcond(i,38)=axbx(i)*dspcond(i,14)+fspcond(i,14)
      dppcond(i,39)=axbx(i)*dspcond(i,15)+fspcond(i,15)
      dppcond(i,40)=ayby(i)*dspcond(i,13)+fspcond(i,22)
      dppcond(i,41)=ayby(i)*dspcond(i,14)+fspcond(i,23)
      dppcond(i,42)=ayby(i)*dspcond(i,15)+fspcond(i,24)
      dppcond(i,43)=azbz(i)*dspcond(i,13)+fspcond(i,25)
      dppcond(i,44)=azbz(i)*dspcond(i,14)+fspcond(i,26)
      dppcond(i,45)=azbz(i)*dspcond(i,15)+fspcond(i,27)
      dppcond(i,46)=axbx(i)*dspcond(i,16)+fspcond(i,16)
      dppcond(i,47)=axbx(i)*dspcond(i,17)+fspcond(i,17)
      dppcond(i,48)=axbx(i)*dspcond(i,18)+fspcond(i,18)
      dppcond(i,49)=ayby(i)*dspcond(i,16)+fspcond(i,25)
      dppcond(i,50)=ayby(i)*dspcond(i,17)+fspcond(i,26)
      dppcond(i,51)=ayby(i)*dspcond(i,18)+fspcond(i,27)
      dppcond(i,52)=azbz(i)*dspcond(i,16)+fspcond(i,28)
      dppcond(i,53)=azbz(i)*dspcond(i,17)+fspcond(i,29)
 1020 dppcond(i,54)=azbz(i)*dspcond(i,18)+fspcond(i,30)

      do 1021 i=1,m
      dpdcond(i,001)=axbx(i)*dsdcond(i,01)+fsdcond(i,01)
      dpdcond(i,002)=axbx(i)*dsdcond(i,02)+fsdcond(i,02)
      dpdcond(i,003)=axbx(i)*dsdcond(i,03)+fsdcond(i,03)
      dpdcond(i,004)=axbx(i)*dsdcond(i,04)+fsdcond(i,04)
      dpdcond(i,005)=axbx(i)*dsdcond(i,05)+fsdcond(i,05)
      dpdcond(i,006)=axbx(i)*dsdcond(i,06)+fsdcond(i,06)
      dpdcond(i,007)=ayby(i)*dsdcond(i,01)+fsdcond(i,07)
      dpdcond(i,008)=ayby(i)*dsdcond(i,02)+fsdcond(i,08)
      dpdcond(i,009)=ayby(i)*dsdcond(i,03)+fsdcond(i,09)
      dpdcond(i,010)=ayby(i)*dsdcond(i,04)+fsdcond(i,10)
      dpdcond(i,011)=ayby(i)*dsdcond(i,05)+fsdcond(i,11)
      dpdcond(i,012)=ayby(i)*dsdcond(i,06)+fsdcond(i,12)
      dpdcond(i,013)=azbz(i)*dsdcond(i,01)+fsdcond(i,13)
      dpdcond(i,014)=azbz(i)*dsdcond(i,02)+fsdcond(i,14)
      dpdcond(i,015)=azbz(i)*dsdcond(i,03)+fsdcond(i,15)
      dpdcond(i,016)=azbz(i)*dsdcond(i,04)+fsdcond(i,16)
      dpdcond(i,017)=azbz(i)*dsdcond(i,05)+fsdcond(i,17)
      dpdcond(i,018)=azbz(i)*dsdcond(i,06)+fsdcond(i,18)
      dpdcond(i,019)=axbx(i)*dsdcond(i,07)+fsdcond(i,07)
      dpdcond(i,020)=axbx(i)*dsdcond(i,08)+fsdcond(i,08)
      dpdcond(i,021)=axbx(i)*dsdcond(i,09)+fsdcond(i,09)
      dpdcond(i,022)=axbx(i)*dsdcond(i,10)+fsdcond(i,10)
      dpdcond(i,023)=axbx(i)*dsdcond(i,11)+fsdcond(i,11)
      dpdcond(i,024)=axbx(i)*dsdcond(i,12)+fsdcond(i,12)
      dpdcond(i,025)=ayby(i)*dsdcond(i,07)+fsdcond(i,19)
      dpdcond(i,026)=ayby(i)*dsdcond(i,08)+fsdcond(i,20)
      dpdcond(i,027)=ayby(i)*dsdcond(i,09)+fsdcond(i,21)
      dpdcond(i,028)=ayby(i)*dsdcond(i,10)+fsdcond(i,22)
      dpdcond(i,029)=ayby(i)*dsdcond(i,11)+fsdcond(i,23)
      dpdcond(i,030)=ayby(i)*dsdcond(i,12)+fsdcond(i,24)
      dpdcond(i,031)=azbz(i)*dsdcond(i,07)+fsdcond(i,25)
      dpdcond(i,032)=azbz(i)*dsdcond(i,08)+fsdcond(i,26)
      dpdcond(i,033)=azbz(i)*dsdcond(i,09)+fsdcond(i,27)
      dpdcond(i,034)=azbz(i)*dsdcond(i,10)+fsdcond(i,28)
      dpdcond(i,035)=azbz(i)*dsdcond(i,11)+fsdcond(i,29)
      dpdcond(i,036)=azbz(i)*dsdcond(i,12)+fsdcond(i,30)
      dpdcond(i,037)=axbx(i)*dsdcond(i,13)+fsdcond(i,13)
      dpdcond(i,038)=axbx(i)*dsdcond(i,14)+fsdcond(i,14)
      dpdcond(i,039)=axbx(i)*dsdcond(i,15)+fsdcond(i,15)
      dpdcond(i,040)=axbx(i)*dsdcond(i,16)+fsdcond(i,16)
      dpdcond(i,041)=axbx(i)*dsdcond(i,17)+fsdcond(i,17)
      dpdcond(i,042)=axbx(i)*dsdcond(i,18)+fsdcond(i,18)
      dpdcond(i,043)=ayby(i)*dsdcond(i,13)+fsdcond(i,25)
      dpdcond(i,044)=ayby(i)*dsdcond(i,14)+fsdcond(i,26)
      dpdcond(i,045)=ayby(i)*dsdcond(i,15)+fsdcond(i,27)
      dpdcond(i,046)=ayby(i)*dsdcond(i,16)+fsdcond(i,28)
      dpdcond(i,047)=ayby(i)*dsdcond(i,17)+fsdcond(i,29)
      dpdcond(i,048)=ayby(i)*dsdcond(i,18)+fsdcond(i,30)
      dpdcond(i,049)=azbz(i)*dsdcond(i,13)+fsdcond(i,31)
      dpdcond(i,050)=azbz(i)*dsdcond(i,14)+fsdcond(i,32)
      dpdcond(i,051)=azbz(i)*dsdcond(i,15)+fsdcond(i,33)
      dpdcond(i,052)=azbz(i)*dsdcond(i,16)+fsdcond(i,34)
      dpdcond(i,053)=azbz(i)*dsdcond(i,17)+fsdcond(i,35)
      dpdcond(i,054)=azbz(i)*dsdcond(i,18)+fsdcond(i,36)
      dpdcond(i,055)=axbx(i)*dsdcond(i,19)+fsdcond(i,19)
      dpdcond(i,056)=axbx(i)*dsdcond(i,20)+fsdcond(i,20)
      dpdcond(i,057)=axbx(i)*dsdcond(i,21)+fsdcond(i,21)
      dpdcond(i,058)=axbx(i)*dsdcond(i,22)+fsdcond(i,22)
      dpdcond(i,059)=axbx(i)*dsdcond(i,23)+fsdcond(i,23)
      dpdcond(i,060)=axbx(i)*dsdcond(i,24)+fsdcond(i,24)
      dpdcond(i,061)=ayby(i)*dsdcond(i,19)+fsdcond(i,37)
      dpdcond(i,062)=ayby(i)*dsdcond(i,20)+fsdcond(i,38)
      dpdcond(i,063)=ayby(i)*dsdcond(i,21)+fsdcond(i,39)
      dpdcond(i,064)=ayby(i)*dsdcond(i,22)+fsdcond(i,40)
      dpdcond(i,065)=ayby(i)*dsdcond(i,23)+fsdcond(i,41)
      dpdcond(i,066)=ayby(i)*dsdcond(i,24)+fsdcond(i,42)
      dpdcond(i,067)=azbz(i)*dsdcond(i,19)+fsdcond(i,43)
      dpdcond(i,068)=azbz(i)*dsdcond(i,20)+fsdcond(i,44)
      dpdcond(i,069)=azbz(i)*dsdcond(i,21)+fsdcond(i,45)
      dpdcond(i,070)=azbz(i)*dsdcond(i,22)+fsdcond(i,46)
      dpdcond(i,071)=azbz(i)*dsdcond(i,23)+fsdcond(i,47)
      dpdcond(i,072)=azbz(i)*dsdcond(i,24)+fsdcond(i,48)
      dpdcond(i,073)=axbx(i)*dsdcond(i,25)+fsdcond(i,25)
      dpdcond(i,074)=axbx(i)*dsdcond(i,26)+fsdcond(i,26)
      dpdcond(i,075)=axbx(i)*dsdcond(i,27)+fsdcond(i,27)
      dpdcond(i,076)=axbx(i)*dsdcond(i,28)+fsdcond(i,28)
      dpdcond(i,077)=axbx(i)*dsdcond(i,29)+fsdcond(i,29)
      dpdcond(i,078)=axbx(i)*dsdcond(i,30)+fsdcond(i,30)
      dpdcond(i,079)=ayby(i)*dsdcond(i,25)+fsdcond(i,43)
      dpdcond(i,080)=ayby(i)*dsdcond(i,26)+fsdcond(i,44)
      dpdcond(i,081)=ayby(i)*dsdcond(i,27)+fsdcond(i,45)
      dpdcond(i,082)=ayby(i)*dsdcond(i,28)+fsdcond(i,46)
      dpdcond(i,083)=ayby(i)*dsdcond(i,29)+fsdcond(i,47)
      dpdcond(i,084)=ayby(i)*dsdcond(i,30)+fsdcond(i,48)
      dpdcond(i,085)=azbz(i)*dsdcond(i,25)+fsdcond(i,49)
      dpdcond(i,086)=azbz(i)*dsdcond(i,26)+fsdcond(i,50)
      dpdcond(i,087)=azbz(i)*dsdcond(i,27)+fsdcond(i,51)
      dpdcond(i,088)=azbz(i)*dsdcond(i,28)+fsdcond(i,52)
      dpdcond(i,089)=azbz(i)*dsdcond(i,29)+fsdcond(i,53)
      dpdcond(i,090)=azbz(i)*dsdcond(i,30)+fsdcond(i,54)
      dpdcond(i,091)=axbx(i)*dsdcond(i,31)+fsdcond(i,31)
      dpdcond(i,092)=axbx(i)*dsdcond(i,32)+fsdcond(i,32)
      dpdcond(i,093)=axbx(i)*dsdcond(i,33)+fsdcond(i,33)
      dpdcond(i,094)=axbx(i)*dsdcond(i,34)+fsdcond(i,34)
      dpdcond(i,095)=axbx(i)*dsdcond(i,35)+fsdcond(i,35)
      dpdcond(i,096)=axbx(i)*dsdcond(i,36)+fsdcond(i,36)
      dpdcond(i,097)=ayby(i)*dsdcond(i,31)+fsdcond(i,49)
      dpdcond(i,098)=ayby(i)*dsdcond(i,32)+fsdcond(i,50)
      dpdcond(i,099)=ayby(i)*dsdcond(i,33)+fsdcond(i,51)
      dpdcond(i,100)=ayby(i)*dsdcond(i,34)+fsdcond(i,52)
      dpdcond(i,101)=ayby(i)*dsdcond(i,35)+fsdcond(i,53)
      dpdcond(i,102)=ayby(i)*dsdcond(i,36)+fsdcond(i,54)
      dpdcond(i,103)=azbz(i)*dsdcond(i,31)+fsdcond(i,55)
      dpdcond(i,104)=azbz(i)*dsdcond(i,32)+fsdcond(i,56)
      dpdcond(i,105)=azbz(i)*dsdcond(i,33)+fsdcond(i,57)
      dpdcond(i,106)=azbz(i)*dsdcond(i,34)+fsdcond(i,58)
      dpdcond(i,107)=azbz(i)*dsdcond(i,35)+fsdcond(i,59)
 1021 dpdcond(i,108)=azbz(i)*dsdcond(i,36)+fsdcond(i,60)

      do 1022 i=1,m
      fpscond(i,01)=axbx(i)*fsscond(i,01)+gsscond(i,01)
      fpscond(i,02)=ayby(i)*fsscond(i,01)+gsscond(i,02)
      fpscond(i,03)=azbz(i)*fsscond(i,01)+gsscond(i,03)
      fpscond(i,04)=axbx(i)*fsscond(i,02)+gsscond(i,02)
      fpscond(i,05)=ayby(i)*fsscond(i,02)+gsscond(i,04)
      fpscond(i,06)=azbz(i)*fsscond(i,02)+gsscond(i,05)
      fpscond(i,07)=axbx(i)*fsscond(i,03)+gsscond(i,03)
      fpscond(i,08)=ayby(i)*fsscond(i,03)+gsscond(i,05)
      fpscond(i,09)=azbz(i)*fsscond(i,03)+gsscond(i,06)
      fpscond(i,10)=axbx(i)*fsscond(i,04)+gsscond(i,04)
      fpscond(i,11)=ayby(i)*fsscond(i,04)+gsscond(i,07)
      fpscond(i,12)=azbz(i)*fsscond(i,04)+gsscond(i,08)
      fpscond(i,13)=axbx(i)*fsscond(i,05)+gsscond(i,05)
      fpscond(i,14)=ayby(i)*fsscond(i,05)+gsscond(i,08)
      fpscond(i,15)=azbz(i)*fsscond(i,05)+gsscond(i,09)
      fpscond(i,16)=axbx(i)*fsscond(i,06)+gsscond(i,06)
      fpscond(i,17)=ayby(i)*fsscond(i,06)+gsscond(i,09)
      fpscond(i,18)=azbz(i)*fsscond(i,06)+gsscond(i,10)
      fpscond(i,19)=axbx(i)*fsscond(i,07)+gsscond(i,07)
      fpscond(i,20)=ayby(i)*fsscond(i,07)+gsscond(i,11)
      fpscond(i,21)=azbz(i)*fsscond(i,07)+gsscond(i,12)
      fpscond(i,22)=axbx(i)*fsscond(i,08)+gsscond(i,08)
      fpscond(i,23)=ayby(i)*fsscond(i,08)+gsscond(i,12)
      fpscond(i,24)=azbz(i)*fsscond(i,08)+gsscond(i,13)
      fpscond(i,25)=axbx(i)*fsscond(i,09)+gsscond(i,09)
      fpscond(i,26)=ayby(i)*fsscond(i,09)+gsscond(i,13)
      fpscond(i,27)=azbz(i)*fsscond(i,09)+gsscond(i,14)
      fpscond(i,28)=axbx(i)*fsscond(i,10)+gsscond(i,10)
      fpscond(i,29)=ayby(i)*fsscond(i,10)+gsscond(i,14)
 1022 fpscond(i,30)=azbz(i)*fsscond(i,10)+gsscond(i,15)

      do 1023 i=1,m
      fppcond(i,01)=axbx(i)*fspcond(i,01)+gspcond(i,01)
      fppcond(i,02)=axbx(i)*fspcond(i,02)+gspcond(i,02)
      fppcond(i,03)=axbx(i)*fspcond(i,03)+gspcond(i,03)
      fppcond(i,04)=ayby(i)*fspcond(i,01)+gspcond(i,04)
      fppcond(i,05)=ayby(i)*fspcond(i,02)+gspcond(i,05)
      fppcond(i,06)=ayby(i)*fspcond(i,03)+gspcond(i,06)
      fppcond(i,07)=azbz(i)*fspcond(i,01)+gspcond(i,07)
      fppcond(i,08)=azbz(i)*fspcond(i,02)+gspcond(i,08)
      fppcond(i,09)=azbz(i)*fspcond(i,03)+gspcond(i,09)
      fppcond(i,10)=axbx(i)*fspcond(i,04)+gspcond(i,04)
      fppcond(i,11)=axbx(i)*fspcond(i,05)+gspcond(i,05)
      fppcond(i,12)=axbx(i)*fspcond(i,06)+gspcond(i,06)
      fppcond(i,13)=ayby(i)*fspcond(i,04)+gspcond(i,10)
      fppcond(i,14)=ayby(i)*fspcond(i,05)+gspcond(i,11)
      fppcond(i,15)=ayby(i)*fspcond(i,06)+gspcond(i,12)
      fppcond(i,16)=azbz(i)*fspcond(i,04)+gspcond(i,13)
      fppcond(i,17)=azbz(i)*fspcond(i,05)+gspcond(i,14)
      fppcond(i,18)=azbz(i)*fspcond(i,06)+gspcond(i,15)
      fppcond(i,19)=axbx(i)*fspcond(i,07)+gspcond(i,07)
      fppcond(i,20)=axbx(i)*fspcond(i,08)+gspcond(i,08)
      fppcond(i,21)=axbx(i)*fspcond(i,09)+gspcond(i,09)
      fppcond(i,22)=ayby(i)*fspcond(i,07)+gspcond(i,13)
      fppcond(i,23)=ayby(i)*fspcond(i,08)+gspcond(i,14)
      fppcond(i,24)=ayby(i)*fspcond(i,09)+gspcond(i,15)
      fppcond(i,25)=azbz(i)*fspcond(i,07)+gspcond(i,16)
      fppcond(i,26)=azbz(i)*fspcond(i,08)+gspcond(i,17)
      fppcond(i,27)=azbz(i)*fspcond(i,09)+gspcond(i,18)
      fppcond(i,28)=axbx(i)*fspcond(i,10)+gspcond(i,10)
      fppcond(i,29)=axbx(i)*fspcond(i,11)+gspcond(i,11)
      fppcond(i,30)=axbx(i)*fspcond(i,12)+gspcond(i,12)
      fppcond(i,31)=ayby(i)*fspcond(i,10)+gspcond(i,19)
      fppcond(i,32)=ayby(i)*fspcond(i,11)+gspcond(i,20)
      fppcond(i,33)=ayby(i)*fspcond(i,12)+gspcond(i,21)
      fppcond(i,34)=azbz(i)*fspcond(i,10)+gspcond(i,22)
      fppcond(i,35)=azbz(i)*fspcond(i,11)+gspcond(i,23)
      fppcond(i,36)=azbz(i)*fspcond(i,12)+gspcond(i,24)
      fppcond(i,37)=axbx(i)*fspcond(i,13)+gspcond(i,13)
      fppcond(i,38)=axbx(i)*fspcond(i,14)+gspcond(i,14)
      fppcond(i,39)=axbx(i)*fspcond(i,15)+gspcond(i,15)
      fppcond(i,40)=ayby(i)*fspcond(i,13)+gspcond(i,22)
      fppcond(i,41)=ayby(i)*fspcond(i,14)+gspcond(i,23)
      fppcond(i,42)=ayby(i)*fspcond(i,15)+gspcond(i,24)
      fppcond(i,43)=azbz(i)*fspcond(i,13)+gspcond(i,25)
      fppcond(i,44)=azbz(i)*fspcond(i,14)+gspcond(i,26)
      fppcond(i,45)=azbz(i)*fspcond(i,15)+gspcond(i,27)
      fppcond(i,46)=axbx(i)*fspcond(i,16)+gspcond(i,16)
      fppcond(i,47)=axbx(i)*fspcond(i,17)+gspcond(i,17)
      fppcond(i,48)=axbx(i)*fspcond(i,18)+gspcond(i,18)
      fppcond(i,49)=ayby(i)*fspcond(i,16)+gspcond(i,25)
      fppcond(i,50)=ayby(i)*fspcond(i,17)+gspcond(i,26)
      fppcond(i,51)=ayby(i)*fspcond(i,18)+gspcond(i,27)
      fppcond(i,52)=azbz(i)*fspcond(i,16)+gspcond(i,28)
      fppcond(i,53)=azbz(i)*fspcond(i,17)+gspcond(i,29)
      fppcond(i,54)=azbz(i)*fspcond(i,18)+gspcond(i,30)
      fppcond(i,55)=axbx(i)*fspcond(i,19)+gspcond(i,19)
      fppcond(i,56)=axbx(i)*fspcond(i,20)+gspcond(i,20)
      fppcond(i,57)=axbx(i)*fspcond(i,21)+gspcond(i,21)
      fppcond(i,58)=ayby(i)*fspcond(i,19)+gspcond(i,31)
      fppcond(i,59)=ayby(i)*fspcond(i,20)+gspcond(i,32)
      fppcond(i,60)=ayby(i)*fspcond(i,21)+gspcond(i,33)
      fppcond(i,61)=azbz(i)*fspcond(i,19)+gspcond(i,34)
      fppcond(i,62)=azbz(i)*fspcond(i,20)+gspcond(i,35)
      fppcond(i,63)=azbz(i)*fspcond(i,21)+gspcond(i,36)
      fppcond(i,64)=axbx(i)*fspcond(i,22)+gspcond(i,22)
      fppcond(i,65)=axbx(i)*fspcond(i,23)+gspcond(i,23)
      fppcond(i,66)=axbx(i)*fspcond(i,24)+gspcond(i,24)
      fppcond(i,67)=ayby(i)*fspcond(i,22)+gspcond(i,34)
      fppcond(i,68)=ayby(i)*fspcond(i,23)+gspcond(i,35)
      fppcond(i,69)=ayby(i)*fspcond(i,24)+gspcond(i,36)
      fppcond(i,70)=azbz(i)*fspcond(i,22)+gspcond(i,37)
      fppcond(i,71)=azbz(i)*fspcond(i,23)+gspcond(i,38)
      fppcond(i,72)=azbz(i)*fspcond(i,24)+gspcond(i,39)
      fppcond(i,73)=axbx(i)*fspcond(i,25)+gspcond(i,25)
      fppcond(i,74)=axbx(i)*fspcond(i,26)+gspcond(i,26)
      fppcond(i,75)=axbx(i)*fspcond(i,27)+gspcond(i,27)
      fppcond(i,76)=ayby(i)*fspcond(i,25)+gspcond(i,37)
      fppcond(i,77)=ayby(i)*fspcond(i,26)+gspcond(i,38)
      fppcond(i,78)=ayby(i)*fspcond(i,27)+gspcond(i,39)
      fppcond(i,79)=azbz(i)*fspcond(i,25)+gspcond(i,40)
      fppcond(i,80)=azbz(i)*fspcond(i,26)+gspcond(i,41)
      fppcond(i,81)=azbz(i)*fspcond(i,27)+gspcond(i,42)
      fppcond(i,82)=axbx(i)*fspcond(i,28)+gspcond(i,28)
      fppcond(i,83)=axbx(i)*fspcond(i,29)+gspcond(i,29)
      fppcond(i,84)=axbx(i)*fspcond(i,30)+gspcond(i,30)
      fppcond(i,85)=ayby(i)*fspcond(i,28)+gspcond(i,40)
      fppcond(i,86)=ayby(i)*fspcond(i,29)+gspcond(i,41)
      fppcond(i,87)=ayby(i)*fspcond(i,30)+gspcond(i,42)
      fppcond(i,88)=azbz(i)*fspcond(i,28)+gspcond(i,43)
      fppcond(i,89)=azbz(i)*fspcond(i,29)+gspcond(i,44)
 1023 fppcond(i,90)=azbz(i)*fspcond(i,30)+gspcond(i,45)

      do 1024 i=1,m
      fpdcond(i,001)=axbx(i)*fsdcond(i,01)+gsdcond(i,01)
      fpdcond(i,002)=axbx(i)*fsdcond(i,02)+gsdcond(i,02)
      fpdcond(i,003)=axbx(i)*fsdcond(i,03)+gsdcond(i,03)
      fpdcond(i,004)=axbx(i)*fsdcond(i,04)+gsdcond(i,04)
      fpdcond(i,005)=axbx(i)*fsdcond(i,05)+gsdcond(i,05)
      fpdcond(i,006)=axbx(i)*fsdcond(i,06)+gsdcond(i,06)
      fpdcond(i,007)=ayby(i)*fsdcond(i,01)+gsdcond(i,07)
      fpdcond(i,008)=ayby(i)*fsdcond(i,02)+gsdcond(i,08)
      fpdcond(i,009)=ayby(i)*fsdcond(i,03)+gsdcond(i,09)
      fpdcond(i,010)=ayby(i)*fsdcond(i,04)+gsdcond(i,10)
      fpdcond(i,011)=ayby(i)*fsdcond(i,05)+gsdcond(i,11)
      fpdcond(i,012)=ayby(i)*fsdcond(i,06)+gsdcond(i,12)
      fpdcond(i,013)=azbz(i)*fsdcond(i,01)+gsdcond(i,13)
      fpdcond(i,014)=azbz(i)*fsdcond(i,02)+gsdcond(i,14)
      fpdcond(i,015)=azbz(i)*fsdcond(i,03)+gsdcond(i,15)
      fpdcond(i,016)=azbz(i)*fsdcond(i,04)+gsdcond(i,16)
      fpdcond(i,017)=azbz(i)*fsdcond(i,05)+gsdcond(i,17)
      fpdcond(i,018)=azbz(i)*fsdcond(i,06)+gsdcond(i,18)
      fpdcond(i,019)=axbx(i)*fsdcond(i,07)+gsdcond(i,07)
      fpdcond(i,020)=axbx(i)*fsdcond(i,08)+gsdcond(i,08)
      fpdcond(i,021)=axbx(i)*fsdcond(i,09)+gsdcond(i,09)
      fpdcond(i,022)=axbx(i)*fsdcond(i,10)+gsdcond(i,10)
      fpdcond(i,023)=axbx(i)*fsdcond(i,11)+gsdcond(i,11)
      fpdcond(i,024)=axbx(i)*fsdcond(i,12)+gsdcond(i,12)
      fpdcond(i,025)=ayby(i)*fsdcond(i,07)+gsdcond(i,19)
      fpdcond(i,026)=ayby(i)*fsdcond(i,08)+gsdcond(i,20)
      fpdcond(i,027)=ayby(i)*fsdcond(i,09)+gsdcond(i,21)
      fpdcond(i,028)=ayby(i)*fsdcond(i,10)+gsdcond(i,22)
      fpdcond(i,029)=ayby(i)*fsdcond(i,11)+gsdcond(i,23)
      fpdcond(i,030)=ayby(i)*fsdcond(i,12)+gsdcond(i,24)
      fpdcond(i,031)=azbz(i)*fsdcond(i,07)+gsdcond(i,25)
      fpdcond(i,032)=azbz(i)*fsdcond(i,08)+gsdcond(i,26)
      fpdcond(i,033)=azbz(i)*fsdcond(i,09)+gsdcond(i,27)
      fpdcond(i,034)=azbz(i)*fsdcond(i,10)+gsdcond(i,28)
      fpdcond(i,035)=azbz(i)*fsdcond(i,11)+gsdcond(i,29)
      fpdcond(i,036)=azbz(i)*fsdcond(i,12)+gsdcond(i,30)
      fpdcond(i,037)=axbx(i)*fsdcond(i,13)+gsdcond(i,13)
      fpdcond(i,038)=axbx(i)*fsdcond(i,14)+gsdcond(i,14)
      fpdcond(i,039)=axbx(i)*fsdcond(i,15)+gsdcond(i,15)
      fpdcond(i,040)=axbx(i)*fsdcond(i,16)+gsdcond(i,16)
      fpdcond(i,041)=axbx(i)*fsdcond(i,17)+gsdcond(i,17)
      fpdcond(i,042)=axbx(i)*fsdcond(i,18)+gsdcond(i,18)
      fpdcond(i,043)=ayby(i)*fsdcond(i,13)+gsdcond(i,25)
      fpdcond(i,044)=ayby(i)*fsdcond(i,14)+gsdcond(i,26)
      fpdcond(i,045)=ayby(i)*fsdcond(i,15)+gsdcond(i,27)
      fpdcond(i,046)=ayby(i)*fsdcond(i,16)+gsdcond(i,28)
      fpdcond(i,047)=ayby(i)*fsdcond(i,17)+gsdcond(i,29)
      fpdcond(i,048)=ayby(i)*fsdcond(i,18)+gsdcond(i,30)
      fpdcond(i,049)=azbz(i)*fsdcond(i,13)+gsdcond(i,31)
      fpdcond(i,050)=azbz(i)*fsdcond(i,14)+gsdcond(i,32)
      fpdcond(i,051)=azbz(i)*fsdcond(i,15)+gsdcond(i,33)
      fpdcond(i,052)=azbz(i)*fsdcond(i,16)+gsdcond(i,34)
      fpdcond(i,053)=azbz(i)*fsdcond(i,17)+gsdcond(i,35)
      fpdcond(i,054)=azbz(i)*fsdcond(i,18)+gsdcond(i,36)
      fpdcond(i,055)=axbx(i)*fsdcond(i,19)+gsdcond(i,19)
      fpdcond(i,056)=axbx(i)*fsdcond(i,20)+gsdcond(i,20)
      fpdcond(i,057)=axbx(i)*fsdcond(i,21)+gsdcond(i,21)
      fpdcond(i,058)=axbx(i)*fsdcond(i,22)+gsdcond(i,22)
      fpdcond(i,059)=axbx(i)*fsdcond(i,23)+gsdcond(i,23)
      fpdcond(i,060)=axbx(i)*fsdcond(i,24)+gsdcond(i,24)
      fpdcond(i,061)=ayby(i)*fsdcond(i,19)+gsdcond(i,37)
      fpdcond(i,062)=ayby(i)*fsdcond(i,20)+gsdcond(i,38)
      fpdcond(i,063)=ayby(i)*fsdcond(i,21)+gsdcond(i,39)
      fpdcond(i,064)=ayby(i)*fsdcond(i,22)+gsdcond(i,40)
      fpdcond(i,065)=ayby(i)*fsdcond(i,23)+gsdcond(i,41)
      fpdcond(i,066)=ayby(i)*fsdcond(i,24)+gsdcond(i,42)
      fpdcond(i,067)=azbz(i)*fsdcond(i,19)+gsdcond(i,43)
      fpdcond(i,068)=azbz(i)*fsdcond(i,20)+gsdcond(i,44)
      fpdcond(i,069)=azbz(i)*fsdcond(i,21)+gsdcond(i,45)
      fpdcond(i,070)=azbz(i)*fsdcond(i,22)+gsdcond(i,46)
      fpdcond(i,071)=azbz(i)*fsdcond(i,23)+gsdcond(i,47)
      fpdcond(i,072)=azbz(i)*fsdcond(i,24)+gsdcond(i,48)
      fpdcond(i,073)=axbx(i)*fsdcond(i,25)+gsdcond(i,25)
      fpdcond(i,074)=axbx(i)*fsdcond(i,26)+gsdcond(i,26)
      fpdcond(i,075)=axbx(i)*fsdcond(i,27)+gsdcond(i,27)
      fpdcond(i,076)=axbx(i)*fsdcond(i,28)+gsdcond(i,28)
      fpdcond(i,077)=axbx(i)*fsdcond(i,29)+gsdcond(i,29)
      fpdcond(i,078)=axbx(i)*fsdcond(i,30)+gsdcond(i,30)
      fpdcond(i,079)=ayby(i)*fsdcond(i,25)+gsdcond(i,43)
      fpdcond(i,080)=ayby(i)*fsdcond(i,26)+gsdcond(i,44)
      fpdcond(i,081)=ayby(i)*fsdcond(i,27)+gsdcond(i,45)
      fpdcond(i,082)=ayby(i)*fsdcond(i,28)+gsdcond(i,46)
      fpdcond(i,083)=ayby(i)*fsdcond(i,29)+gsdcond(i,47)
      fpdcond(i,084)=ayby(i)*fsdcond(i,30)+gsdcond(i,48)
      fpdcond(i,085)=azbz(i)*fsdcond(i,25)+gsdcond(i,49)
      fpdcond(i,086)=azbz(i)*fsdcond(i,26)+gsdcond(i,50)
      fpdcond(i,087)=azbz(i)*fsdcond(i,27)+gsdcond(i,51)
      fpdcond(i,088)=azbz(i)*fsdcond(i,28)+gsdcond(i,52)
      fpdcond(i,089)=azbz(i)*fsdcond(i,29)+gsdcond(i,53)
      fpdcond(i,090)=azbz(i)*fsdcond(i,30)+gsdcond(i,54)
      fpdcond(i,091)=axbx(i)*fsdcond(i,31)+gsdcond(i,31)
      fpdcond(i,092)=axbx(i)*fsdcond(i,32)+gsdcond(i,32)
      fpdcond(i,093)=axbx(i)*fsdcond(i,33)+gsdcond(i,33)
      fpdcond(i,094)=axbx(i)*fsdcond(i,34)+gsdcond(i,34)
      fpdcond(i,095)=axbx(i)*fsdcond(i,35)+gsdcond(i,35)
      fpdcond(i,096)=axbx(i)*fsdcond(i,36)+gsdcond(i,36)
      fpdcond(i,097)=ayby(i)*fsdcond(i,31)+gsdcond(i,49)
      fpdcond(i,098)=ayby(i)*fsdcond(i,32)+gsdcond(i,50)
      fpdcond(i,099)=ayby(i)*fsdcond(i,33)+gsdcond(i,51)
      fpdcond(i,100)=ayby(i)*fsdcond(i,34)+gsdcond(i,52)
      fpdcond(i,101)=ayby(i)*fsdcond(i,35)+gsdcond(i,53)
      fpdcond(i,102)=ayby(i)*fsdcond(i,36)+gsdcond(i,54)
      fpdcond(i,103)=azbz(i)*fsdcond(i,31)+gsdcond(i,55)
      fpdcond(i,104)=azbz(i)*fsdcond(i,32)+gsdcond(i,56)
      fpdcond(i,105)=azbz(i)*fsdcond(i,33)+gsdcond(i,57)
      fpdcond(i,106)=azbz(i)*fsdcond(i,34)+gsdcond(i,58)
      fpdcond(i,107)=azbz(i)*fsdcond(i,35)+gsdcond(i,59)
      fpdcond(i,108)=azbz(i)*fsdcond(i,36)+gsdcond(i,60)
      fpdcond(i,109)=axbx(i)*fsdcond(i,37)+gsdcond(i,37)
      fpdcond(i,110)=axbx(i)*fsdcond(i,38)+gsdcond(i,38)
      fpdcond(i,111)=axbx(i)*fsdcond(i,39)+gsdcond(i,39)
      fpdcond(i,112)=axbx(i)*fsdcond(i,40)+gsdcond(i,40)
      fpdcond(i,113)=axbx(i)*fsdcond(i,41)+gsdcond(i,41)
      fpdcond(i,114)=axbx(i)*fsdcond(i,42)+gsdcond(i,42)
      fpdcond(i,115)=ayby(i)*fsdcond(i,37)+gsdcond(i,61)
      fpdcond(i,116)=ayby(i)*fsdcond(i,38)+gsdcond(i,62)
      fpdcond(i,117)=ayby(i)*fsdcond(i,39)+gsdcond(i,63)
      fpdcond(i,118)=ayby(i)*fsdcond(i,40)+gsdcond(i,64)
      fpdcond(i,119)=ayby(i)*fsdcond(i,41)+gsdcond(i,65)
      fpdcond(i,120)=ayby(i)*fsdcond(i,42)+gsdcond(i,66)
      fpdcond(i,121)=azbz(i)*fsdcond(i,37)+gsdcond(i,67)
      fpdcond(i,122)=azbz(i)*fsdcond(i,38)+gsdcond(i,68)
      fpdcond(i,123)=azbz(i)*fsdcond(i,39)+gsdcond(i,69)
      fpdcond(i,124)=azbz(i)*fsdcond(i,40)+gsdcond(i,70)
      fpdcond(i,125)=azbz(i)*fsdcond(i,41)+gsdcond(i,71)
      fpdcond(i,126)=azbz(i)*fsdcond(i,42)+gsdcond(i,72)
      fpdcond(i,127)=axbx(i)*fsdcond(i,43)+gsdcond(i,43)
      fpdcond(i,128)=axbx(i)*fsdcond(i,44)+gsdcond(i,44)
      fpdcond(i,129)=axbx(i)*fsdcond(i,45)+gsdcond(i,45)
      fpdcond(i,130)=axbx(i)*fsdcond(i,46)+gsdcond(i,46)
      fpdcond(i,131)=axbx(i)*fsdcond(i,47)+gsdcond(i,47)
      fpdcond(i,132)=axbx(i)*fsdcond(i,48)+gsdcond(i,48)
      fpdcond(i,133)=ayby(i)*fsdcond(i,43)+gsdcond(i,67)
      fpdcond(i,134)=ayby(i)*fsdcond(i,44)+gsdcond(i,68)
      fpdcond(i,135)=ayby(i)*fsdcond(i,45)+gsdcond(i,69)
      fpdcond(i,136)=ayby(i)*fsdcond(i,46)+gsdcond(i,70)
      fpdcond(i,137)=ayby(i)*fsdcond(i,47)+gsdcond(i,71)
      fpdcond(i,138)=ayby(i)*fsdcond(i,48)+gsdcond(i,72)
      fpdcond(i,139)=azbz(i)*fsdcond(i,43)+gsdcond(i,73)
      fpdcond(i,140)=azbz(i)*fsdcond(i,44)+gsdcond(i,74)
      fpdcond(i,141)=azbz(i)*fsdcond(i,45)+gsdcond(i,75)
      fpdcond(i,142)=azbz(i)*fsdcond(i,46)+gsdcond(i,76)
      fpdcond(i,143)=azbz(i)*fsdcond(i,47)+gsdcond(i,77)
      fpdcond(i,144)=azbz(i)*fsdcond(i,48)+gsdcond(i,78)
      fpdcond(i,145)=axbx(i)*fsdcond(i,49)+gsdcond(i,49)
      fpdcond(i,146)=axbx(i)*fsdcond(i,50)+gsdcond(i,50)
      fpdcond(i,147)=axbx(i)*fsdcond(i,51)+gsdcond(i,51)
      fpdcond(i,148)=axbx(i)*fsdcond(i,52)+gsdcond(i,52)
      fpdcond(i,149)=axbx(i)*fsdcond(i,53)+gsdcond(i,53)
      fpdcond(i,150)=axbx(i)*fsdcond(i,54)+gsdcond(i,54)
      fpdcond(i,151)=ayby(i)*fsdcond(i,49)+gsdcond(i,73)
      fpdcond(i,152)=ayby(i)*fsdcond(i,50)+gsdcond(i,74)
      fpdcond(i,153)=ayby(i)*fsdcond(i,51)+gsdcond(i,75)
      fpdcond(i,154)=ayby(i)*fsdcond(i,52)+gsdcond(i,76)
      fpdcond(i,155)=ayby(i)*fsdcond(i,53)+gsdcond(i,77)
      fpdcond(i,156)=ayby(i)*fsdcond(i,54)+gsdcond(i,78)
      fpdcond(i,157)=azbz(i)*fsdcond(i,49)+gsdcond(i,79)
      fpdcond(i,158)=azbz(i)*fsdcond(i,50)+gsdcond(i,80)
      fpdcond(i,159)=azbz(i)*fsdcond(i,51)+gsdcond(i,81)
      fpdcond(i,160)=azbz(i)*fsdcond(i,52)+gsdcond(i,82)
      fpdcond(i,161)=azbz(i)*fsdcond(i,53)+gsdcond(i,83)
      fpdcond(i,162)=azbz(i)*fsdcond(i,54)+gsdcond(i,84)
      fpdcond(i,163)=axbx(i)*fsdcond(i,55)+gsdcond(i,55)
      fpdcond(i,164)=axbx(i)*fsdcond(i,56)+gsdcond(i,56)
      fpdcond(i,165)=axbx(i)*fsdcond(i,57)+gsdcond(i,57)
      fpdcond(i,166)=axbx(i)*fsdcond(i,58)+gsdcond(i,58)
      fpdcond(i,167)=axbx(i)*fsdcond(i,59)+gsdcond(i,59)
      fpdcond(i,168)=axbx(i)*fsdcond(i,60)+gsdcond(i,60)
      fpdcond(i,169)=ayby(i)*fsdcond(i,55)+gsdcond(i,79)
      fpdcond(i,170)=ayby(i)*fsdcond(i,56)+gsdcond(i,80)
      fpdcond(i,171)=ayby(i)*fsdcond(i,57)+gsdcond(i,81)
      fpdcond(i,172)=ayby(i)*fsdcond(i,58)+gsdcond(i,82)
      fpdcond(i,173)=ayby(i)*fsdcond(i,59)+gsdcond(i,83)
      fpdcond(i,174)=ayby(i)*fsdcond(i,60)+gsdcond(i,84)
      fpdcond(i,175)=azbz(i)*fsdcond(i,55)+gsdcond(i,85)
      fpdcond(i,176)=azbz(i)*fsdcond(i,56)+gsdcond(i,86)
      fpdcond(i,177)=azbz(i)*fsdcond(i,57)+gsdcond(i,87)
      fpdcond(i,178)=azbz(i)*fsdcond(i,58)+gsdcond(i,88)
      fpdcond(i,179)=azbz(i)*fsdcond(i,59)+gsdcond(i,89)
 1024 fpdcond(i,180)=azbz(i)*fsdcond(i,60)+gsdcond(i,90)

      do 1025 i=1,m
      ddscond(i,01)=axbx(i)*dpscond(i,01)+fpscond(i,01)
      ddscond(i,02)=ayby(i)*dpscond(i,01)+fpscond(i,04)
      ddscond(i,03)=azbz(i)*dpscond(i,01)+fpscond(i,07)
      ddscond(i,04)=ayby(i)*dpscond(i,02)+fpscond(i,05)
      ddscond(i,05)=azbz(i)*dpscond(i,02)+fpscond(i,08)
      ddscond(i,06)=azbz(i)*dpscond(i,03)+fpscond(i,09)
      ddscond(i,07)=axbx(i)*dpscond(i,04)+fpscond(i,04)
      ddscond(i,08)=ayby(i)*dpscond(i,04)+fpscond(i,10)
      ddscond(i,09)=azbz(i)*dpscond(i,04)+fpscond(i,13)
      ddscond(i,10)=ayby(i)*dpscond(i,05)+fpscond(i,11)
      ddscond(i,11)=azbz(i)*dpscond(i,05)+fpscond(i,14)
      ddscond(i,12)=azbz(i)*dpscond(i,06)+fpscond(i,15)
      ddscond(i,13)=axbx(i)*dpscond(i,07)+fpscond(i,07)
      ddscond(i,14)=ayby(i)*dpscond(i,07)+fpscond(i,13)
      ddscond(i,15)=azbz(i)*dpscond(i,07)+fpscond(i,16)
      ddscond(i,16)=ayby(i)*dpscond(i,08)+fpscond(i,14)
      ddscond(i,17)=azbz(i)*dpscond(i,08)+fpscond(i,17)
      ddscond(i,18)=azbz(i)*dpscond(i,09)+fpscond(i,18)
      ddscond(i,19)=axbx(i)*dpscond(i,10)+fpscond(i,10)
      ddscond(i,20)=ayby(i)*dpscond(i,10)+fpscond(i,19)
      ddscond(i,21)=azbz(i)*dpscond(i,10)+fpscond(i,22)
      ddscond(i,22)=ayby(i)*dpscond(i,11)+fpscond(i,20)
      ddscond(i,23)=azbz(i)*dpscond(i,11)+fpscond(i,23)
      ddscond(i,24)=azbz(i)*dpscond(i,12)+fpscond(i,24)
      ddscond(i,25)=axbx(i)*dpscond(i,13)+fpscond(i,13)
      ddscond(i,26)=ayby(i)*dpscond(i,13)+fpscond(i,22)
      ddscond(i,27)=azbz(i)*dpscond(i,13)+fpscond(i,25)
      ddscond(i,28)=ayby(i)*dpscond(i,14)+fpscond(i,23)
      ddscond(i,29)=azbz(i)*dpscond(i,14)+fpscond(i,26)
      ddscond(i,30)=azbz(i)*dpscond(i,15)+fpscond(i,27)
      ddscond(i,31)=axbx(i)*dpscond(i,16)+fpscond(i,16)
      ddscond(i,32)=ayby(i)*dpscond(i,16)+fpscond(i,25)
      ddscond(i,33)=azbz(i)*dpscond(i,16)+fpscond(i,28)
      ddscond(i,34)=ayby(i)*dpscond(i,17)+fpscond(i,26)
      ddscond(i,35)=azbz(i)*dpscond(i,17)+fpscond(i,29)
 1025 ddscond(i,36)=azbz(i)*dpscond(i,18)+fpscond(i,30)

      do 1026 i=1,m
      ddpcond(i,001)=axbx(i)*dppcond(i,01)+fppcond(i,01)
      ddpcond(i,002)=axbx(i)*dppcond(i,02)+fppcond(i,02)
      ddpcond(i,003)=axbx(i)*dppcond(i,03)+fppcond(i,03)
      ddpcond(i,004)=ayby(i)*dppcond(i,01)+fppcond(i,10)
      ddpcond(i,005)=ayby(i)*dppcond(i,02)+fppcond(i,11)
      ddpcond(i,006)=ayby(i)*dppcond(i,03)+fppcond(i,12)
      ddpcond(i,007)=azbz(i)*dppcond(i,01)+fppcond(i,19)
      ddpcond(i,008)=azbz(i)*dppcond(i,02)+fppcond(i,20)
      ddpcond(i,009)=azbz(i)*dppcond(i,03)+fppcond(i,21)
      ddpcond(i,010)=ayby(i)*dppcond(i,04)+fppcond(i,13)
      ddpcond(i,011)=ayby(i)*dppcond(i,05)+fppcond(i,14)
      ddpcond(i,012)=ayby(i)*dppcond(i,06)+fppcond(i,15)
      ddpcond(i,013)=azbz(i)*dppcond(i,04)+fppcond(i,22)
      ddpcond(i,014)=azbz(i)*dppcond(i,05)+fppcond(i,23)
      ddpcond(i,015)=azbz(i)*dppcond(i,06)+fppcond(i,24)
      ddpcond(i,016)=azbz(i)*dppcond(i,07)+fppcond(i,25)
      ddpcond(i,017)=azbz(i)*dppcond(i,08)+fppcond(i,26)
      ddpcond(i,018)=azbz(i)*dppcond(i,09)+fppcond(i,27)
      ddpcond(i,019)=axbx(i)*dppcond(i,10)+fppcond(i,10)
      ddpcond(i,020)=axbx(i)*dppcond(i,11)+fppcond(i,11)
      ddpcond(i,021)=axbx(i)*dppcond(i,12)+fppcond(i,12)
      ddpcond(i,022)=ayby(i)*dppcond(i,10)+fppcond(i,28)
      ddpcond(i,023)=ayby(i)*dppcond(i,11)+fppcond(i,29)
      ddpcond(i,024)=ayby(i)*dppcond(i,12)+fppcond(i,30)
      ddpcond(i,025)=azbz(i)*dppcond(i,10)+fppcond(i,37)
      ddpcond(i,026)=azbz(i)*dppcond(i,11)+fppcond(i,38)
      ddpcond(i,027)=azbz(i)*dppcond(i,12)+fppcond(i,39)
      ddpcond(i,028)=ayby(i)*dppcond(i,13)+fppcond(i,31)
      ddpcond(i,029)=ayby(i)*dppcond(i,14)+fppcond(i,32)
      ddpcond(i,030)=ayby(i)*dppcond(i,15)+fppcond(i,33)
      ddpcond(i,031)=azbz(i)*dppcond(i,13)+fppcond(i,40)
      ddpcond(i,032)=azbz(i)*dppcond(i,14)+fppcond(i,41)
      ddpcond(i,033)=azbz(i)*dppcond(i,15)+fppcond(i,42)
      ddpcond(i,034)=azbz(i)*dppcond(i,16)+fppcond(i,43)
      ddpcond(i,035)=azbz(i)*dppcond(i,17)+fppcond(i,44)
      ddpcond(i,036)=azbz(i)*dppcond(i,18)+fppcond(i,45)
      ddpcond(i,037)=axbx(i)*dppcond(i,19)+fppcond(i,19)
      ddpcond(i,038)=axbx(i)*dppcond(i,20)+fppcond(i,20)
      ddpcond(i,039)=axbx(i)*dppcond(i,21)+fppcond(i,21)
      ddpcond(i,040)=ayby(i)*dppcond(i,19)+fppcond(i,37)
      ddpcond(i,041)=ayby(i)*dppcond(i,20)+fppcond(i,38)
      ddpcond(i,042)=ayby(i)*dppcond(i,21)+fppcond(i,39)
      ddpcond(i,043)=azbz(i)*dppcond(i,19)+fppcond(i,46)
      ddpcond(i,044)=azbz(i)*dppcond(i,20)+fppcond(i,47)
      ddpcond(i,045)=azbz(i)*dppcond(i,21)+fppcond(i,48)
      ddpcond(i,046)=ayby(i)*dppcond(i,22)+fppcond(i,40)
      ddpcond(i,047)=ayby(i)*dppcond(i,23)+fppcond(i,41)
      ddpcond(i,048)=ayby(i)*dppcond(i,24)+fppcond(i,42)
      ddpcond(i,049)=azbz(i)*dppcond(i,22)+fppcond(i,49)
      ddpcond(i,050)=azbz(i)*dppcond(i,23)+fppcond(i,50)
      ddpcond(i,051)=azbz(i)*dppcond(i,24)+fppcond(i,51)
      ddpcond(i,052)=azbz(i)*dppcond(i,25)+fppcond(i,52)
      ddpcond(i,053)=azbz(i)*dppcond(i,26)+fppcond(i,53)
      ddpcond(i,054)=azbz(i)*dppcond(i,27)+fppcond(i,54)
      ddpcond(i,055)=axbx(i)*dppcond(i,28)+fppcond(i,28)
      ddpcond(i,056)=axbx(i)*dppcond(i,29)+fppcond(i,29)
      ddpcond(i,057)=axbx(i)*dppcond(i,30)+fppcond(i,30)
      ddpcond(i,058)=ayby(i)*dppcond(i,28)+fppcond(i,55)
      ddpcond(i,059)=ayby(i)*dppcond(i,29)+fppcond(i,56)
      ddpcond(i,060)=ayby(i)*dppcond(i,30)+fppcond(i,57)
      ddpcond(i,061)=azbz(i)*dppcond(i,28)+fppcond(i,64)
      ddpcond(i,062)=azbz(i)*dppcond(i,29)+fppcond(i,65)
      ddpcond(i,063)=azbz(i)*dppcond(i,30)+fppcond(i,66)
      ddpcond(i,064)=ayby(i)*dppcond(i,31)+fppcond(i,58)
      ddpcond(i,065)=ayby(i)*dppcond(i,32)+fppcond(i,59)
      ddpcond(i,066)=ayby(i)*dppcond(i,33)+fppcond(i,60)
      ddpcond(i,067)=azbz(i)*dppcond(i,31)+fppcond(i,67)
      ddpcond(i,068)=azbz(i)*dppcond(i,32)+fppcond(i,68)
      ddpcond(i,069)=azbz(i)*dppcond(i,33)+fppcond(i,69)
      ddpcond(i,070)=azbz(i)*dppcond(i,34)+fppcond(i,70)
      ddpcond(i,071)=azbz(i)*dppcond(i,35)+fppcond(i,71)
      ddpcond(i,072)=azbz(i)*dppcond(i,36)+fppcond(i,72)
      ddpcond(i,073)=axbx(i)*dppcond(i,37)+fppcond(i,37)
      ddpcond(i,074)=axbx(i)*dppcond(i,38)+fppcond(i,38)
      ddpcond(i,075)=axbx(i)*dppcond(i,39)+fppcond(i,39)
      ddpcond(i,076)=ayby(i)*dppcond(i,37)+fppcond(i,64)
      ddpcond(i,077)=ayby(i)*dppcond(i,38)+fppcond(i,65)
      ddpcond(i,078)=ayby(i)*dppcond(i,39)+fppcond(i,66)
      ddpcond(i,079)=azbz(i)*dppcond(i,37)+fppcond(i,73)
      ddpcond(i,080)=azbz(i)*dppcond(i,38)+fppcond(i,74)
      ddpcond(i,081)=azbz(i)*dppcond(i,39)+fppcond(i,75)
      ddpcond(i,082)=ayby(i)*dppcond(i,40)+fppcond(i,67)
      ddpcond(i,083)=ayby(i)*dppcond(i,41)+fppcond(i,68)
      ddpcond(i,084)=ayby(i)*dppcond(i,42)+fppcond(i,69)
      ddpcond(i,085)=azbz(i)*dppcond(i,40)+fppcond(i,76)
      ddpcond(i,086)=azbz(i)*dppcond(i,41)+fppcond(i,77)
      ddpcond(i,087)=azbz(i)*dppcond(i,42)+fppcond(i,78)
      ddpcond(i,088)=azbz(i)*dppcond(i,43)+fppcond(i,79)
      ddpcond(i,089)=azbz(i)*dppcond(i,44)+fppcond(i,80)
      ddpcond(i,090)=azbz(i)*dppcond(i,45)+fppcond(i,81)
      ddpcond(i,091)=axbx(i)*dppcond(i,46)+fppcond(i,46)
      ddpcond(i,092)=axbx(i)*dppcond(i,47)+fppcond(i,47)
      ddpcond(i,093)=axbx(i)*dppcond(i,48)+fppcond(i,48)
      ddpcond(i,094)=ayby(i)*dppcond(i,46)+fppcond(i,73)
      ddpcond(i,095)=ayby(i)*dppcond(i,47)+fppcond(i,74)
      ddpcond(i,096)=ayby(i)*dppcond(i,48)+fppcond(i,75)
      ddpcond(i,097)=azbz(i)*dppcond(i,46)+fppcond(i,82)
      ddpcond(i,098)=azbz(i)*dppcond(i,47)+fppcond(i,83)
      ddpcond(i,099)=azbz(i)*dppcond(i,48)+fppcond(i,84)
      ddpcond(i,100)=ayby(i)*dppcond(i,49)+fppcond(i,76)
      ddpcond(i,101)=ayby(i)*dppcond(i,50)+fppcond(i,77)
      ddpcond(i,102)=ayby(i)*dppcond(i,51)+fppcond(i,78)
      ddpcond(i,103)=azbz(i)*dppcond(i,49)+fppcond(i,85)
      ddpcond(i,104)=azbz(i)*dppcond(i,50)+fppcond(i,86)
      ddpcond(i,105)=azbz(i)*dppcond(i,51)+fppcond(i,87)
      ddpcond(i,106)=azbz(i)*dppcond(i,52)+fppcond(i,88)
      ddpcond(i,107)=azbz(i)*dppcond(i,53)+fppcond(i,89)
 1026 ddpcond(i,108)=azbz(i)*dppcond(i,54)+fppcond(i,90)

      do 1027 i=1,m
      dddcond(i,001)=axbx(i)*dpdcond(i,001)+fpdcond(i,001)
      dddcond(i,002)=axbx(i)*dpdcond(i,002)+fpdcond(i,002)
      dddcond(i,003)=axbx(i)*dpdcond(i,003)+fpdcond(i,003)
      dddcond(i,004)=axbx(i)*dpdcond(i,004)+fpdcond(i,004)
      dddcond(i,005)=axbx(i)*dpdcond(i,005)+fpdcond(i,005)
      dddcond(i,006)=axbx(i)*dpdcond(i,006)+fpdcond(i,006)
      dddcond(i,007)=ayby(i)*dpdcond(i,001)+fpdcond(i,019)
      dddcond(i,008)=ayby(i)*dpdcond(i,002)+fpdcond(i,020)
      dddcond(i,009)=ayby(i)*dpdcond(i,003)+fpdcond(i,021)
      dddcond(i,010)=ayby(i)*dpdcond(i,004)+fpdcond(i,022)
      dddcond(i,011)=ayby(i)*dpdcond(i,005)+fpdcond(i,023)
      dddcond(i,012)=ayby(i)*dpdcond(i,006)+fpdcond(i,024)
      dddcond(i,013)=azbz(i)*dpdcond(i,001)+fpdcond(i,037)
      dddcond(i,014)=azbz(i)*dpdcond(i,002)+fpdcond(i,038)
      dddcond(i,015)=azbz(i)*dpdcond(i,003)+fpdcond(i,039)
      dddcond(i,016)=azbz(i)*dpdcond(i,004)+fpdcond(i,040)
      dddcond(i,017)=azbz(i)*dpdcond(i,005)+fpdcond(i,041)
      dddcond(i,018)=azbz(i)*dpdcond(i,006)+fpdcond(i,042)
      dddcond(i,019)=ayby(i)*dpdcond(i,007)+fpdcond(i,025)
      dddcond(i,020)=ayby(i)*dpdcond(i,008)+fpdcond(i,026)
      dddcond(i,021)=ayby(i)*dpdcond(i,009)+fpdcond(i,027)
      dddcond(i,022)=ayby(i)*dpdcond(i,010)+fpdcond(i,028)
      dddcond(i,023)=ayby(i)*dpdcond(i,011)+fpdcond(i,029)
      dddcond(i,024)=ayby(i)*dpdcond(i,012)+fpdcond(i,030)
      dddcond(i,025)=azbz(i)*dpdcond(i,007)+fpdcond(i,043)
      dddcond(i,026)=azbz(i)*dpdcond(i,008)+fpdcond(i,044)
      dddcond(i,027)=azbz(i)*dpdcond(i,009)+fpdcond(i,045)
      dddcond(i,028)=azbz(i)*dpdcond(i,010)+fpdcond(i,046)
      dddcond(i,029)=azbz(i)*dpdcond(i,011)+fpdcond(i,047)
      dddcond(i,030)=azbz(i)*dpdcond(i,012)+fpdcond(i,048)
      dddcond(i,031)=azbz(i)*dpdcond(i,013)+fpdcond(i,049)
      dddcond(i,032)=azbz(i)*dpdcond(i,014)+fpdcond(i,050)
      dddcond(i,033)=azbz(i)*dpdcond(i,015)+fpdcond(i,051)
      dddcond(i,034)=azbz(i)*dpdcond(i,016)+fpdcond(i,052)
      dddcond(i,035)=azbz(i)*dpdcond(i,017)+fpdcond(i,053)
      dddcond(i,036)=azbz(i)*dpdcond(i,018)+fpdcond(i,054)
      dddcond(i,037)=axbx(i)*dpdcond(i,019)+fpdcond(i,019)
      dddcond(i,038)=axbx(i)*dpdcond(i,020)+fpdcond(i,020)
      dddcond(i,039)=axbx(i)*dpdcond(i,021)+fpdcond(i,021)
      dddcond(i,040)=axbx(i)*dpdcond(i,022)+fpdcond(i,022)
      dddcond(i,041)=axbx(i)*dpdcond(i,023)+fpdcond(i,023)
      dddcond(i,042)=axbx(i)*dpdcond(i,024)+fpdcond(i,024)
      dddcond(i,043)=ayby(i)*dpdcond(i,019)+fpdcond(i,055)
      dddcond(i,044)=ayby(i)*dpdcond(i,020)+fpdcond(i,056)
      dddcond(i,045)=ayby(i)*dpdcond(i,021)+fpdcond(i,057)
      dddcond(i,046)=ayby(i)*dpdcond(i,022)+fpdcond(i,058)
      dddcond(i,047)=ayby(i)*dpdcond(i,023)+fpdcond(i,059)
      dddcond(i,048)=ayby(i)*dpdcond(i,024)+fpdcond(i,060)
      dddcond(i,049)=azbz(i)*dpdcond(i,019)+fpdcond(i,073)
      dddcond(i,050)=azbz(i)*dpdcond(i,020)+fpdcond(i,074)
      dddcond(i,051)=azbz(i)*dpdcond(i,021)+fpdcond(i,075)
      dddcond(i,052)=azbz(i)*dpdcond(i,022)+fpdcond(i,076)
      dddcond(i,053)=azbz(i)*dpdcond(i,023)+fpdcond(i,077)
      dddcond(i,054)=azbz(i)*dpdcond(i,024)+fpdcond(i,078)
      dddcond(i,055)=ayby(i)*dpdcond(i,025)+fpdcond(i,061)
      dddcond(i,056)=ayby(i)*dpdcond(i,026)+fpdcond(i,062)
      dddcond(i,057)=ayby(i)*dpdcond(i,027)+fpdcond(i,063)
      dddcond(i,058)=ayby(i)*dpdcond(i,028)+fpdcond(i,064)
      dddcond(i,059)=ayby(i)*dpdcond(i,029)+fpdcond(i,065)
      dddcond(i,060)=ayby(i)*dpdcond(i,030)+fpdcond(i,066)
      dddcond(i,061)=azbz(i)*dpdcond(i,025)+fpdcond(i,079)
      dddcond(i,062)=azbz(i)*dpdcond(i,026)+fpdcond(i,080)
      dddcond(i,063)=azbz(i)*dpdcond(i,027)+fpdcond(i,081)
      dddcond(i,064)=azbz(i)*dpdcond(i,028)+fpdcond(i,082)
      dddcond(i,065)=azbz(i)*dpdcond(i,029)+fpdcond(i,083)
      dddcond(i,066)=azbz(i)*dpdcond(i,030)+fpdcond(i,084)
      dddcond(i,067)=azbz(i)*dpdcond(i,031)+fpdcond(i,085)
      dddcond(i,068)=azbz(i)*dpdcond(i,032)+fpdcond(i,086)
      dddcond(i,069)=azbz(i)*dpdcond(i,033)+fpdcond(i,087)
      dddcond(i,070)=azbz(i)*dpdcond(i,034)+fpdcond(i,088)
      dddcond(i,071)=azbz(i)*dpdcond(i,035)+fpdcond(i,089)
      dddcond(i,072)=azbz(i)*dpdcond(i,036)+fpdcond(i,090)
      dddcond(i,073)=axbx(i)*dpdcond(i,037)+fpdcond(i,037)
      dddcond(i,074)=axbx(i)*dpdcond(i,038)+fpdcond(i,038)
      dddcond(i,075)=axbx(i)*dpdcond(i,039)+fpdcond(i,039)
      dddcond(i,076)=axbx(i)*dpdcond(i,040)+fpdcond(i,040)
      dddcond(i,077)=axbx(i)*dpdcond(i,041)+fpdcond(i,041)
      dddcond(i,078)=axbx(i)*dpdcond(i,042)+fpdcond(i,042)
      dddcond(i,079)=ayby(i)*dpdcond(i,037)+fpdcond(i,073)
      dddcond(i,080)=ayby(i)*dpdcond(i,038)+fpdcond(i,074)
      dddcond(i,081)=ayby(i)*dpdcond(i,039)+fpdcond(i,075)
      dddcond(i,082)=ayby(i)*dpdcond(i,040)+fpdcond(i,076)
      dddcond(i,083)=ayby(i)*dpdcond(i,041)+fpdcond(i,077)
      dddcond(i,084)=ayby(i)*dpdcond(i,042)+fpdcond(i,078)
      dddcond(i,085)=azbz(i)*dpdcond(i,037)+fpdcond(i,091)
      dddcond(i,086)=azbz(i)*dpdcond(i,038)+fpdcond(i,092)
      dddcond(i,087)=azbz(i)*dpdcond(i,039)+fpdcond(i,093)
      dddcond(i,088)=azbz(i)*dpdcond(i,040)+fpdcond(i,094)
      dddcond(i,089)=azbz(i)*dpdcond(i,041)+fpdcond(i,095)
      dddcond(i,090)=azbz(i)*dpdcond(i,042)+fpdcond(i,096)
      dddcond(i,091)=ayby(i)*dpdcond(i,043)+fpdcond(i,079)
      dddcond(i,092)=ayby(i)*dpdcond(i,044)+fpdcond(i,080)
      dddcond(i,093)=ayby(i)*dpdcond(i,045)+fpdcond(i,081)
      dddcond(i,094)=ayby(i)*dpdcond(i,046)+fpdcond(i,082)
      dddcond(i,095)=ayby(i)*dpdcond(i,047)+fpdcond(i,083)
      dddcond(i,096)=ayby(i)*dpdcond(i,048)+fpdcond(i,084)
      dddcond(i,097)=azbz(i)*dpdcond(i,043)+fpdcond(i,097)
      dddcond(i,098)=azbz(i)*dpdcond(i,044)+fpdcond(i,098)
      dddcond(i,099)=azbz(i)*dpdcond(i,045)+fpdcond(i,099)
      dddcond(i,100)=azbz(i)*dpdcond(i,046)+fpdcond(i,100)
      dddcond(i,101)=azbz(i)*dpdcond(i,047)+fpdcond(i,101)
      dddcond(i,102)=azbz(i)*dpdcond(i,048)+fpdcond(i,102)
      dddcond(i,103)=azbz(i)*dpdcond(i,049)+fpdcond(i,103)
      dddcond(i,104)=azbz(i)*dpdcond(i,050)+fpdcond(i,104)
      dddcond(i,105)=azbz(i)*dpdcond(i,051)+fpdcond(i,105)
      dddcond(i,106)=azbz(i)*dpdcond(i,052)+fpdcond(i,106)
      dddcond(i,107)=azbz(i)*dpdcond(i,053)+fpdcond(i,107)
      dddcond(i,108)=azbz(i)*dpdcond(i,054)+fpdcond(i,108)
      dddcond(i,109)=axbx(i)*dpdcond(i,055)+fpdcond(i,055)
      dddcond(i,110)=axbx(i)*dpdcond(i,056)+fpdcond(i,056)
      dddcond(i,111)=axbx(i)*dpdcond(i,057)+fpdcond(i,057)
      dddcond(i,112)=axbx(i)*dpdcond(i,058)+fpdcond(i,058)
      dddcond(i,113)=axbx(i)*dpdcond(i,059)+fpdcond(i,059)
      dddcond(i,114)=axbx(i)*dpdcond(i,060)+fpdcond(i,060)
      dddcond(i,115)=ayby(i)*dpdcond(i,055)+fpdcond(i,109)
      dddcond(i,116)=ayby(i)*dpdcond(i,056)+fpdcond(i,110)
      dddcond(i,117)=ayby(i)*dpdcond(i,057)+fpdcond(i,111)
      dddcond(i,118)=ayby(i)*dpdcond(i,058)+fpdcond(i,112)
      dddcond(i,119)=ayby(i)*dpdcond(i,059)+fpdcond(i,113)
      dddcond(i,120)=ayby(i)*dpdcond(i,060)+fpdcond(i,114)
      dddcond(i,121)=azbz(i)*dpdcond(i,055)+fpdcond(i,127)
      dddcond(i,122)=azbz(i)*dpdcond(i,056)+fpdcond(i,128)
      dddcond(i,123)=azbz(i)*dpdcond(i,057)+fpdcond(i,129)
      dddcond(i,124)=azbz(i)*dpdcond(i,058)+fpdcond(i,130)
      dddcond(i,125)=azbz(i)*dpdcond(i,059)+fpdcond(i,131)
      dddcond(i,126)=azbz(i)*dpdcond(i,060)+fpdcond(i,132)
      dddcond(i,127)=ayby(i)*dpdcond(i,061)+fpdcond(i,115)
      dddcond(i,128)=ayby(i)*dpdcond(i,062)+fpdcond(i,116)
      dddcond(i,129)=ayby(i)*dpdcond(i,063)+fpdcond(i,117)
      dddcond(i,130)=ayby(i)*dpdcond(i,064)+fpdcond(i,118)
      dddcond(i,131)=ayby(i)*dpdcond(i,065)+fpdcond(i,119)
      dddcond(i,132)=ayby(i)*dpdcond(i,066)+fpdcond(i,120)
      dddcond(i,133)=azbz(i)*dpdcond(i,061)+fpdcond(i,133)
      dddcond(i,134)=azbz(i)*dpdcond(i,062)+fpdcond(i,134)
      dddcond(i,135)=azbz(i)*dpdcond(i,063)+fpdcond(i,135)
      dddcond(i,136)=azbz(i)*dpdcond(i,064)+fpdcond(i,136)
      dddcond(i,137)=azbz(i)*dpdcond(i,065)+fpdcond(i,137)
      dddcond(i,138)=azbz(i)*dpdcond(i,066)+fpdcond(i,138)
      dddcond(i,139)=azbz(i)*dpdcond(i,067)+fpdcond(i,139)
      dddcond(i,140)=azbz(i)*dpdcond(i,068)+fpdcond(i,140)
      dddcond(i,141)=azbz(i)*dpdcond(i,069)+fpdcond(i,141)
      dddcond(i,142)=azbz(i)*dpdcond(i,070)+fpdcond(i,142)
      dddcond(i,143)=azbz(i)*dpdcond(i,071)+fpdcond(i,143)
      dddcond(i,144)=azbz(i)*dpdcond(i,072)+fpdcond(i,144)
      dddcond(i,145)=axbx(i)*dpdcond(i,073)+fpdcond(i,073)
      dddcond(i,146)=axbx(i)*dpdcond(i,074)+fpdcond(i,074)
      dddcond(i,147)=axbx(i)*dpdcond(i,075)+fpdcond(i,075)
      dddcond(i,148)=axbx(i)*dpdcond(i,076)+fpdcond(i,076)
      dddcond(i,149)=axbx(i)*dpdcond(i,077)+fpdcond(i,077)
      dddcond(i,150)=axbx(i)*dpdcond(i,078)+fpdcond(i,078)
      dddcond(i,151)=ayby(i)*dpdcond(i,073)+fpdcond(i,127)
      dddcond(i,152)=ayby(i)*dpdcond(i,074)+fpdcond(i,128)
      dddcond(i,153)=ayby(i)*dpdcond(i,075)+fpdcond(i,129)
      dddcond(i,154)=ayby(i)*dpdcond(i,076)+fpdcond(i,130)
      dddcond(i,155)=ayby(i)*dpdcond(i,077)+fpdcond(i,131)
      dddcond(i,156)=ayby(i)*dpdcond(i,078)+fpdcond(i,132)
      dddcond(i,157)=azbz(i)*dpdcond(i,073)+fpdcond(i,145)
      dddcond(i,158)=azbz(i)*dpdcond(i,074)+fpdcond(i,146)
      dddcond(i,159)=azbz(i)*dpdcond(i,075)+fpdcond(i,147)
      dddcond(i,160)=azbz(i)*dpdcond(i,076)+fpdcond(i,148)
      dddcond(i,161)=azbz(i)*dpdcond(i,077)+fpdcond(i,149)
      dddcond(i,162)=azbz(i)*dpdcond(i,078)+fpdcond(i,150)
      dddcond(i,163)=ayby(i)*dpdcond(i,079)+fpdcond(i,133)
      dddcond(i,164)=ayby(i)*dpdcond(i,080)+fpdcond(i,134)
      dddcond(i,165)=ayby(i)*dpdcond(i,081)+fpdcond(i,135)
      dddcond(i,166)=ayby(i)*dpdcond(i,082)+fpdcond(i,136)
      dddcond(i,167)=ayby(i)*dpdcond(i,083)+fpdcond(i,137)
      dddcond(i,168)=ayby(i)*dpdcond(i,084)+fpdcond(i,138)
      dddcond(i,169)=azbz(i)*dpdcond(i,079)+fpdcond(i,151)
      dddcond(i,170)=azbz(i)*dpdcond(i,080)+fpdcond(i,152)
      dddcond(i,171)=azbz(i)*dpdcond(i,081)+fpdcond(i,153)
      dddcond(i,172)=azbz(i)*dpdcond(i,082)+fpdcond(i,154)
      dddcond(i,173)=azbz(i)*dpdcond(i,083)+fpdcond(i,155)
      dddcond(i,174)=azbz(i)*dpdcond(i,084)+fpdcond(i,156)
      dddcond(i,175)=azbz(i)*dpdcond(i,085)+fpdcond(i,157)
      dddcond(i,176)=azbz(i)*dpdcond(i,086)+fpdcond(i,158)
      dddcond(i,177)=azbz(i)*dpdcond(i,087)+fpdcond(i,159)
      dddcond(i,178)=azbz(i)*dpdcond(i,088)+fpdcond(i,160)
      dddcond(i,179)=azbz(i)*dpdcond(i,089)+fpdcond(i,161)
      dddcond(i,180)=azbz(i)*dpdcond(i,090)+fpdcond(i,162)
      dddcond(i,181)=axbx(i)*dpdcond(i,091)+fpdcond(i,091)
      dddcond(i,182)=axbx(i)*dpdcond(i,092)+fpdcond(i,092)
      dddcond(i,183)=axbx(i)*dpdcond(i,093)+fpdcond(i,093)
      dddcond(i,184)=axbx(i)*dpdcond(i,094)+fpdcond(i,094)
      dddcond(i,185)=axbx(i)*dpdcond(i,095)+fpdcond(i,095)
      dddcond(i,186)=axbx(i)*dpdcond(i,096)+fpdcond(i,096)
      dddcond(i,187)=ayby(i)*dpdcond(i,091)+fpdcond(i,145)
      dddcond(i,188)=ayby(i)*dpdcond(i,092)+fpdcond(i,146)
      dddcond(i,189)=ayby(i)*dpdcond(i,093)+fpdcond(i,147)
      dddcond(i,190)=ayby(i)*dpdcond(i,094)+fpdcond(i,148)
      dddcond(i,191)=ayby(i)*dpdcond(i,095)+fpdcond(i,149)
      dddcond(i,192)=ayby(i)*dpdcond(i,096)+fpdcond(i,150)
      dddcond(i,193)=azbz(i)*dpdcond(i,091)+fpdcond(i,163)
      dddcond(i,194)=azbz(i)*dpdcond(i,092)+fpdcond(i,164)
      dddcond(i,195)=azbz(i)*dpdcond(i,093)+fpdcond(i,165)
      dddcond(i,196)=azbz(i)*dpdcond(i,094)+fpdcond(i,166)
      dddcond(i,197)=azbz(i)*dpdcond(i,095)+fpdcond(i,167)
      dddcond(i,198)=azbz(i)*dpdcond(i,096)+fpdcond(i,168)
      dddcond(i,199)=ayby(i)*dpdcond(i,097)+fpdcond(i,151)
      dddcond(i,200)=ayby(i)*dpdcond(i,098)+fpdcond(i,152)
      dddcond(i,201)=ayby(i)*dpdcond(i,099)+fpdcond(i,153)
      dddcond(i,202)=ayby(i)*dpdcond(i,100)+fpdcond(i,154)
      dddcond(i,203)=ayby(i)*dpdcond(i,101)+fpdcond(i,155)
      dddcond(i,204)=ayby(i)*dpdcond(i,102)+fpdcond(i,156)
      dddcond(i,205)=azbz(i)*dpdcond(i,097)+fpdcond(i,169)
      dddcond(i,206)=azbz(i)*dpdcond(i,098)+fpdcond(i,170)
      dddcond(i,207)=azbz(i)*dpdcond(i,099)+fpdcond(i,171)
      dddcond(i,208)=azbz(i)*dpdcond(i,100)+fpdcond(i,172)
      dddcond(i,209)=azbz(i)*dpdcond(i,101)+fpdcond(i,173)
      dddcond(i,210)=azbz(i)*dpdcond(i,102)+fpdcond(i,174)
      dddcond(i,211)=azbz(i)*dpdcond(i,103)+fpdcond(i,175)
      dddcond(i,212)=azbz(i)*dpdcond(i,104)+fpdcond(i,176)
      dddcond(i,213)=azbz(i)*dpdcond(i,105)+fpdcond(i,177)
      dddcond(i,214)=azbz(i)*dpdcond(i,106)+fpdcond(i,178)
      dddcond(i,215)=azbz(i)*dpdcond(i,107)+fpdcond(i,179)
 1027 dddcond(i,216)=azbz(i)*dpdcond(i,108)+fpdcond(i,180)

      do 1028 i=1,m
      grad(i,01)=ddscond(i,01)*density(inddyy(i,01))*cdfits
      grad(i,02)=ddscond(i,02)*density(inddyy(i,02))*cdfits
      grad(i,03)=ddscond(i,03)*density(inddyy(i,03))*cdfits
      grad(i,04)=ddscond(i,07)*density(inddyy(i,04))*cdfits
      grad(i,05)=ddscond(i,08)*density(inddyy(i,05))*cdfits
      grad(i,06)=ddscond(i,09)*density(inddyy(i,06))*cdfits
      grad(i,07)=ddscond(i,13)*density(inddyy(i,07))*cdfits
      grad(i,08)=ddscond(i,14)*density(inddyy(i,08))*cdfits
      grad(i,09)=ddscond(i,15)*density(inddyy(i,09))*cdfits
      grad(i,10)=ddscond(i,19)*density(inddyy(i,10))*cdfits
      grad(i,11)=ddscond(i,20)*density(inddyy(i,11))*cdfits
      grad(i,12)=ddscond(i,21)*density(inddyy(i,12))*cdfits
      grad(i,13)=ddscond(i,25)*density(inddyy(i,13))*cdfits
      grad(i,14)=ddscond(i,26)*density(inddyy(i,14))*cdfits
      grad(i,15)=ddscond(i,27)*density(inddyy(i,15))*cdfits
      grad(i,16)=ddscond(i,31)*density(inddyy(i,16))*cdfits
      grad(i,17)=ddscond(i,32)*density(inddyy(i,17))*cdfits
      grad(i,18)=ddscond(i,33)*density(inddyy(i,18))*cdfits
      grad(i,19)=ddscond(i,02)*density(inddyy(i,01))*cdfits
      grad(i,20)=ddscond(i,04)*density(inddyy(i,02))*cdfits
      grad(i,21)=ddscond(i,05)*density(inddyy(i,03))*cdfits
      grad(i,22)=ddscond(i,08)*density(inddyy(i,04))*cdfits
      grad(i,23)=ddscond(i,10)*density(inddyy(i,05))*cdfits
      grad(i,24)=ddscond(i,11)*density(inddyy(i,06))*cdfits
      grad(i,25)=ddscond(i,14)*density(inddyy(i,07))*cdfits
      grad(i,26)=ddscond(i,16)*density(inddyy(i,08))*cdfits
      grad(i,27)=ddscond(i,17)*density(inddyy(i,09))*cdfits
      grad(i,28)=ddscond(i,20)*density(inddyy(i,10))*cdfits
      grad(i,29)=ddscond(i,22)*density(inddyy(i,11))*cdfits
      grad(i,30)=ddscond(i,23)*density(inddyy(i,12))*cdfits
      grad(i,31)=ddscond(i,26)*density(inddyy(i,13))*cdfits
      grad(i,32)=ddscond(i,28)*density(inddyy(i,14))*cdfits
      grad(i,33)=ddscond(i,29)*density(inddyy(i,15))*cdfits
      grad(i,34)=ddscond(i,32)*density(inddyy(i,16))*cdfits
      grad(i,35)=ddscond(i,34)*density(inddyy(i,17))*cdfits
      grad(i,36)=ddscond(i,35)*density(inddyy(i,18))*cdfits
      grad(i,37)=ddscond(i,03)*density(inddyy(i,01))*cdfits
      grad(i,38)=ddscond(i,05)*density(inddyy(i,02))*cdfits
      grad(i,39)=ddscond(i,06)*density(inddyy(i,03))*cdfits
      grad(i,40)=ddscond(i,09)*density(inddyy(i,04))*cdfits
      grad(i,41)=ddscond(i,11)*density(inddyy(i,05))*cdfits
      grad(i,42)=ddscond(i,12)*density(inddyy(i,06))*cdfits
      grad(i,43)=ddscond(i,15)*density(inddyy(i,07))*cdfits
      grad(i,44)=ddscond(i,17)*density(inddyy(i,08))*cdfits
      grad(i,45)=ddscond(i,18)*density(inddyy(i,09))*cdfits
      grad(i,46)=ddscond(i,21)*density(inddyy(i,10))*cdfits
      grad(i,47)=ddscond(i,23)*density(inddyy(i,11))*cdfits
      grad(i,48)=ddscond(i,24)*density(inddyy(i,12))*cdfits
      grad(i,49)=ddscond(i,27)*density(inddyy(i,13))*cdfits
      grad(i,50)=ddscond(i,29)*density(inddyy(i,14))*cdfits
      grad(i,51)=ddscond(i,30)*density(inddyy(i,15))*cdfits
      grad(i,52)=ddscond(i,33)*density(inddyy(i,16))*cdfits
      grad(i,53)=ddscond(i,35)*density(inddyy(i,17))*cdfits
 1028 grad(i,54)=ddscond(i,36)*density(inddyy(i,18))*cdfits

      do 1029 k=1,3
      do 1029 j=1,18
      do 1029 i=1,m
 1029 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1030 k=1,3
      do 1030 j=1,18
      do 1030 i=1,m
 1030 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

      do 2001 l=1,3

      do 1031 i=1,m
      grad(i,01)=ddpcond(i,000+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,02)=ddpcond(i,003+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,03)=ddpcond(i,006+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,04)=ddpcond(i,018+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,05)=ddpcond(i,021+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,06)=ddpcond(i,024+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,07)=ddpcond(i,036+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,08)=ddpcond(i,039+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,09)=ddpcond(i,042+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,10)=ddpcond(i,054+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,11)=ddpcond(i,057+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,12)=ddpcond(i,060+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,13)=ddpcond(i,072+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,14)=ddpcond(i,075+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,15)=ddpcond(i,078+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,16)=ddpcond(i,090+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,17)=ddpcond(i,093+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,18)=ddpcond(i,096+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,19)=ddpcond(i,003+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,20)=ddpcond(i,009+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,21)=ddpcond(i,012+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,22)=ddpcond(i,021+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,23)=ddpcond(i,027+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,24)=ddpcond(i,030+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,25)=ddpcond(i,039+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,26)=ddpcond(i,045+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,27)=ddpcond(i,048+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,28)=ddpcond(i,057+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,29)=ddpcond(i,063+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,30)=ddpcond(i,066+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,31)=ddpcond(i,075+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,32)=ddpcond(i,081+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,33)=ddpcond(i,084+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,34)=ddpcond(i,093+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,35)=ddpcond(i,099+l)*density(inddyy(i,17))*cdfitp(l)
      grad(i,36)=ddpcond(i,102+l)*density(inddyy(i,18))*cdfitp(l)
      grad(i,37)=ddpcond(i,006+l)*density(inddyy(i,01))*cdfitp(l)
      grad(i,38)=ddpcond(i,012+l)*density(inddyy(i,02))*cdfitp(l)
      grad(i,39)=ddpcond(i,015+l)*density(inddyy(i,03))*cdfitp(l)
      grad(i,40)=ddpcond(i,024+l)*density(inddyy(i,04))*cdfitp(l)
      grad(i,41)=ddpcond(i,030+l)*density(inddyy(i,05))*cdfitp(l)
      grad(i,42)=ddpcond(i,033+l)*density(inddyy(i,06))*cdfitp(l)
      grad(i,43)=ddpcond(i,042+l)*density(inddyy(i,07))*cdfitp(l)
      grad(i,44)=ddpcond(i,048+l)*density(inddyy(i,08))*cdfitp(l)
      grad(i,45)=ddpcond(i,051+l)*density(inddyy(i,09))*cdfitp(l)
      grad(i,46)=ddpcond(i,060+l)*density(inddyy(i,10))*cdfitp(l)
      grad(i,47)=ddpcond(i,066+l)*density(inddyy(i,11))*cdfitp(l)
      grad(i,48)=ddpcond(i,069+l)*density(inddyy(i,12))*cdfitp(l)
      grad(i,49)=ddpcond(i,078+l)*density(inddyy(i,13))*cdfitp(l)
      grad(i,50)=ddpcond(i,084+l)*density(inddyy(i,14))*cdfitp(l)
      grad(i,51)=ddpcond(i,087+l)*density(inddyy(i,15))*cdfitp(l)
      grad(i,52)=ddpcond(i,096+l)*density(inddyy(i,16))*cdfitp(l)
      grad(i,53)=ddpcond(i,102+l)*density(inddyy(i,17))*cdfitp(l)
 1031 grad(i,54)=ddpcond(i,105+l)*density(inddyy(i,18))*cdfitp(l)

      do 1032 k=1,3
      do 1032 j=1,18
      do 1032 i=1,m
 1032 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1033 k=1,3
      do 1033 j=1,18
      do 1033 i=1,m
 1033 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

 2001 continue

      do 2002 l=1,6

      do 1034 i=1,m
      grad(i,01)=dddcond(i,000+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,02)=dddcond(i,006+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,03)=dddcond(i,012+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,04)=dddcond(i,036+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,05)=dddcond(i,042+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,06)=dddcond(i,048+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,07)=dddcond(i,072+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,08)=dddcond(i,078+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,09)=dddcond(i,084+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,10)=dddcond(i,108+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,11)=dddcond(i,114+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,12)=dddcond(i,120+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,13)=dddcond(i,144+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,14)=dddcond(i,150+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,15)=dddcond(i,156+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,16)=dddcond(i,180+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,17)=dddcond(i,186+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,18)=dddcond(i,192+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,19)=dddcond(i,006+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,20)=dddcond(i,018+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,21)=dddcond(i,024+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,22)=dddcond(i,042+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,23)=dddcond(i,054+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,24)=dddcond(i,060+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,25)=dddcond(i,078+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,26)=dddcond(i,090+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,27)=dddcond(i,096+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,28)=dddcond(i,114+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,29)=dddcond(i,126+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,30)=dddcond(i,132+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,31)=dddcond(i,150+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,32)=dddcond(i,162+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,33)=dddcond(i,168+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,34)=dddcond(i,186+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,35)=dddcond(i,198+l)*density(inddyy(i,17))*cdfitd(l)
      grad(i,36)=dddcond(i,204+l)*density(inddyy(i,18))*cdfitd(l)
      grad(i,37)=dddcond(i,012+l)*density(inddyy(i,01))*cdfitd(l)
      grad(i,38)=dddcond(i,024+l)*density(inddyy(i,02))*cdfitd(l)
      grad(i,39)=dddcond(i,030+l)*density(inddyy(i,03))*cdfitd(l)
      grad(i,40)=dddcond(i,048+l)*density(inddyy(i,04))*cdfitd(l)
      grad(i,41)=dddcond(i,060+l)*density(inddyy(i,05))*cdfitd(l)
      grad(i,42)=dddcond(i,066+l)*density(inddyy(i,06))*cdfitd(l)
      grad(i,43)=dddcond(i,084+l)*density(inddyy(i,07))*cdfitd(l)
      grad(i,44)=dddcond(i,096+l)*density(inddyy(i,08))*cdfitd(l)
      grad(i,45)=dddcond(i,102+l)*density(inddyy(i,09))*cdfitd(l)
      grad(i,46)=dddcond(i,120+l)*density(inddyy(i,10))*cdfitd(l)
      grad(i,47)=dddcond(i,132+l)*density(inddyy(i,11))*cdfitd(l)
      grad(i,48)=dddcond(i,138+l)*density(inddyy(i,12))*cdfitd(l)
      grad(i,49)=dddcond(i,156+l)*density(inddyy(i,13))*cdfitd(l)
      grad(i,50)=dddcond(i,168+l)*density(inddyy(i,14))*cdfitd(l)
      grad(i,51)=dddcond(i,174+l)*density(inddyy(i,15))*cdfitd(l)
      grad(i,52)=dddcond(i,192+l)*density(inddyy(i,16))*cdfitd(l)
      grad(i,53)=dddcond(i,204+l)*density(inddyy(i,17))*cdfitd(l)
 1034 grad(i,54)=dddcond(i,210+l)*density(inddyy(i,18))*cdfitd(l)

      do 1035 k=1,3
      do 1035 j=1,18
      do 1035 i=1,m
 1035 gradient(k,nc)=gradient(k,nc)-grad(i,18*(k-1)+j)

      do 1036 k=1,3
      do 1036 j=1,18
      do 1036 i=1,m
 1036 gradient(k,icentr(i,2))=gradient(k,icentr(i,2))+grad(i,18*(k-1)+j)

 2002 continue

      return
      end
