      subroutine mesppp(m,n,iminj,icontr,inddyy,esp,ccx,ccy,ccz,g,
     &                  density,zeta,axbx,ayby,azbz,px,py,pz,pxax,pyay,
     &                  pzaz,base,ss0,ss1,ss2,ps0,ps1,pscond,ds0,dscond,
     &                  ppcond,c,pxcx,pycy,pzcz,u,twozeta)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),axbx(*),ayby(*),azbz(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),base(*),ss0(*),
     &          ss1(*),ss2(*),ps0(n,*),ps1(n,*),pscond(m,*),ds0(n,*),
     &          dscond(m,*),ppcond(m,*),c(*),pxcx(*),pycy(*),pzcz(*),
     &          u(*),twozeta(*)

      data zero,two,three,pi/0.0,2.0,3.0,3.1415926535898/

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)

      twopi=two*pi

      do 1002 i=1,n
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(3,u(i),g)
      ss0(i)=base(i)*g(1)*twopi/zeta(i)
      ss1(i)=base(i)*g(2)*twopi/zeta(i)
 1003 ss2(i)=base(i)*g(3)*twopi/zeta(i)

      do 1004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

 1004 continue

      do 1005 i=1,n
 1005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1007 j=1,3
      do 1007 i=1,m
 1007 pscond(i,j)=zero

      do 1008 j=1,3
      do 1008 i=1,n
 1008 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)

      do 1009 j=1,6
      do 1009 i=1,m
 1009 dscond(i,j)=zero

      do 1010 j=1,6
      do 1010 i=1,n
 1010 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)

      do 1011 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1011 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1012 i=1,m
      esp=esp-density(inddyy(i,1))*ppcond(i,1)
      esp=esp-density(inddyy(i,4))*ppcond(i,4)
      esp=esp-density(inddyy(i,5))*ppcond(i,5)
      esp=esp-density(inddyy(i,7))*ppcond(i,7)
      esp=esp-density(inddyy(i,8))*ppcond(i,8)
 1012 esp=esp-density(inddyy(i,9))*ppcond(i,9)

      do 1013 i=1,m
      if(iminj(i).ne.0) then
                              esp=esp-density(inddyy(i,2))*ppcond(i,2)
                              esp=esp-density(inddyy(i,3))*ppcond(i,3)
                              esp=esp-density(inddyy(i,6))*ppcond(i,6)
                        endif
 1013 continue

      return
      end
