      subroutine numxc(npoints,natoms,ncntrt,nconts,ncontp,ncontd,
     &                 ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,natomtype,
     &                 nptsatom,cent,alpha,coeff,fock,xpoints,ypoints,
     &                 zpoints,weights,xcnrgy,xcenergy,qf,qftrans,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension natomtype(*),nptsatom(*)

      dimension cent(3,*),alpha(*),coeff(*),fock(*)

      dimension xpoints(*),ypoints(*),zpoints(*),weights(*),xcnrgy(*)
      dimension xcenergy(*),qf(npoints,*),qftrans(ncntrt,*),wkvec(*)

      data small/0.00000000000001/

      rewind 11
      rewind 12

      do 1001 iatom=1,natoms

      if(natomtype(iatom).eq.0) goto 1001

      call fastrd(11,xpoints,nptsatom(iatom))
      call fastrd(11,ypoints,nptsatom(iatom))
      call fastrd(11,zpoints,nptsatom(iatom))

      call fastrd(11,weights,nptsatom(iatom))

      call fastrd(12,xcnrgy,1)
      call fastrd(12,xcnrgy,1)

      call fastrd(12,xcnrgy,nptsatom(iatom))

      do 1002 istart=1,nptsatom(iatom),npoints

      do 1003 i=istart,min(istart+npoints-1,nptsatom(iatom))
 1003 xcenergy(i-istart+1)=xcnrgy(i)*weights(i)

      npts=min(istart+npoints-1,nptsatom(iatom))-istart+1

      call compg0(ncntrt,npts,npoints,nconts,ncontp,ncontd,ilfunc,
     &            icfunc,ngauss,nptrs,nptrp,nptrd,cent,alpha,coeff,
     &            xpoints(istart),ypoints(istart),zpoints(istart),qf,
     &            wkvec(00*npoints+1),wkvec(01*npoints+1),
     &            wkvec(02*npoints+1),wkvec(03*npoints+1),
     &            wkvec(04*npoints+1),wkvec(05*npoints+1),
     &            wkvec(06*npoints+1),wkvec(07*npoints+1),
     &            wkvec(08*npoints+1),wkvec(09*npoints+1),
     &            wkvec(10*npoints+1),wkvec(11*npoints+1))

      do 1004 i=1,ncntrt
      do 1004 j=1,npts
 1004 qftrans(i,j)=qf(j,i)*xcenergy(j)

      do 1005 i=1,ncntrt
      ii=i*(i-1)/2
      do 1005 j=1,npts
      if(abs(qf(j,i)).gt.small) then

                          do 1006 k=1,i
 1006                     fock(ii+k)=fock(ii+k)+qftrans(k,j)*qf(j,i)

                                endif
 1005 continue

 1002 continue
 1001 continue

      return
      end
