      subroutine scfcontrol(nfdpbcalc,nreal,ninteger,natoms,nmaxorbs,
     &                      nmaxaux,nmaxpts,nmaxesp,mesp,nmaxiterations,
     &                      nfunctional,idiis,ngridtype,irandomgrid,
     &                      ncenters,nptcharges,nequivalences,nalpha,
     &                      nbeta,nconts,ncontp,ncontd,ncds,ncdspd,nxcs,
     &                      nxcspd,natomtype,nptsatom,nshels,nshelp,
     &                      nsheld,ilfunc,icfunc,ngaussians,mtloca,
     &                      icdlfunc,icdcfunc,ixclfunc,ixccfunc,
     &                      nvecequivalences,iwkvec,epsilon,
     &                      econvergence,dmixing,elevelshift,coord,
     &                      charge,coordpc,ptcharge,core,focka,fockb,
     &                      focke,dmta,dmtb,coeffa,coeffb,orbnrga,
     &                      orbnrgb,overlapinv,alpha,coeffs,alphacd,
     &                      coefscd,coefpcd,coefdcd,alphaxc,coefsxc,
     &                      coefpxc,coefdxc,cdfitc,xcfita,xcfitb,xcfite,
     &                      xcfitesave,auxoverlap,tvector,tveca,tvecb,
     &                      tvece,wkvec)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension natomtype(*),nptsatom(*),nshels(*),nshelp(*),nsheld(*),
     &          ilfunc(*),icfunc(*),ngaussians(*),mtloca(*),icdlfunc(*),
     &          icdcfunc(*),ixclfunc(*),ixccfunc(*),
     &          nvecequivalences(natoms,*),iwkvec(*)

      dimension coord(3,*),charge(*),coordpc(3,*),ptcharge(*),core(*),
     &          focka(*),fockb(*),focke(*),dmta(*),dmtb(*),
     &          coeffa(nmaxorbs,*),coeffb(nmaxorbs,*),orbnrga(*),
     &          orbnrgb(*),overlapinv(nmaxorbs,*),alpha(*),coeffs(*),
     &          alphacd(*),coefscd(*),coefpcd(*),coefdcd(*),alphaxc(*),
     &          coefsxc(*),coefpxc(*),coefdxc(*),cdfitc(*),xcfita(*),
     &          xcfitb(*),xcfite(*),xcfitesave(*),auxoverlap(nmaxaux,*),
     &          tvector(*),tveca(*),tvecb(*),tvece(*),wkvec(*)

      if(nfdpbcalc.eq.1) then

         call delphidr(nreal,ninteger,natoms,nmaxorbs,nmaxaux,nmaxpts,
     &                 nmaxesp,mesp,nmaxiterations,ngridtype,
     &                 irandomgrid,nfunctional,ncenters,nptcharges,
     &                 nequivalences,nalpha,nbeta,nconts,ncontp,
     &                 ncontd,ncds,ncdspd,nxcs,nxcspd,natomtype,
     &                 nptsatom,nshels,nshelp,nsheld,ilfunc,icfunc,
     &                 ngaussians,mtloca,icdlfunc,icdcfunc,ixclfunc,
     &                 ixccfunc,nvecequivalences,iwkvec,epsilon,
     &                 econvergence,dmixing,elevelshift,coord,charge,
     &                 coordpc,ptcharge,core,focka,fockb,focke,dmta,
     &                 dmtb,coeffa,coeffb,orbnrga,orbnrgb,overlapinv,
     &                 alpha,coeffs,alphacd,coefscd,coefpcd,coefdcd,
     &                 alphaxc,coefsxc,coefpxc,coefdxc,cdfitc,xcfita,
     &                 xcfitb,xcfite,tvector,tveca,tvecb,tvece,
     &                 xcfitesave,auxoverlap,wkvec)

                         else

         call scfrun(nreal,ninteger,nmaxorbs,nmaxaux,nmaxpts,
     &               nfunctional,nmaxiterations,idiis,ngridtype,
     &               irandomgrid,ncenters,nptcharges,nalpha,nbeta,
     &               nconts,ncontp,ncontd,ncds,ncdspd,nxcs,nxcspd,
     &               natomtype,nptsatom,nshels,nshelp,nsheld,ilfunc,
     &               icfunc,mtloca,ngaussians,icdlfunc,icdcfunc,
     &               ixclfunc,ixccfunc,iwkvec,econvergence,dmixing,
     &               elevelshift,diiserror,coord,charge,coordpc,
     &               ptcharge,core,focka,fockb,focke,dmta,dmtb,coeffa,
     &               coeffb,orbnrga,orbnrgb,alpha,coeffs,alphacd,
     &               coefscd,coefpcd,coefdcd,alphaxc,coefsxc,coefpxc,
     &               coefdxc,cdfitc,xcfita,xcfitb,xcfite,xcfitesave,
     &               auxoverlap,tvector,tveca,tvecb,tvece,overlapinv,
     &               wkvec)

                         endif

      return
      end
