      subroutine setupgps(m,n,ncontp,nconts,nshelp,nshels,mtloca,
     &                    iprimvc,nprimvc,icentvc,icontr,inddyy,icentr,
     &                    coord,alpha,coeff,zeta,zetaa,zetab,twozetaa,
     &                    twozetab,aax,aay,aaz,eta,eta2,etarr,base,px,
     &                    py,pz,pxax,pyay,pzaz,axbx,ayby,azbz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension nshelp(*),nshels(*),mtloca(*),iprimvc(*),nprimvc(*),
     &          icentvc(*),icontr(*),inddyy(m,*),icentr(m,*)

      dimension coord(3,*),alpha(*),coeff(*),zeta(*),zetaa(*),zetab(*),
     &          twozetaa(*),twozetab(*),aax(*),aay(*),aaz(*),eta(*),
     &          eta2(*),etarr(*),base(*),px(*),py(*),pz(*),pxax(*),
     &          pyay(*),pzaz(*),axbx(*),ayby(*),azbz(*)

      data zero,two,expcut/0.0,2.0,100.0/

      icnptr=0

      n=0

      do 1001 i=1,ncontp
      do 1001 j=1,nconts

      icnptr=icnptr+1

      nconta=nshelp(i)
      ncontb=nshels(j)

      matlca=mtloca(nconta)
      matlcb=mtloca(ncontb)

      i1=matlca
      i2=(i1*(i1-1))/2
      i3=matlcb
      i4=i2+i3

      inddyy(icnptr,1)=i4
      inddyy(icnptr,2)=i4+i1
      inddyy(icnptr,3)=i4+i1+i1+1

      iprima=iprimvc(nconta)
      iprimb=iprimvc(ncontb)

      nprima=iprima+nprimvc(nconta)-1
      nprimb=iprimb+nprimvc(ncontb)-1

      icenta=icentvc(nconta)
      icentb=icentvc(ncontb)

      icentr(icnptr,1)=icenta
      icentr(icnptr,2)=icentb

      ax=coord(1,icenta)
      ay=coord(2,icenta)
      az=coord(3,icenta)

      bx=coord(1,icentb)
      by=coord(2,icentb)
      bz=coord(3,icentb)

      axbx(icnptr)=ax-bx
      ayby(icnptr)=ay-by
      azbz(icnptr)=az-bz

      caxbx=ax-bx
      cayby=ay-by
      cazbz=az-bz

      rr=caxbx*caxbx+cayby*cayby+cazbz*cazbz

      do 1001 ii=iprima,nprima
      do 1001 jj=iprimb,nprimb

      n=n+1

      icontr(n)=icnptr

      zetaa(n)=alpha(ii)
      zetab(n)=alpha(jj)

      zeta(n)=zetaa(n)+zetab(n)

      twozetaa(n)=two*zetaa(n)
      twozetab(n)=two*zetab(n)

      factor=coeff(ii)*coeff(jj)

      aax(n)=ax
      aay(n)=ay
      aaz(n)=az

      px(n)=(zetaa(n)*ax+zetab(n)*bx)/zeta(n)
      py(n)=(zetaa(n)*ay+zetab(n)*by)/zeta(n)
      pz(n)=(zetaa(n)*az+zetab(n)*bz)/zeta(n)

      pxax(n)=px(n)-ax
      pyay(n)=py(n)-ay
      pzaz(n)=pz(n)-az

      eta(n)=zetaa(n)*zetab(n)/zeta(n)

      eta2(n)=two*eta(n)

      etarr(n)=eta(n)*rr

      base(n)=zero
      if(etarr(n).lt.expcut) then
                                   base(n)=factor*exp(-etarr(n))
                             else
                                   n=n-1
                             endif

 1001 continue

      return
      end
