      subroutine solveks(niteration,idiis,maxao,ncontractions,nindpndnt,
     &                   maxoccupied,nalpha,nbeta,xim,elevelshift,
     &                   diiserror,changep,amat,bmat,fockalpha,fockbeta,
     &                   coeffalpha,coeffbeta,enrgalpha,enrgbeta,
     &                   sinverse,wkmat1,wkmat2,diis1,diis2,diis3,wkvec,
     &                   aux1,aux2,aux3)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension amat(*),bmat(*),fockalpha(*),fockbeta(*)
      dimension coeffalpha(maxao,*),coeffbeta(maxao,*)
      dimension enrgalpha(*),enrgbeta(*),sinverse(maxao,*)

      dimension wkmat1(ncontractions,*),wkmat2(ncontractions,*)
      dimension diis1(nindpndnt,*)
      dimension diis2(maxoccupied,*),diis3(maxoccupied,*)
      dimension wkvec(*),aux1(*),aux2(*),aux3(*)

      data zero/0.0/

      rewind 44

      do 1001 i=1,nindpndnt
 1001 call fastrd(44,sinverse(1,i),ncontractions)

      do 1002 i=1,ncontractions
      do 1002 j=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
 1002 wkmat2(i,j)=fockalpha(ij)

      do 1003 i=1,ncontractions
      do 1003 j=1,nindpndnt
 1003 wkmat1(i,j)=dot(ncontractions,sinverse(1,j),wkmat2(1,i))

      do 1004 i=1,nindpndnt
      do 1004 j=1,nindpndnt
 1004 wkmat2(i,j)=dot(ncontractions,sinverse(1,i),wkmat1(1,j))

      if(idiis.eq.1) call diis(1,niteration,ncontractions,nalpha,
     &                         nindpndnt-nalpha,nindpndnt,xim,diiserror,
     &                         wkmat1,wkmat2,diis1,diis2,diis3)

      call tred2(ncontractions,nindpndnt,wkmat2,wkvec,aux1,aux2,wkmat1)
      call tql2(ncontractions,nindpndnt,wkvec,aux1,wkmat1,aux2,aux3,ie)

      if(idiis.eq.1) then
                           rewind 81
                           do 1005 i=1,nindpndnt
 1005                      call fastwr(81,wkmat1(1,i),ncontractions)
                     endif

      do 1006 i=1,ncontractions
      if(i.le.nalpha) enrgalpha(i)=wkvec(i)+elevelshift
 1006 if(i.gt.nalpha) enrgalpha(i)=wkvec(i)-elevelshift

      do 1007 j=1,nindpndnt
      do 1008 i=1,ncontractions
 1008 coeffalpha(i,j)=zero
      do 1007 k=1,nindpndnt
      do 1007 i=1,ncontractions
 1007 coeffalpha(i,j)=coeffalpha(i,j)+sinverse(i,k)*wkmat1(k,j)

      do 1009 i=1,ncontractions*(ncontractions+1)/2
 1009 wkvec(i)=amat(i)

      do 1010 i=1,ncontractions*(ncontractions+1)/2
 1010 amat(i)=zero

      do 1011 i=1,ncontractions
      do 1011 j=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
      do 1011 k=1,nalpha
 1011 amat(ij)=amat(ij)+coeffalpha(i,k)*coeffalpha(j,k)

      changep=zero

      do 1012 i=1,ncontractions*(ncontractions+1)/2
 1012 if(abs(amat(i)-wkvec(i)).gt.changep) changep=abs(amat(i)-wkvec(i))

      if(nalpha.eq.nbeta) then

                          do 1013 i=1,nindpndnt
                          enrgbeta(i)=enrgalpha(i)
                          do 1013 j=1,ncontractions
 1013                     coeffbeta(j,i)=coeffalpha(j,i)

                          do 1014 i=1,ncontractions*(ncontractions+1)/2
 1014                     bmat(i)=amat(i)

                          return

                          endif

      if(nbeta.eq.0) return

      ij=0

      do 1015 i=1,ncontractions
      do 1015 j=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
 1015 wkmat2(i,j)=fockbeta(ij)

      do 1016 i=1,ncontractions
      do 1016 j=1,nindpndnt
 1016 wkmat1(i,j)=dot(ncontractions,sinverse(1,j),wkmat2(1,i))

      do 1017 i=1,nindpndnt
      do 1017 j=1,nindpndnt
 1017 wkmat2(i,j)=dot(ncontractions,sinverse(1,i),wkmat1(1,j))

      if(idiis.eq.1) call diis(2,niteration,ncontractions,nbeta,
     &                         nindpndnt-nbeta,nindpndnt,xim,diiserror,
     &                         wkmat1,wkmat2,diis1,diis2,diis3)

      call tred2(ncontractions,nindpndnt,wkmat2,wkvec,aux1,aux2,wkmat1)
      call tql2(ncontractions,nindpndnt,wkvec,aux1,wkmat1,aux2,aux3,ie)

      if(idiis.eq.1) then
                           rewind 82
                           do 1018 i=1,nindpndnt
 1018                      call fastwr(82,wkmat1(1,i),ncontractions)
                     endif

      do 1019 i=1,ncontractions
      if(i.le.nbeta) enrgbeta(i)=wkvec(i)+elevelshift
 1019 if(i.gt.nbeta) enrgbeta(i)=wkvec(i)-elevelshift

      do 1020 j=1,nindpndnt
      do 1021 i=1,ncontractions
 1021 coeffbeta(i,j)=zero
      do 1020 k=1,nindpndnt
      do 1020 i=1,ncontractions
 1020 coeffbeta(i,j)=coeffbeta(i,j)+sinverse(i,k)*wkmat1(k,j)

      do 1022 i=1,ncontractions*(ncontractions+1)/2
 1022 wkvec(i)=bmat(i)

      do 1023 i=1,ncontractions*(ncontractions+1)/2
 1023 bmat(i)=zero

      do 1024 i=1,ncontractions
      do 1024 j=1,ncontractions
      ij=((max(i,j)*(max(i,j)-1))/2)+min(i,j)
      do 1024 k=1,nbeta
 1024 bmat(ij)=bmat(ij)+coeffbeta(i,k)*coeffbeta(j,k)

      do 1025 i=1,ncontractions*(ncontractions+1)/2
 1025 if(abs(bmat(i)-wkvec(i)).gt.changep) changep=abs(bmat(i)-wkvec(i))

      return
      end
