      subroutine xcgrad(nd,npts,ncntrt,nconts,ncontp,ncontd,ncentr,
     &                  ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,nptsatom,
     &                  natnumber,nfuncatom,alpha,coeff,dmta,dmtb,cent,
     &                  grad,x,y,z,weight,xcalph,xcbeta,qf,qx,qy,qz,qqx,
     &                  qqy,qqz,dmtsqa,dmtsqb,wv)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)
      dimension nptsatom(*),natnumber(*),nfuncatom(*)

      dimension alpha(*),coeff(*),dmta(*),dmtb(*),cent(3,*),grad(3,*)

      dimension x(*),y(*),z(*),weight(*),xcalph(*),xcbeta(*)
      dimension qf(npts,*),qx(npts,*),qy(npts,*),qz(npts,*)
      dimension qqx(ncntrt,*),qqy(ncntrt,*),qqz(ncntrt,*)
      dimension dmtsqa(ncntrt,*),dmtsqb(ncntrt,*),wv(*)

      rewind 11
      rewind 12

      ij=0
      do 1001 i=1,ncntrt
      do 1001 j=1,i
      ij=ij+1
      dmtsqa(j,i)=dmta(ij)
      dmtsqa(i,j)=dmta(ij)
      dmtsqb(j,i)=dmtb(ij)
 1001 dmtsqb(i,j)=dmtb(ij)

      do 1002 i=1,ncntrt
      dmtsqa(i,i)=dmtsqa(i,i)+dmtsqa(i,i)
 1002 dmtsqb(i,i)=dmtsqb(i,i)+dmtsqb(i,i)

      do 1003 iatom=1,ncentr

      if(natnumber(iatom).eq.0) goto 1003

      call fastrd(11,x,nptsatom(iatom))
      call fastrd(11,y,nptsatom(iatom))
      call fastrd(11,z,nptsatom(iatom))
      call fastrd(11,weight,nptsatom(iatom))
      call fastrd(12,xcalph,nptsatom(iatom))
      call fastrd(12,xcbeta,nptsatom(iatom))
      call fastrd(12,adummy,1)

      do 1004 i=1,nptsatom(iatom)
      xcalph(i)=xcalph(i)*weight(i)
 1004 xcbeta(i)=xcbeta(i)*weight(i)

      do 1005 i=1,nptsatom(iatom),npts

      nptsbatch=min(npts,nptsatom(iatom)-i+1)

      call compg1(ncntrt,nptsbatch,npts,nconts,ncontp,ncontd,ilfunc,
     &            icfunc,ngauss,nptrs,nptrp,nptrd,cent,alpha,coeff,
     &            x(i),y(i),z(i),qf,qx,qy,qz,wv(nd*01),wv(nd*02),
     &            wv(nd*03),wv(nd*04),wv(nd*05),wv(nd*06),wv(nd*07),
     &            wv(nd*08),wv(nd*09),wv(nd*10),wv(nd*11),wv(nd*12),
     &            wv(nd*13),wv(nd*14),wv(nd*15),wv(nd*16),wv(nd*17),
     &            wv(nd*18),wv(nd*19),wv(nd*20),wv(nd*21),wv(nd*22),
     &            wv(nd*23),wv(nd*24),wv(nd*25))

      do 1006 j=1,nptsbatch
      do 1006 k=1,ncntrt
      qqx(k,j)=qx(j,k)
      qqy(k,j)=qy(j,k)
 1006 qqz(k,j)=qz(j,k)

      call xcaddgrad(ncntrt,npts,nptsbatch,nfuncatom,xcalph(i),
     &               xcbeta(i),qf,qx,qy,qz,qqx,qqy,qqz,dmtsqa,dmtsqb,
     &               grad,wv(nd*01),wv(nd*02),wv(nd*03))

 1005 continue

 1003 continue

      return
      end
